1997-09-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Version 20.2 released.

	* s/sol2-5.h (SYSTEM_MALLOC): Defined.

1997-09-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Version 20.1 released.

	* keyboard.c (command_loop_1): Add nonascii_insert_offset
	before calling direct_output_for_insert.

1997-09-15  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* indent.c (compute_motion): Ignore the display table entry for a
	base leading code when dealing with multibyte characters.

1997-09-14  Kenichi Handa  <handa@etl.go.jp>

	* fileio.c (Finsert_file_contents): If a coding system is
	specified explicitly on visiting a new file, set
	buffer-file-coding system of the new buffer to the specified one.

1997-09-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (syms_of_minibuf): Doc fix.

1997-09-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c: When redisplaying the echo area, use the value
	of enable-multibyte-characters from when message was called.
	(message_enable_multibyte): New variable.
	(message2_nolog): Set the variable.
	(echo_area_display): Use that variable.
	(display_string): New arg MULTIBYTE.  Callers changed.

	* print.c (Fexternal_debugging_output): On Windows, output to debugger.

1997-09-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* msdos.c: Use raw-text as coding system.

1997-09-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (syms_of_msdos): Intern background-color and
	foreground-color, and staticpro them.
	(IT_set_frame_parameters): Use Qforeground_color and
	Qbackground_color.

1997-09-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (display_menu_bar): Include WINDOW_LEFT_MARGIN in maxendcol.

	* process.c (create_process): Encode the new current dir.

	* callproc.c (Fcall_process): Encode the new current dir.

1997-09-09  Paul Eggert  <eggert@twinsun.com>

	* s/sco5.h (BROKEN_MKTIME): Define.

1997-09-09  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* xfns.c (x_screen_planes): Fix type of argument.

	* syntax.h (UPDATE_SYNTAX_TABLE_FORWARD): Add missing fourth
	argument of update_syntax_table.
	(UPDATE_SYNTAX_TABLE_BACKWARD): Likewise.
	(UPDATE_SYNTAX_TABLE): Likewise.

	* coding.c (encode_designation_at_bol): Fix type of local vars C1, C2.

1997-09-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (ENCODE_FILE): New macro.
	(Vfile_name_coding_system): New variable.
	(syms_of_fileio): Set up Lisp variable.
	(Fset_visited_file_modtime): Use ENCODE_FILE.
	(Fcopy_file, Fmake_directory_internal, Fdelete_directory, Fdelete_file)
	(Frename_file, Fadd_name_to_file, Ffile_exists_p Ffile_executable_p)
	(Ffile_readable_p, Ffile_writable_p, Faccess_file, Ffile_symlink_p)
	(Ffile_directory_p, Ffile_accessible_directory_p, Ffile_regular_p)
	(Ffile_modes, Fset_file_modes, Ffile_newer_than_file_p, Fwrite_region)
	(Finsert_file_contents, Fverify_visited_file_modtime): Likewise.

	* fileio.c (Ffile_symlink_p): Decode the file name value.

	* dired.c (ENCODE_FILE): New macro.
	(Ffile_attributes): Encode the file names to operate on.
	(file_name_completion): Do completion on encoded name, then decode.
	(Fdirectory_files): Encode the argument.
	Decode all result file names using Vfile_name_coding_system.

	* coding.c (Fencode_coding_string, Fdecode_coding_string): Doc fixes.
	
1997-09-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (Feval_buffer): New arg FILENAME.

	* buffer.c (modify_overlay): Update overlay_modiff of proper buffer.

1997-09-07  Geoff Voelker  <voelker@cs.washington.edu>

	* firstfile.c: New file.
	
1997-09-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (display_string): Determine multibyte from current buffer,
	not from W's buffer.

1997-09-07  Kenneth Stailey  <kstailey@elbereth.disclosure.com>

	* s/openbsd.h: New file.

	* m/ns32000.h, m/sparc.h, m/alpha.h, m/pmax.h, unexalpha.c:
	Test __OpenBSD__ along with __NetBSD__.

	* unexelf.c: Test __OpenBSD__ along with __NetBSD__.
	[__OpenBSD__]: Include sys/exec_elf.h.
	
1997-09-05  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* coding.c (Ffind_operation_coding_system): If a function in
	XXX-coding-system-alist returns a coding system (instead of cons
	of coding systems), return cons of it.

1997-09-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* coding.c (Fread_coding_system):
	New optional arg DEFAULT_CODING_SYSTEM.
	* lisp.h (Fread_coding_system): Update decl.

	* callint.c (Fcall_interactively): Pass new arg to Fread_coding_system.
	
1997-09-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* m/alpha.h (PTY_OPEN): Call sigblock properly.

	* fileio.c (Fexpand_file_name): If default dir isn't string, use `/'.

	* callproc.c (Fcall_process_region): Fix previous change:
	never override Vcoding_system_for_write.

	* m/alpha.h (PTY_OPEN): Save and restore the SIGCHLD handler.

1997-09-04  Erik Naggum  <erik@naggum.no>

	* emacs.c (main): Update Copyright message.

1997-09-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* data.c (Faset): Simplify a statement in the char-table case.
	This is to help some compilers.

	* coding.c (Qcoding_system_history): New variable.
	(syms_of_coding): Initialize it.
	(Fread_coding_system): Use Qcoding_system_history.

	* coding.c (setup_coding_system, Ffind_operation_coding_system)
	(Fdetect_coding_region, Fread_coding_system):
	Don't initialize a Lisp_Object.

1997-09-03  NIIBE Yutaka  <gniibe@mri.co.jp>

	* emacs.c (main): Call run_time_remap earlier, before any use of stdio.

1997-09-03  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* minibuf.c (read_minibuf): Fix use of Ffboundp.

1997-09-03  Geoff Voelker  <voelker@cs.washington.edu>

	* lastfile.c (my_endbss) [WINDOWSNT]: New variable.

1997-09-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* coding.c (detect_coding_mask): Re-work previous change.
	(detect_eol): Fix use of == instead of -.

1997-09-03  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (detect_coding_mask): Cancel previous change.  Always
	include CODING_CATEGORY_MASK_RAW_TEXT in the return value.

1997-09-02  Andrew Innes  <andrewi@harlequin.co.uk>

	* makefile.nt (TLIB0, TOBJ, OBJ0): New macro.
	(LINK_FLAGS): Separate debugging info from the executable.
	(LIBS): Include TLIB0.
	(TEMACS): Link with TLIB0.
	(EMACS): Copy temacs map file to emacs map file.
	Update file dependencies.

	* unexw32.c: Include config.h and time.h.
	Declare extern data and functions.
 	(file_data): Move definition from w32heap.c.
	(_start): Add debug hook for when profiling.
	Spoof executable name when using profilers.
	Invoke sbrk immediately when undumped.
	(unexec): Print error messages when input and output dump files
	cannot be opened.
	Reset header checksum.
	(open_input_file, open_output_file): Return status instead of aborting.
	(get_section_size): Handle different linkers.
	(find_section, rva_to_section): New functions.
	(get_section_info) [SEPARATE_BSS_SECTION]: Make code for using
	a separate .bss section conditional.
	Use my_begbss and my_endbss to determine .bss size by default.
	Look for Emacs data in EMDATA section.
	
	* w32.c: Include stddef.h.
	(getwd): Delete macro.
	(startup_dir): New variable.
	(getwd): Return directory in which Emacs started.
	(init_user_info): Set SHELL environment variable if not set.
	(parse_root, get_long_basename, w32_get_long_filename): New functions.
	(init_environment): Look for CMDPROXY.
	Make sure that PATH and COMSPEC are capitalized in the environment.
	Record startup directory.
	(get_emacs_configuration, sys_rename): Use OS_WIN95.
	(map_w32_filename): Calculate returned string correctly.

	(sys_fopen): Use _fdopen.
	(sys_link): Support NTFS links.
	(sys_rename): Use a long file name for temporary name.
	(sys_pipe): Make pipes binary and non-inheritable.
	(sys_read, sys_write): Spoof text mode translation for pipes 
	and sockets.
	
	(hashval): Simplify.
	(generate_inode_val): Use long file name version of file.

	(stat): Optimize by using active readdir info.
	Set fake_inode to 0 for directories.
	Set fake_inode to xor of file indexes for files.
	Don't use generate_inode_val to set inode value.

	(volume_info_data): Renamed from volume_info.
	(volume_info, fixed_drives, volume_cache): New variables.
	(DRIVE_INDEX, VOLINFO_STILL_VALID): New macros.
	(lookup_volume_info, add_volume_info, GetCachedVolumeInformation):
	New functions.
	(get_volume_info): Use volume_info_data.
	Use GetCachedVolumeInformation.	

	(init_ntproc): No longer restrict to one DOS subprocess.
	Use CRT _open and _fdopen.
	Cache fixed drive information.
	
	* w32.h: Remove debugging macros.
	(child_process): Remove is_dos_process field, add hwnd handle field.
	(FILE_LAST_CR): New macro.
	(w32_get_long_filename): Declare extern.

	* w32console.c: (DebPrint, reset_kbd, unset_kbd, take_console): 
	Delete functions.
	(keyboard_init_hook): Delete variable.
	(prev_console_cursor) [! USE_SEPARATE_SCREEN]: New variable.
	(reset_terminal_modes) [! USE_SEPARATE_SCREEN]: Reset cursor info.
	(initialize_w32_display) [USE_SEPARATE_SCREEN]: Create separate
	screen buffer.
	(ctrl_c_handler): Only ignore interrupts when interactive.
	(set_terminal_modes): Set input mode.
	(initialize_w32_display): Record original settings.
	Don't reset cursor or clear frame.

	* w32fns.c: Include limits.h and errno.h.
	Declare externs from other files.
	(w32_in_use): New variable.	
	(check_w32, have_menus_p, x_set_title, w32_msg_worker,
	find_deferred_msg, send_deferred_msg, complete_deferred_msg,
	Fw32_focus_frame, W32-send-sys-command): New functions.
	(last_mouse_movement_time): Delete variable.

	(x_frame_parms): Alphabetize.  Add title parm.
	(x_set_icon_name): Use title if set.
	(x_set_menu_bar_lines): Ensure client area remains the same.
	(x_set_name): Don't update if the name is the same.
	Use title for name if available.
	(x_icon): Initial support for creating window iconified.
	(x_display_info_for_name): Set w32_in_use.
	(Fx_open_connection): Validate Vwindow_system.  Set w32_in_use.
	
	(w32_create_window): Set window size to frame dimensions.
	Set font width, line height, border, scrollbar indexes.
	Don't set X and Y units indexes.
	(w32_msg_pump): Renamed from windows_msg_worker.
	Make static.  Don't post done message. No longer handle
	create scrollbar message.  Don't abort on anomalous messages.
	Return when completion detected.
	(w32_wnd_proc): Keep track of button state.	
	For WINDOWPOSCHANGING, force window dimensions to be multiples
	of character dimensions.
	Handle CREATESCROLLBAR.
	Use correct arguments for SHOWWINDOW.
	For SETWINDOWPOS, use WINDOWPOS structure.

	(my_create_window): Abort if message post fails.
	(Fx_create_frame): Use title instead of name.
	GC protect frame before make_frame_without_minibuffer.
	Set icon name.
	Use courier new as default font (has bold and italic).
	Set BufferPredicate and Title default parameters.
	
	(x_to_w32_weight): Support semibold weight.
	(x_to_w32_charset): Map # to numeric charset identifier.
	(w32_to_x_charset): Encode unknown charsets as a number.
	(enum_font_cb2): Don't restrict to ANSI and OEM charsets.

	(Fx_color_values): Set high and low words of color values.

	(syms_of_w32fns): Zero w32_in_use.  defsubr new functions.

	* w32heap.c (os_subtype): New variable.
	(cache_system_info): Set os_subtype.
	(recreate_heap): Update system information after loading heap.

	* w32heap.h: Enumerate operating system types.
	Declare extern data and functions.
	Move file_data struct definition here.
	(OFFSET_TO_RVA, RVA_TO_OFFSET, RVA_TO_PTR): New macros.

	* w32inevt.c: Declare externs from other files.
	(w32_kbd_mods_to_emacs): New parameter KEY.
	Use w32-capslock-is-shiftlock for old behavior.
	(key_event): Pass in new parameter to w32_kbd_mods_to_emacs.	
	
	* w32menu.c (init_menu_items): Disable code.
	(x_activate_menubar): New function.
	(initialize_frame_menubar): Pass in new param to set_frame_menubar.
	
	* w32proc.c: Include w32heap.h.
	(Vw32_start_process_share_console, Vw32_generate_fake_inodes,
	Vw32_get_true_file_attributes, Qhigh, Qlow, process_dir): 
	New variables.
	(find_child_console, set_process_dir, Fw32_short_file_name,
	Fw32_long_file_name, Fw32_set_process_priority, Fw32_get_locale_info,
	Fw32_get_current_locale_id, Fw32_get_default_local_id, 
	Fw32_set_current_locale): New functions.
	(CORRECT_DIR_SEPS): New macro.
	(create_child): Create a new console if subprocs don't share parent's.
	(reap_subprocess): Don't check for dos subprocesses.  
	Add debug support.
	(sys_wait): Ignore socket child_procs.
	Check for quit while waiting.
	(w32_executable_type): Renamed from w32_is_dos_binary.
	Check for dos and Cygnus executables.
	(sys_spawnve): Always use cmdproxy if spawning a dos app.
	Use quotes to quote arguments for Cygnus apps, backslashes otherwise.
	Handle escape characters.  Escape quotes at start and end, too.
	(sys_select): Treat null timeout as infinite.
	Add handles of child processes.
	Loop over handles round robin to ensure fairness.
	(sys_kill): Send ctrl-break and ctrl-c keystrokes to subprocesses
	on SIGINT if not sharing consoles, otherwise generate ctrl-break event.
	On other termination signals, send WM_QUIT message to Win95 apps
	and WM_CLOSE to NT apps.
	(syms_of_ntproc): Intern new symbols.  defsubr new functions.
	DEFVAR new variables.

	* w32term.c (SIF_*): Win95 macros defined for NT.
	(struct tagSCROLLINFO): Win95 struct defined for NT.
	(vertical_scroll_bar_min_handle, vertical_scroll_bar_top_border,
 	vertical_scroll_bar_bottom_border, last_scroll_bar_drag_pos,
 	Vw32_gab_focus_on_raise, Vw32_capslock_is_shiftlock): New
 	variables.
	(w32_frame_up_to_date): Block input.
	(do_line_dance): Use DC while erasing, release at end.
	(show_mouse_face): Use column and endcolumn calculated at start of
 	loop.
	(my_create_scrollbar, my_show_window, my_set_window_pos,
 	my_set_focus) [! ATTACH_THREADS]: Send message to window instead
 	of invoking Windows procedure.
	(x_scroll_bar_create, x_scroll_bar_move, x_scroll_bar_handle_click,
	x_scroll_bar_report_motion): Use SCROLLINFO for proportional handle.
	(x_scroll_bar_set_handle): Create proportional sized scroll handle.
	(w32_set_vertical_scroll_bar): Size handle according to how much
	is showing in window.
	(x_scroll_bar_set_report_motion): Use top_range, calculated above.
	(x_scroll_bar_clear): Hide scroll bar until ready to repaint.
	(show_scroll_bars): Pass in frame to my_show_window.

	(w32_read_socket): Distinguish between invisible and obscured frames
	when handling PAINT messages.
	Fixup off-by-one calculation for PAINT and SIZE.
	Pass in new parameter to w32_kbd_mods_to_emacs.
 	Handle WM_DISPLAYCHANGE, WINDOWPOSCHANGED, ACTIVATE, SHOWWINDOW,
 	INITMENU, and ACTIVATEAPP messages.
	Explicitly check for visibile and obscured frames, and to see if 
	any event should cause a redisplay.

	(x_display_bar_cursor): Don't check whether frame is updating here.
	(x_display_cursor): Check it here instead.
	(x_set_offset) [HAVE_NTGUI]: Don't add border widths.
	Set NOACTIVATE when setting window position.
	(x_set_window_size): Fixup off-by-one calculation when setting
	window position.  Mark frame garbaged earlier.  Clear mouse
	highlighting state.
	(x_focus_on_frame): Set focus by making frame the foreground window.
	(x_raise_frame): Support frames to be raised without grabbing focus.
	(x_lower_frame): Set NOACTIVATE flag when setting window position.
	(x_make_frame_visible, x_make_frame_invisible): Pass in frame 
	to my_show_window.
	(x_iconify_frame): Send a MINIMIZE message to the window.	
	(x_wm_set_size_hint): Set font width, line height, border,
	and scroll bar indexes instead of X and Y unit indexes.

	(w32_initialize): Set input mode.  Use w32_msg_worker instead
	of windows_msg_worker.  Dynamically link proportional scroll bar
	functions and intialize proportional scroll bar variables.
	(syms_of_w32term): DEFVAR new variables.

	* w32term.h (w32_output): New fields menubar_widget, menubar_active,
	and pending_menu_activation.
	(VERTICAL_SCROLL_BAR_*): Use proportional scroll bar variables.	
	(W32WindowPos): Delete definition.
	(WM_EMACS_SETFOCUS, WND_*_INDEX): New macros.
	(deferred_msg): New structure.

	* w32xfns.c (have_menus_p): Move to w32fns.c.

	* s/ms-w32.h (INTERRUPT_INPUT): Don't define.
	(bcopy): Use memmove instead of memcpy.
	(GAP_USE_BCOPY, BCOPY_UPWARD_SAFE, BCOPY_DOWNWARD_SAFE): Define.
	Undef system calls before redefining.  Emulated calls redefined
	to sys_*, real calls redefined to _*.
	(DebPrint): Macro defined.
	
1997-09-02  Michael Welsh Duggan  <md5i@schenley.com>

        * w32term.h (WM_MOUSEWHEEL): Define if not already defined.
        Necessary for pre VC5.0 distribution.
 	(WM_EMACS_TRACKPOPUPMENU): New Macro.

        * w32term.c (construct_mouse_wheel): New function.  Constructs an
        input event from a WM_MOUSEWHEEL message.
        (w32_read_socket): Handle WM_MOUSEWHEEL.

        * w32fns.c (win32_wnd_proc): Capture and handle WM_MOUSEWHEEL events.
	Capture and handle WM_EMACS_TRACKPOPUPMENU events.
	Allow a dragged selection from a popup menu started up 
	by a mouse down event.
	(x_to_win32_color): Support for X Windows RGB string specifications.
 
  	* w32menu.c (get_frame_menubar_event): Check for the possibility
 	of a menu-bar button.  A menu-bar button is a caption on the menu
 	bar with no submenu.
 	(set_frame_menubar): Correctly handle menu-bar buttons.
 	(add_menu_item): Equiv parameter send and paid attention to.
 	(keymap_panes, list_of_panes): Use CreatePopupMenu.
 	(single_keymap_panes): Use CreatePopupMenu.  Send key descriptions
 	to add_menu_item.
 	(list_of_items): Use CreatePopupMenu.  Send nil description to
 	add_menu_item.
 	(get_menu_event): Send keymap instead of menu to get_keymap_event.
 	(Fx_popup_menu): Extra parameter to mouse_position_hook.  Don't
 	send address of menu to win32menu_show.
 	(win32menu_show): Send message to call popup menu rather than
 	trying directly.  get_menu_event should take an address.
	Call eat_mouse_events in order to get rid of any extraneous 
	mouse events.
 	(list_of_panes): Only bring up one pane if the length of the list
 	of panes is one.
 
1997-09-02  Nico Francois  <nico.francois@scala.nl>
  
  	* w32menu.c (single_keymap_panes): Fixed problem with 'descrip'
 	lisp object not being protected properly (GCPRO).
  	(get_single_keymap_event): Fixed problem with 'descrip' lisp
 	object not being protected properly (GCPRO).
	(name_is_separator): New function.
	(list_of_panes): If a pane's name is empty ("") items are now
 	placed in the main popup instead of a blank-named submenu.  This
 	seems to be an undocumented feature of x-popup-menu.
  	(list_of_items): New argument HMENU.
 	Use 1 and 0 instead of Qt and Qnil for enable in add_menu_item

1997-09-02  Geoff Voelker  <voelker@cs.washington.edu>

	* w32.c (init_environment): Don't look for INFOPATH.

 	* w32fns.c (w32_wnd_proc): Pass on WM_DISPLAYCHANGE messages.

	* w32heap.c: Don't use data_seg pragma here.
	(_heap_init, _heap_term) [_MSC_VER >= 1000]: New functions that
	override CRT routines.

	* w32inevt.c (key_event): New parameter isdead. Set isdead if the
  	key press was done using a dead key.

	* w32term.c (w32_read_socket): Pass in new parameter to key_event.
	Let key_event determine whether key is dead.
	For MOVE, use x_real_positions to map to client coords.
	(x_set_mouse_pixel_position): Offset to use client area as origin.

	* s/ms-w32.h: Use pragmas to place Emacs initialized data in
 	EMDATA segment, and Emacs uninitialized data in EMBSS segment.

1997-09-02  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Fadd_name_to_file) [WINDOWSNT]: Remove conditional.

	* frame.h (FRAME_OBSCURED_P): New macro.
	(FRAME_SAMPLE_VISIBILITY): Distinguish between invisible and obscured.

	* keyboard.c (kbd_buffer_get_event) [WINDOWSNT]: Support
	menu_bar_activate_event.
	(set-input-mode) [DOS_NT]: Do not invoke reset and init sys modes.

	* sysdep.c (sys_subshell) [DOS_NT]: Save and restore parent's
	working directory.
	(sys_subshell) [WINDOWSNT]: Share MSDOS code. Don't take console.
	(init_sys_modes, reset_sys_modes) [WINDOWSNT]: Do it even with 
	a read_socket_hook.

	* xdisp.c (redisplay_internal): Check to see if frame is not obscured
	as well as visible.
	
1997-09-02  Michael Welsh Duggan  <md5i@schenley.com>

	* lisp.h: Declare discard_mouse_events.

	* keyboard.c (Qmouse_wheel) [WINDOWSNT]: New variable.
	(discard_mouse_events): New function.
	(mouse_wheel_syms) [WINDOWSNT]: New variable.
	(lispy_mouse_wheel_names) [WINDOWSNT]: New variable.
	(make_lispy_event) [WINDOWSNT]: Make mouse-wheel events.
	(syms_of_keyboard) [WINDOWSNT]: Define Qmouse_wheel and
	mouse_wheel_syms.

	* termhooks.h (event_kind) [WINDOWSNT]: New event type: mouse_wheel.

1997-09-02  Geoff Voelker  <voelker@cs.washington.edu>

	* fileio.c (Fexpand_file_name) [WINDOWSNT]: When stripping
	drive letter, be careful not to create a UNC filename.

1997-09-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* coding.c (detect_coding_mask): Add in CODING_CATEGORY_MASK_RAW_TEXT
	in the detect_coding_iso2022 case.

	* minibuf.c (Fread_from_minibuffer, Fread_string): Doc fixes.
	(Fread_no_blanks_input, Fcompleting_read): Doc fixes.	

	* unexnext.c: Include unistd.h instead of libc.h.

1997-09-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/hpux9.h (HAVE_RINT): Add #undef.

	* floatfns.c (emacs_rint): Define this,
	either as a function or as a macro for rint.
	(Fround, Ffround): Use emacs_rint, not rint directly.

	* window.c (syms_of_window): Doc fix.

	* fileio.c (Finsert_file_contents): Fix previous change--don't
	call Fboundp on Vset_auto_coding_function, just check non-nil.

1997-09-01  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* alloc.c (free_float, free_cons): Don't use the same field for
	chaining as for marking.
	(make_float, Fcons, gc_sweep): Corresponding changes.

1997-09-01  Kenichi Handa  <handa@etl.go.jp>

	* charset.h (LEADING_CODE_PRIVATE_22): Comment fixed.

	* process.c (read_process_output): Index for
	proc_encode_coding_system should be p->outfd (not `channel' which
	is p->infd).

	* fileio.c (Vset_auto_coding_function): Name changed from
	Vauto_file_coding_system.
	(syms_of_fileio): Adjusted for the above change.  Doc change.
	(Finsert_file_contents): The argument for Vset_auto_coding is a
	concatination of the heading 1K-byte and the tailing 3K-byte.

	* cmds.c (internal_self_insert): Only set TARGET_CLM when C2 is tab.
	When multibyte characters are disabled,
	use 1 as the width of the inserted character.

1997-08-31  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* category.c (describe_category): Handle a sub-chartable.

1997-08-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sysdep.c (init_system_name): Don't try to use getdomainname.

1997-08-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dispnew.c (change_frame_size_1): Save current buffer
	around calling Fset_window_buffer.

	* lread.c (Fload): Fix doc syntax.

	* m/intel386.h (HAVE_ALLOCA): Do define this, if SOLARIS2.

1997-08-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (Fload): If FILE arg ends in .el or .elc,
	don't insist on adding a suffix.

1997-08-28  Eli Zaretskii  <eliz@is.elta.co.il>

	* callproc.c (Fcall_process): Set EOL conversion type to LF when
	binary-process-output is non-nil.
	(Fcall_process_region): binary-process-XXXput only determines EOL
	conversion; if it is nil, convert LF <-> CRLF.  Don't bind
	coding-system-for-read, it is done in Fcall_process.

1997-08-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* alloc.c (free_marker): Call unchain_marker.

1997-08-28  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (detect_eol): Do not select no-conversion even if EOL
	format of raw-text file is inconsistent.  Just read it by
	raw-text-unix.
	(Fdetect_coding_region): Do not select no-conversion even if EOL
	format of raw-text file is inconsistent.
	
1997-08-28  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (Qno_conversion, Qundecided): New variables.
	(syms_of_coding): Initialize and staticpro them.
	(coding_category_name): Include "coding-category-raw-test".
	(setup_coding_system): Handle coding_type_raw_text.
	(detect_coding_mask): Include CODING_CATEGORY_MASK_RAW_TEXT in the
	return value instead of CODING_CATEGORY_MASK_BINARY.
	(detect_coding): Do not check the case that `mask' is 0, which
	never happens now.
	(detect_eol_type): If EOL format is inconsistent, return
	CODING_EOL_INCONSISTENT.
	(detect_eol): If EOL format of raw-text file is inconsistent,
	detect it as no-conversion.
	(decode_coding): Handle coding_type_raw_text.
	(encode_coding): Likewise.
	(Fdetect_coding_region): Ajusted for the above changes.
	(shrink_conversion_area): Handle coding_type_raw_text.

	* coding.h (coding_type): New member coding_type_raw_text.
	(CODING_EOL_INCONSISTENT): New macro.
	(CODING_REQUIRE_NO_CONVERSION): Check also coding_type_raw_text.
	(CODING_MAY_REQUIRE_NO_CONVERSION): Likewise.
	(CODING_CATEGORY_IDX_RAW_TEXT): New macro.
	(CODING_CATEGORY_MASK_RAW_TEXT): New macro.

1997-08-28  Eli Zaretskii  <eliz@psilocin.gnu.ai.mit.edu>

	* msdos.c: Add coding: tag, to prevent Emacs from interpreting
	binary strings.

1997-08-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xmenu.c (free_frame_menubar): Clear menubar_height field.

1997-08-26  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* xdisp.c (redisplay_window): When trying to scroll conservatively,
	correctly take the scroll margin into account.

	* buffer.c: Include errno.h.
	(init_buffer) [HAVE_GETCWD]: Fix error message for getcwd failure.

	* fileio.c (Finsert_file_contents): Fix use of Fboundp.

	* fns.c (concat): Fix use of Fchar_bytes.

	* lisp.h: Declare Fchar_bytes.

1997-08-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (read_minibuf): Inherit enable-multibyte-characters
	along with the input method, if requested.

1997-08-26  Eli Zaretskii  <eliz@is.elta.co.il>

	* xdisp.c (decode_mode_spec): For %Z and %z, put keyboard and
	terminal coding systems into modeline on MSDOS frames as well.

1997-08-26  Kenichi Handa  <handa@etl.go.jp>

	* minibuf.c (Qcurrent_input_method, Qactivate_input_method): New vars.
	(syms_of_minibuf): Intern and staticpro them.
	(read_minibuf): New argument INHERIT_INPUT_METHOD.  If it is
	nonzero, remember the current input method in INPUT_METHOD, and
	activate it after switching to the minibuffer.
	(Fread_from_minibuffer): New argument INHERIT_INPUT_METHOD.
	(Fread_minibuffer): Call read_minibuf with INHERIT_INPUT_METHOD nil.
	(Fread_string): New argument INHERIT_INPUT_METHOD.
	(Fread_no_blanks_input): Likewise.
	(Fread_command): Call Fcompleting_read with INHERIT_INPUT_METHOD nil.
	(Fread_function, Fread_variable, Fread_buffer): Likewise
	(Fcompleting_read): New argument INHERIT_INPUT_METHOD.

	* lisp.h (DEFUN_ARGS_8): New macro.
	(Fcompleting_read, Fread_from_minibuffer, Fread_string,
	Fread_no_blanks_input): Number of arguments fixed.

	* eval.c (Feval): Handle a subr which takes 8 arguments.
	(Ffuncall): Likewise.

	* coding.c (Fread_non_nil_coding_system): Supply the arg
	INHERIT-INPUT-METHOD to Fcompleting_read.
	(Fread_coding_system): Likewise.

	* callint.c (Finteractive): Document the code letter `M'.
	(Fcall_interactively): Call Fcompleting_read,
	Fread_from_minibuffer, and Fread_string with a proper value for
	the arg INHERIT-INPUT-METHOD.  Handle the code letter `M'.

	* fileio.c (Fwrite_region): Convert EOL format even if
	enable-multibyte-characters is nil.
	(Fread_file_name): Call Fcompleting_read with INHERIT-INPUT-METHOD
	nil.

	* keyboard.c (Fexecute_extended_command): Call Fread_from_minibuffer
	with INHERIT-INPUT-METHOD nil.

	* fns.c (Fyes_or_no_p): Likewise.

	* mocklisp.c (Fml_arg): Call Fread_string with
	INHERIT-INPUT-METHOD nil.

	* search.c (Fsearch_backward): Inherit the current input method on
	reading STRING.
	(Fsearch_forward): Likewise.

1997-08-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* frame.c (Fframe_pixel_height): Doc fix.

	* Makefile.in (emacs): Put dash at beginning.

1997-08-24  NIIBE Yutaka  <gniibe@mri.co.jp>

	* Makefile.in (xrdb.o): Depend on paths.h.

1997-08-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* config.in (KERBEROS5, HAVE_LIBKRB4, HAVE_LIBDES425, HAVE_LIBKRB5)
	(HAVE_LIBCRYPTO, HAVE_LIBCOM_ERR, HAVE_KRB5_H, HAVE_DES_H, HAVE_KRB_H)
	(HAVE_KERBEROSIV_DES_H, HAVE_KERBEROSIV_KRB_H, HAVE_KERBEROS_DES_H)
	(HAVE_KERBEROS_KRB_H, HAVE_COM_ERR_H): Add undefs.

	* callproc.c (init_callproc): Don't warn about missing
	arch-dep data directory, while preparing to dump.

	* puresize.h (BASE_PURESIZE): Increased by 10k.

1997-08-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (LIB_MOTIF_EXTRA): New variable.
	(LIBW): Use LIB_MOTIF_EXTRA.
	* config.in (HAVE_MOTIF_2_1): Add #undef.

	* fileio.c (Fmake_temp_name): Doc fix.

	* buffer.c (syms_of_buffer): Doc fixes.

1997-08-21  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* xdisp.c (redisplay_window): Don't try using last_point_x
	if point is in the left margin of an hscroll'ed window.

1997-08-21  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* fileio.c (syms_of_fileio): Fix previous change.

	* coding.c (detect_eol): If the coding system is an alias, get
	eol-type from the base of it.

1997-08-21  Kenichi HANDA  <handa@etl.go.jp>

	* fileio.c (Vauto_file_coding_system_function): New variable.
	(Finsert_file_contents): Decide coding system after opening a
	file.  Call functions set in Vauto_file_coding_system_function.
	(syms_of_fileio): Declare auto-file-coding-system-function as a
	Lisp variable.

	* fontset.c (Valternate_fontname_alist): Name changed from
	Valternative_fontname_alist.
	(syms_of_fontset): Adjusted for the above change.
	
	* fontset.h: Adjusted for the name change of
	Valternate_fontname_alist.

	* xterm.c (x_list_fonts): Adjusted for the name change of
	Valternate_fontname_alist.

1997-08-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* charset.c (Fchars_in_region): Fix gap handling.

	* editfns.c (NULL): Define, if not defined.

1997-08-19  Geoff Voelker  <voelker@cs.washington.edu>

	* fileio.c (Finsert_file_contents): Fix previous change.

1997-08-18  Ken'ichi Handa  <handa@albert.gnu.ai.mit.edu>

	* charset.c (Fchars_in_region): Renamed form Fcount_chars_region.
	(syms_of_charset): Define Schars_in_region as a Lisp subroutine
	instead of Scount_chars_region.

1997-08-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Fdo_auto_save): If open fails, make lispstream nil.

1997-08-16  Geoff Voelker  <voelker@cs.washington.edu>

	* fileio.c (Finsert_file_contents) [DOS_NT]: Set buffer_file_type
	according to eol conversion used on file.

1997-08-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (xselect.o): Fix previous change.

	* minibuf.c (read_minibuf): New arg disable_multibyte.
	(Fcompleting_read): Pass 1 for disable_multibyte if
	the completion table is read-file-name-internal.

	* xrdb.c: Include paths.h.
	(get_system_app): Use PATH_X_DEFAULTS.

	* paths.in (PATH_X_DEFAULTS): New macro.

	* term.c (term_get_fkeys_1): Use kH as alternate for move-to-last-line.

	* charset.c: Many doc fixes.
	(Fcount_chars_region): New function.
	(min, max): New macros.

	* fns.c (Flength): Doc fix.

	* editfns.c (Fchar_before): Do range check before decrement.

1997-08-16  Kenichi Handa  <handa@etl.go.jp>

	* coding.h (CODING_FLAG_ISO_LATIN_EXTRA): New macro.

	* coding.c (Vmicrosoft_code_table): This variable deleted.
	(Vlatin_extra_code_table): New variable.
	(detect_coding_iso2022): Pay attention to Vlatin_extra_code_table.
	(detect_coding_mask): Likewise.
	(setup_coding_system): Handle a new FLAGS element
	ACCEPT-LATIN-EXTRA-CODE.
	(syms_of_coding): Delete code for Vmicrosoft_code_table.
	Declare latin-extra-code-table as Lisp variable, and initialize.

1997-08-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (xselect.o): Depend on coding.h.

	* s/osf1.h (SOCKLEN_TYPE): New macro definition.

1997-08-14  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* xdisp.c (COERCE_MARKER): Use Fmarker_position instead of
	marker_position so that it works with a marker that points nowhere.
	(redisplay_window): Check that Voverlay_arrow_position is a
	marker before accessing it as such.

1997-08-14  Eli Zaretskii  <eliz@is.elta.co.il>

	* emacs.c (main): Update re_max_failures so regex.c won't overflow
	the stack, except when dumping.

1997-08-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (redisplay_window): When handling just cursor motion,
	do not subtract hscroll when accessing last_point_x.
	(display_text_line): Add WINDOW_LEFT_MARGIN into hpos
	later on, after handling hscroll and minibuffer prompt.

1997-08-13  Eli Zaretskii  <eliz@psilocin.gnu.ai.mit.edu>

	* msdos.c (syms_of_msdos): Define and bind x-bitmap-file-path and
	delete-exited-processes, to prevent cus-start.el from complaining.

1997-08-13  Kazushi (Jam) Marukawa  <maru@pdapsun2.trc.rwcp.or.jp>

	* filelock.c (lock_file): Use %lu instead of %d in sprintf because
	the variable named pid is unsigned long.

	* unexalpha.c (unexec): Cast arg to fprintf.

1997-08-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* alloc.c (free_marker): New function.

	* insdel.c (signal_before_change): Relocate START and END
	using markers for subsequent functions, when we run a function.

	* Makefile.in (emacs): Warn about shadowed standard libraries here.

1997-08-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (main): Fix previous change.

1997-08-11 +03  Eli Zaretskii  <eliz@is.elta.co.il>

	* dosfns.c (init_dosfns): Avoid calling DOS memory-allocation
	service, NT DPMI server will crash Emacs in DOS box, if we do.

	* msdos.c (IT_set_frame_parameters): Actually store the frame
	parameters in the frame parameters' alist.

	* msdos.c (init_environment): Set Emacs root directory properly when
	the executable is in its `src' subdirectory, as under a debugger.
	(IT_set_face): If termscript is in use, print the number of the
	face as well.

1997-08-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (main) [__FreeBSD__ && PROFILING]: Add code for profiling.

1997-08-10  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (Qbackground_color, Qforeground_color): Define vars.

	* dosfns.c (Finsert_startup_screen): Call `insert_char' with a
	single argument.

1997-08-10  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* coding.h (struct iso2022_spec): New member expected_charsets.
	(CODING_SPEC_ISO_EXPECTED_CHARSETS): New macro.

	* coding.c (Fset_terminal_coding_system_internal): Set
	CODING_FLAG_ISO_SAFE in terminal_coding.flags.
	(ENCODE_ISO_CHARACTER_DIMENSION1): Check
	CODING_SPEC_ISO_EXPECTED_CHARSETS.
	(ENCODE_ISO_CHARACTER_DIMENSION2): Likewise.

1997-08-10  Kenichi Handa  <handa@etl.go.jp>

	* term.c (encode_terminal_code): Use safe_terminal_coding if
	terminal_coding seems to encode Emacs' internal code as is.
	(write_glyphs): Likewise.

	* coding.c (ENCODE_ISO_CHARACTER_DIMENSION1): Pay attention to
	CODING_FLAG_ISO_SAFE.
	(ENCODE_ISO_CHARACTER_DIMENSION2): Likewise.
	(safe_terminal_coding): New variable.
	(Fset_safe_terminal_coding_system_internal): New function.
	(init_coding_once): Initilize safe_terminal_coding.
	(syms_of_coding): Declare set-safe-terminal-coding-system as a
	Lisp function.

	* coding.h (CODING_FLAG_ISO_SAFE): New macro.
	(CODING_INHIBIT_CHARACTER_SUBSTITUTION): New macro.
	coding.h (safe_terminal_coding): Extern it.

1997-08-10  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (Vmicrosoft_code_table): New variable.
	(syms_of_coding): Declare it as a Lisp variable and initialize it.
	(detect_coding_mask): Pay attention to Vmicrosoft_code_table.

	* xterm.c (dumpglyphs): Pay attention to
	Vignore_relative_composition.

	* fontset.h (Vignore_relative_composition): Extern it.

	* fontset.c (Vignore_relative_composition): New variable.
	(syms_of_fontset): Doc-string of use-default-ascent modified.
	Declare ignore-relative-composition as a Lisp variable.

	* fns.c (concat): Pay attention to multibyte characters when
	TARGET_TYPE is Lisp_String.

1997-08-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sysdep.c (init_system_name): If domain is null, don't add a period.

1997-08-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (init_buffer): Use getcwd instead of getwd, if available.

	* eval.c (do_autoload): Require a suffix for the file.

	* lread.c (read1): Handle read_escape making a multibyte character.

	* strftime.c (gmtime_r, localtime_r): Undef before defining.

	* fns.c (Frequire): Don't insist on a suffix
	if the file name argument was explicitly specified.

1997-08-07  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* Makefile.in (lisp, shortlisp): Add bindings.el and case-table.elc.

	* xdisp.c (redisplay_window): Fix access to w->last_point{,_[xy]}.

	* lisp.h (Flocal_variable_p, Ffind_operation_coding_system): Declared.
	(find_symbol_value): Fix declaration.

1997-08-07  Erik Naggum  <erik@naggum.no>

	* emacs.c (main): Remove call to init_filelock.
	* filelock.c (init_filelock): Function deleted.
	* paths.in (PATH_LOCK): Definition deleted.

1997-08-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xrdb.c (X_DEFAULT_SEARCH_PATH): Add /usr/X11R6/lib alternatives.

	* editfns.c (Fwiden, Fnarrow_to_region, save_restriction_restore): 
	Don't set clip_changed if the new values are the same as the old.

	* fileio.c (Fwrite_region): Turn off the feature of checking
	whether another buffer has locked this file.

	* xdisp.c (COERCE_MARKER): New macro.
	(redisplay_internal): Coerce Voverlay_arrow_position to a number
	to record it in last_arrow_position.
	(mark_window_display_accurate, redisplay_window): Likewise.
	(redisplay_window): Don't do the "only point has change" optimization
	if the overlay arrow is in this buffer.

1997-08-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* unexelf.c (unexec): Cast 1st arg in mmap calls.

	* sysdep.c (init_sys_modes) [mips || HAVE_TCATTR]:
	Handle flow_control by setting VSTART and VSTOP characters.

	* filelock.c (lock_file_1, lock_file): Add casts.

	* xselect.c (syms_of_xselect): Doc syntax fixes.

	* coding.c (syms_of_coding): Doc syntax fixes.

	* xdisp.c (redisplay_internal): Count only visible frames at first.

	* xdisp.c (redisplay_internal): Count all visible frames in new_count.

1997-08-05  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* coding.c (detect_eol_type): Fix previous change.

1997-08-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fontset.c (syms_of_fontset): Doc fixes.

1997-08-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* indent.c (current_column): Update ptr differently at newline
	so that current_column_bol_cache is set properly.

1997-08-04  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (detect_eol_type): If EOL representation does not
	seem consistent, use no conversion.

	* process.c (Fset_process_coding_system): Doc-string modified.
	(Fprocess_coding_system): Likewise.

	* callproc.c (Fcall_process_region): Use cdr part (not car part)
	of Vdefault_process_coding_system for writing out text.

	* coding.c (detect_coding_iso2022): Do not exclude posibility of
	7-bit encoding when designation to G1 occurs.  If CSI, SS2, or SS3
	is found, return CODING_CATEGORY_MASK_ISO_8_ELSE.
	(Fdetect_coding_region): Doc-string modified.

1997-08-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfaces.c (merge_face_list): New function.
	(compute_char_face): Use merge_face_list.
	Allow (foreground-color . COLOR) and (background-color . COLOR)
	in place of a face.

1997-08-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* m/intel386.h (HAVE_ALLOCA): Don't define this
	on USG5_4 if not using GNU C.

	* xdisp.c (redisplay_internal): Count number of visible frames
	instead of number of frames that were redisplayed.

	* m/ibmrs6000.h (LD_SWITCH_MACHINE):
	Add #ifdef emacs around all the definitions of this.

	* lisp.h (Fload): Update declaration.

1997-08-03  Kenichi HANDA  <handa@etl.go.jp>

	* coding.h (CODING_CATEGORY_MASK_BINARY): New macro.

	* coding.c (detect_coding_mask): Include
	CODING_CATEGORY_MASK_BINARY in the return value if any 8-bit code
	is found.

	* xfns.c (x_set_frame_parameters): Heading comment fixed.
	(x_default_parameter): Likewise.

	* xselect.c (Vclipboard_coding_system): New variable.
	(selection_data_to_lisp_data): Decode text by
	Vclipboard_coding_system.
	(lisp_data_to_selection_data): Encode text by
	Vclipboard_coding_system.
	(syms_of_xselect): Declare clipboard-coding-system as Lisp
	variable and initialize it.

1997-08-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* coding.c: Doc fixes.
	
	* lread.c (Fload): New optional arg MUST-SUFFIX.
	* fns.c (Frequire): Pass t for the MUST-SUFFIX arg to Fload.
	* eval.c (do_autoload): Pass new arg to Fload.

	* indent.c (compute_motion): Correct the criterion for when to
	move back 1 space when we terminate just after continuing the line.

1997-07-31  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* coding.c (encode_coding_iso2022): When source data ends not at
	character boundardy, set data in coding->carryover correctly, and
	set SRC to SRC_END.
	(encode_coding_sjis_big5): Likewise.
	(encode_coding): Don't set coding->carryover_size to 0.

	* fileio.c (Fwrite_region): Don't try to flush out a data twice.

1997-07-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (redisplay_window): Fix previous change.

	* dispnew.c (direct_output_for_insert): Set last_point_x properly.

1997-07-31  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_list_fonts): Request at least 10 fonts by XListFonts.

	* coding.c (encode_coding_iso2022): Write out invalid multibyte
	forms in a buffer as is.
	(detect_coding_mask): If ISO_CODE_CSI appears in an invalid
	sequence, ignore it.

1997-07-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (redisplay_window): Fix one-off in handling
	scroll-conservatively for scrolling up.

	* filelock.c (current_lock_owner): Don't try to delete lock
	if this or another existing process owns it!

1997-07-31  enami tsugutomo  <enami@but-b.or.jp>

	* process.c (read_process_output): Don't call setup_coding_system
	for proc_decode_coding_system[channel].  It is already done in
	detect_coding called via decode_coding.

1997-07-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* filelock.c (lock_if_free): Don't loop; for strange error, return -1.

	* s/sunos4shr.h (LIBXMU): Alternative definition if CANNOT_DUMP.

	* Makefile.in (LDFLAGS, CPPFLAGS): Get them from configure like CFLAGS.

1997-07-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): Call detect_input_pending
	whenever read_kbd is 0, not just when wait_for_cell.

	* xdisp.c (decode_mode_spec_coding): If multibyte chars disabled.
	display only the eol flag.

1997-07-29  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_list_fonts): Reject a font whose min_bounds.width is 0.
	
1997-07-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (sort_args): Check properly for `--'.

	* xdisp.c (redisplay_window): Fix previous change.

	* cm.h, sysdep.c, terminfo.c [HAVE_LIBNCURSES]:
	Declare ospeed as short, unless NCURSES_OSPEED_T.

	* xdisp.c (redisplay_window): When text has not changed,
	call compute_motion starting from the former PT if possible.
	If PT is unchanged from w->last_point, don't do compute_motion at all.

1997-07-28  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* editfns.c (Fformat_time_string): Don't hang if strftime produces
	an empty string.  Fix arguments of second call to strftime.
	Remove check for result being negative, this cannot happen.

	* xterm.c (x_new_font): Follow the change in
	x_set_scroll_bar_width and make the scroll bar at least 14 pixels
	wide.

	* xfns.c (Fx_create_frame): Initialize fontset in output_data.

1997-07-28  Dan Nicolaescu  <done@ece.arizona.edu>

	* charset.c (non_ascii_char_to_string): Fix typos.

1997-07-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* callproc.c (syms_of_callproc):
	Don't init Vtemp_file_name_pattern here.

	* lread.c (map_obarray): Don't crash if something strange
	is in the obarray.

1997-07-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_term_init) [! HAVE_X11R5]: Don't try to use
	XtCvtStringToFont.

	* print.c (strout, printchar): Handle minibuffer_auto_raise.

1997-07-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Fwrite_region): Fix previous change.

1997-07-25  NIIBE Yutaka  <gniibe@mri.co.jp>

	* indent.c (compute_motion): Handle display table correctly for
	multibyte characters.

1997-07-25  Ken'ichi Handa  <handa@psilocin.gnu.ai.mit.edu>

	* fontset.c (syms_of_fontset): Set Vhighlight_wrong_size_font to
	Qnil.

	* coding.h (CODING_REQUIRE_TEXT_CONVERSION,
	CODING_REQUIRE_EOL_CONVERSION, CODING_REQUIRE_CONVERSION): Deleted.
	(CODING_REQUIRE_NO_CONVERSION): New macro.
	(CODING_MAY_REQUIRE_NO_CONVERSION): New macro.

	* fileio.c (Finsert_file_contents): Use new macros
	CODING_MAY_REQUIRE_NO_CONVERSION and
	CODING_MAY_REQUIRE_NO_CONVERSION.
	(Fwrite_region): Correct the logic for deciding coding system.

	* process.c (read_process_output): Use new macro
	CODING_REQUIRE_NO_CONVERSION
	(send_process): Use new macro CODING_MAY_REQUIRE_NO_CONVERSION.

	* xterm.c (dumpglyphs): Check the member `encoding' of *FONTP while
	setting `byte1' and `byte2' members of *CP.

1997-07-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (${lispsource}TAGS): Specify ETAGS var in inner make.

	* print.c (Vprint_gensym_alist): Renamed from printed_gensyms.
	(Vprint_gensym): Now a Lisp_Object; Renamed from print_gensym.
	(syms_of_print): Set up both as Lisp vars.
	(PRINTPREPARE, PRINTFINISH): Don't clear Vprint_gensym_alist
	if Vprint_gensym is a cons cell.

	* Makefile.in (../src/$(OLDXMENU)): New target.

	* xselect.c (selection_data_to_lisp_data):
	Make the vector the right size, when format is 16.

	* emacs.c (main): Make --help msg end in newline.

	* xfns.c (Fx_create_frame): Don't fail to initialize `font'.

	* syntax.c (Fforward_comment): When count1 is negative,
	return nil if FROM reaches STOP.

	* editfns.c (Fcurrent_message): New function.
	(syms_of_editfns): defsubr it.

1997-07-23  Marcus G. Daniels  <marcus@cathcart.sysc.pdx.edu>

        * xterm.c (XTread_socket): Trap the BadMatch error that can occur
        after a XSetInputFocus if window is not visible.

1997-07-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (XTread_socket) <ClientMessage>: Use FRAME_X_WINDOW
	when calling XSetInputFocus.

	* buffer.c (syms_of_buffer): Doc fix.

	* eval.c (syms_of_eval): Doc fix.

1997-07-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (display_text_line): Don't count minibuf_prompt_width
	twice in taboffset.

	* coding.c (syms_of_coding): Doc fix.

1997-07-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/sol2.h (LIBS_SYSTEM): Undo previous change.
	(HAVE_LIBKSTAT): Define it.

	* minibuf.c (choose_minibuf_frame_1): New function.
	(read_minibuf): Make an unwind protect to run that.
	(read_minibuf_unwind): Don't call choose_minibuf_frame here.

	* keyboard.c (read_char): Delete spurious UNGCPRO.
	Add UNGCPRO before the longjmps to wrong_kboard_jmpbuf.
	Initialize c before the GCPRO1.
	
	* frame.c (Fdelete_frame): Undo previous change.

	* s/hpux8.h (LD_SWITCH_SYSTEM_TEMACS): Define this
	instead of LD_SWITCH_SYSTEM.
	
	* window.c (set_window_height): Allow all heights > 0
	for minibuffer windows.
	(change_window_height): Fix one-off comparing DELTA with MAXIMUM.

	* xfns.c (Fx_create_frame): Default vertical-scroll-bars
	as symbol, not boolean.

1997-07-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): Initialize total_read.
	Check for read_process_output giving back EIO.

	* keyboard.c (Fcommand_execute): gcpro c.

1997-07-20  Geoff Voelker  <voelker@cs.washington.edu>

	* w32term.c (w32_clear_end_of_line): Include scroll bar width.

1997-07-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/irix6-0.h: Undo previous change.

	* xterm.c (XTread_socket) <ClientMessage>:
	Don't use FRAME_XIC if it is null, here.

	* puresize.h (BASE_PURESIZE): Increased to 410000.

	* xdisp.c (redisplay_internal): Calculate new_count properly
	for non-window displays.

1997-07-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (Fcompleting_read): gcpro def.

	* xterm.c (XTread_socket) <ClientMessage>:
	For wm_take_focus, use x_any_window_to_frame.

	* fileio.c (Fread_file_name): If Fcompleting_read return the default
	because the buffer want empty, replace that with an empty string.

1997-07-18  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* data.c: Many doc fixes.

1997-07-17  Geoff Voelker  <voelker@cs.washington.edu>

	* coding.c (Ffind_operation_coding_system): Use Ffboundp to
	check for a function entry.

	* fileio.c (Finsert_file_contents) [DOS_NT]: Use the coding
	system to determine buffer_file_type.
	(Fwrite_region): Only use Qbuffer_file_coding_system
	before checking file-coding-system-alist if non-nil.
	(Fwrite_region) [DOS_NT]: Delete conditional code.

1997-07-17  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* dispnew.c (direct_output_forward_char): Reenable check against
	truncated text at end of line.

	* xdisp.c (display_string): Ignore W->left if OBEY_WINDOW_WIDTH is
	zero.

1997-07-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (dumpglyphs): Use 8-bit output to X, rather than 16-bit,
	if the character values permit that.

	* .gdbinit (xcar, xcdr): Print with /x.

	* fileio.c (Fdo_auto_save): Temporarily clear minibuffer_auto_raise.

1997-07-17  enami tsugutomo  <enami@but-b.or.jp>

	* xdisp.c (decode_mode_spec_coding): Fix typo; use `val' instead
	of `coding-system'.

1997-07-15  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* xdisp.c (display_text_line): Handle the case of point being in
	the invisible part of the line beyond the left margin.

1997-07-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* syntax.h (SETUP_SYNTAX_TABLE_FOR_OBJECT): Fix previous change.

1997-07-15  Kenichi HANDA  <handa@etl.go.jp>

	* coding.h (CODING_CATEGORY_IDX_ISO_7_ELSE): This macro is deleted
	(CODING_CATEGORY_IDX_ISO_7_ELSE): New macro.
	(CODING_CATEGORY_IDX_ISO_8_ELSE): New macro
	(CODING_CATEGORY_MASK_ISO_ELSE): This macro is deleted.
	(CODING_CATEGORY_MASK_ISO_7_ELSE): New macro.
	(CODING_CATEGORY_MASK_ISO_8_ELSE): New macro.
	(CODING_CATEGORY_MASK_ANY): Adjusted for the above change.

	* coding.c (detect_coding_iso2022): Distinguish
	coding-category-iso-7-else and coding-category-iso-8-else.

1997-07-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* unexalpha.c (unexec):
	Don't call update_dynamic_symbols if static link.

	* keyboard.c (read_char): Call timer_stop_idle unconditionally
	at non_reread.

	* keyboard.c (make_lispy_event): Distinguish S-SPC from SPC.

	* cmds.c (internal_self_insert): Use replace_range when
	number_to_delete is nonzero.

	* insdel.c (replace_range): New function.

	* keyboard.c (make_lispy_event): Handle non_ascii_keystroke
	in the ASCII range.

	* xterm.c (XTread_socket): Treat SPC as a function key.

1997-07-13  Marcus G. Daniels  <marcus@cathcart.sysc.pdx.edu>

	* xterm.c (x_draw_box): Use scratch_cursor_gc to draw the cursor
	box using the color specified by cursor_pixel.

1997-07-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (Fwrite_region) [DOS_NT]: Always use binary mode since
	coding conversion now takes care of NL -> CRLF.

	* callproc.c (Fcall_process) [MSDOS]: Request EOL conversion of
	the process output, unless we were promised it is binary.

	* coding.c: Substantial comment changes.

	* lread.c (init_lread): Don't add to load-path lisp subdirectories
	of the source tree if the parent of the source was moved after
	dumping Emacs.

1997-07-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* search.c (compile_pattern_1): Don't declare val with CONST.

	* cmds.c (internal_self_insert): When overwriting, insert first
	and then delete.

1997-07-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/irix4-0.h (XPointer): Define as macro.

	* emacs.c (main): Use setrlimit only if RLIMIT_STACK.

1997-07-11  Marcus G. Daniels  <marcus@cathcart.sysc.pdx.edu>

	* xdisp.c (decode_mode_spec): Initialize and use `p' (for the termcap
        case).

	* dispnew.c (init_display): Go ahead and prepare for
	a X configuration in the CANNOT_DUMP case.

1997-07-11  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* editfns.c (get_system_name): Don't crash if Vsystem_name does
	not contain a string.
	* filelock.c (lock_file_1): Don't crash if Fuser_login_name or
	Fsystem_name don't return strings.
	(current_lock_owner): Likewise.

	* ralloc.c (r_alloc_reinit): New function.
	* emacs.c (main) [DOUG_LEA_MALLOC]: Call it when restarting a
	dumped Emacs.

1997-07-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* m/news-r6.h: Renamed from news-risc6.h.

1997-07-10  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* xdisp.c (display_text_line): Exit the outer loop immediately
	when the right margin has been reached.

	* lisp.h (EXFUN, P_): New definitions.  Use them to declare
	prototypes for external functions.

	* xterm.c (dumpglyphs): Declare local variable first_ch as
	Lisp_Object, not int.
	* xselect.c (selection_data_to_lisp_data): Convert Fmake_vector
	and Faset arguments to Lisp_Integer.
	(clean_local_selection_data): Likewise.
	* x-list-font.c (Fx_list_fonts): Fix Fnconc argument.
	* window.c (Fcoordinates_in_window_p): Convert Fcons arguments to
	Lisp_Integer.
	(save_window_save): Convert Fset_marker argument to Lisp_Integer.
	* textprop.c (interval_of): Convert args_out_of_range arguments to
	Lisp_Integer.
	* syntax.c (init_syntax_once): Convert Fmake_vector argument to
	Lisp_Integer.
	* process.c (Fprocess_send_region): Convert move_gap argument to int.
	* mocklisp.c (Fml_arg): Add missing Fread_string arguments.
	* minibuf.c (Fread_from_minibuffer): Remove extra get_keymap argument.
	(Fminibuffer_complete): Convert Fset_window_start argument to
	Lisp_Integer.
	* keyboard.c (command_loop_1): Add missing message2 argument.
	(menu_bar_items): Add missing get_keyelt argument.
	(follow_key): Likewise.
	(read_key_sequence): Likewise.
	* intervals.c (set_point): Convert call2 arguments to Lisp_Integer.
	* fileio.c (Fwrite_region): Fix call2 argument.
	(Fread_file_name): Convert Fcons argument to Lisp_Integer.
	* editfns.c (Fcurrent_time_zone): Convert Fmake_list argument to
	Lisp_Integer.
	(Ftranspose_regions): Convert Fset_text_properties arguments to
	Lisp_Integer.
	* doc.c (Fsubstitute_command_keys): Add missing describe_map_tree
	argument.
	* coding.c (Ffind_coding_system): Use call1, not call2.
	* cmds.c (Fdelete_backward_char): Convert Finsert_char argument to
	Lisp_Integer and add missing argument.
	(internal_self_insert): Convert Fmove_to_column argument to
	Lisp_Integer and add missing argument.
	* ccl.c (Fregister_ccl_program): Convert Fmake_vector argument to
	Lisp_Integer.
	(syms_of_ccl): Likewise.
	* category.h (CATEGORY_DOCSTRING): Convert Fchar_table_extra_slot
	argument to Lisp_Integer.
	(CATEGORY_TABLE_VERSION): Likewise.
	* buffer.c (set_buffer_internal_1): Convert Fset_marker argument
	to Lisp_Integer.
	(set_buffer_temp): Likewise.
	(fix_overlays_in_range): Likewise.

	* xdisp.c (message2_nolog): Don't call fwrite will null string.

1997-07-10  Geoff Voelker  <voelker@cs.washington.edu>

	* w32.c (sys_shutdown): New function.
	* s/ms-win32.h: Define HAVE_SHUTDOWN.
	
1997-07-10  Eli Zaretskii  <eliz@pogo.gnu.ai.mit.edu>

	* xfaces.c (Fset_face_attribute_internal): Set mouse_face_defer
	only if HAVE_X_WINDOWS is defined.

1997-07-09  Marcus G. Daniels  <marcus@cathcart.sysc.pdx.edu>

	* xdisp.c (echo_area_display): Don't offset using left-side
	scroll bar width because it is included in the width; clear
	the entire line.

1997-07-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (read_process_output): Add cast.

	* filelock.c (current_lock_owner, lock_file_1): Add casts.

	* xdisp.c (redisplay_internal): Fix previous change.

	* s/irix4-0.h (C_SWITCH_SYSTEM): Add -Wf,-XNh option.

	* s/ms-w32.h: Don't define HAVE_SHUTDOWN.

	* frame.c (Fdelete_frame): Always err for deleting the only frame.

1997-07-09  Kenichi HANDA  <handa@etl.go.jp>

	* fontset.c (Ffont_info): Make vector of correct size.

	* xterm.c (x_load_font): Get value of fontp->height from
	ascent and descent members of structure font->max_bounds.
	(dumpglyphs): Draw background by FillSolid if a font is too short. 

1997-07-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_term_init): Don't use initializer for null_bits.

	* cm.h, sysdep.c, terminfo.c: Fix previous change.

	* fns.c (syms_of_fns): Fix previous change.

	* xdisp.c (decode_mode_spec) <z,Z>: Display buffer coding system
	last of the three.

	* doprnt.c: Use #ifdef to test STDC_HEADERS.

	* Makefile.in (shortlisp): Fix typo.

1997-07-08  enami tsugutomo  <enami@but-b.or.jp>

	* emacs.c (main) [__NetBSD__]: Round up new stack limit to page bdry.

	* fileio.c (Finsert_file_contents): Give up match-end only if
	coding requires conversion.  Adjust end of non-matching text area
	to multibyte character boundary if enable_multibyte_character is
	non-nil.

1997-07-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (decode_mode_spec_coding): Really don't display
	EOL indicator when eol_flag is 0.
	(echo_area_display): Use proper width when scroll bars on left.

	* syntax.h (struct gl_state_s): New field `offset'.
	(SETUP_SYNTAX_TABLE_FOR_OBJECT): Set offset field.
	(SETUP_SYNTAX_TABLE): Clear offset field.
	(UPDATE_SYNTAX_TABLE, UPDATE_SYNTAX_TABLE_FORWARD): 
	(UPDATE_SYNTAX_TABLE_BACKWARD): Use the offset field.

	* s/sol2.h (LIBS_SYSTEM): Add -lkvm and -lelf.

1997-07-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* editfns.c (Fuser_full_name): Declare p, q and r as unsigned char *.

	* xterm.c (XTread_socket) <KeyPress>: Call XFilterEvent.

	* terminfo.c (ospeed):
	Define as short, unless HAVE_TERMIOS_H and LINUX.

	* cm.h (ospeed): Declare as short unless HAVE_TERMIOS_H and LINUX.
	* sysdep.c (ospeed): Likewise.

	* window.c: Include blockinput.h.
	(Fset_window_configuration): Block input around frobbing the frame.
	Preseve point in the current buffer if we do not switch
	to a different one.

1997-07-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (redisplay_internal): Fix previous change.
	(echo_area_display): Use proper vpos when clearing extra minibuf lines.

1997-07-04  Kenichi HANDA  <handa@etl.go.jp>

	* callproc.c (Fcall_process): If enable-multibyte-characters is
	nil, do not encode arguments for process, and decode output of
	process by emacs-mule.
	(Fcall_process_region): If enable-multibyte-characters is nil, do
	not encode text to be given to process, and decode output of
	process by emacs-mule.

	* process.c (Fstart_process): If enable-multibyte-characters is
	nil, set coding system for decoding output of process to
	emacs-mule, and set coding system for encoding to nil.
	(Fopen_network_stream): If enable-multibyte-characters is nil, set
	coding systems for decoding and encoding to nil.
	
	* fileio.c (Finsert_file_contents): If enable-multibyte-characters
	is nil, decode character code by emacs-mule.
	(Fwrite_region): Use buffer-file-coding-system for encoding if
	enable-multibyte-characters is nil.

	* coding.c (Qemacs_mule, inhibit_eol_conversion): New variables.
	(setup_coding_system): If inhibit_eol_conversion is 0, set
	coding->eol_type to CODING_EOL_LF.
	(syms_of_coding): Initialize and staticpro Qemacs_mule.  Change
	error-message property of coding-system-error.  Declare
	inhibit-eol-conversion as Lisp variable.
	(system_eol_type): New variable.
	(init_coding_once): Initialize it.
	(ENCODE_SJIS_BIG5_CHARACTER): Bug in encoding a BIG5 character
	fixed.

	* coding.h (Qemacs_mule): Extern it.

	* xterm.c (x_list_fonts): Initialize the variable LIST to Qnil.

1997-07-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (display_menu_bar): Always pass W to display_string.

	* unexalpha.c (update_dynamic_symbols): Add cast when setting reladdr.

	* sysdep.c (init_system_name): Don't be fooled if getdomainname
	string starts with a period.

1997-07-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (redisplay_internal): At the end, if more frames have
	become visible, repeat the redisplay.
	(decode_mode_spec): Don't display subprocess coding systems.
	Don't display EOL for keyboard and terminal coding systems.

	* xfns.c (x_set_font): Funcall Qface_set_after_frame_default.
	(Qface_set_after_frame_default): New variable.
	(syms_of_xfns): Initialize and staticpro it.

	* xterm.c (x_make_frame_visible): Don't move the frame
	if it was iconified--only if it was invisible.

1997-07-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* gmalloc.c: Rename macro __P to PP.

	* floatfns.c, data.c, doprnt.c: Include float.h before lisp.h.

	* dired.c (Ffile_attributes): Use cast to avoid warnings.

	* syntax.h (SETUP_SYNTAX_TABLE_FOR_OBJECT): Treat nil like a buffer.

	* lread.c (Vpreloaded_file_list): New variable.
	(syms_of_lread): Set up Lisp variable.
	(Fload): Add to Vpreloaded_file_list, if dumping.

1997-07-04  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* editfns.c (Fformat): Add second argument in call to Ftruncate.

	* alloc.c, buffer.c, casefiddle.c, casetab.c, category.c,
	category.h, ccl.c, coding.c, editfns.c, fileio.c, fns.c, indent.c,
	intervals.c, intervals.h, keymap.c, lisp.h, minibuf.c, print.c,
	syntax.c, syntax.h, sysdep.c, textprop.c, xfns.c: Fix numerous
	bugs with inappropriate mixing of Lisp_Object with int.
	* config.in (RE_TRANSLATE): Define to extract integers from
	array of Lisp_Objects.

1997-07-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (overlay_strings): Finish up previous change.

	* Makefile.in (lisp, shortlisp): Some files moved to subdirs.

1997-07-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/sunos4shr.h (LD_SWITCH_SYSTEM_TEMACS): Add #undef.

	* syssignal.h [sigmask] (SIGEMPTYMASK): Define to use sigmask.

	* eval.c (Fsignal, find_handler_clause): If ERROR_SYMBOL
	is nil, assume it's in the car of DATA.
	* alloc.c (memory_full): Pass Qnil to Fsignal for ERROR_SYMBOL.

	* s/sunos4-0.h (LD_SWITCH_SYSTEM_TEMACS): Defined.  Move -e here.
	(LD_SWITCH_SYSTEM): Don't use -e option here.

	* Makefile.in (ALL_LDFLAGS): Use LD_SWITCH_SYSTEM_TEMACS.

1997-07-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (send_process): Make buf and temp_buf  `unsigned char *'.

	* buffer.c (overlay_strings): Use unsigned char for things
	that relate to overlay_str_buf.

	* syssignal.h (sigpause): Don't define if already defined.

	* Makefile.in (LD_SWITCH_SYSTEM_TEMACS): New variable.
	
1997-07-02  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* Makefile.in (lisp, shortlisp): Add widget.elc.

1997-07-02  Kenichi Handa  <handa@etl.go.jp>

	* xselect.c (selection_data_to_lisp_data): Call free instead of
	xfree.

	* coding.h (struct coding_system): New members
	character_unification_table_for_decode and
	character_unification_table_for_encode.

	* coding.c (Vstandard_character_unification_table_for_decode):
	Name changed from Vstandard_character_unification_table_for_read.
	(Vstandard_character_unification_table_for_encode): Name changed
	from Vstandard_character_unification_table_for_write.
	(Qcharacter_unification_table_for_decode): New variable.
	(Qcharacter_unification_table_for_encode): New variable.
	(decode_coding_iso2022): Adjusted for the above name change.
	(encode_coding_iso2022): Likewise.
	(ENCODE_ISO_CHARACTER): Bug of handling return value of unify_char
	fixed.
	(DECODE_SJIS_BIG5_CHARACTER): New macro.
	(decode_coding_sjis_big5): Handle character unificatoin table.
	Use macro DECODE_SJIS_BIG5_CHARACTER.
	(encode_coding_sjis_big5): Handle character unificatoin table.
	Use macro ENCODE_SJIS_BIG5_CHARACTER.
	(setup_coding_system): Handle members
	character_unification_table_for_decode and
	character_unification_table_for_encode of the variable coding.
	(Ffind_operation_coding_system): Renamed from Ffind_coding_system.
	(syms_of_coding): Initialize and staticpro
	Qcharacter_unification_table_for_decode and
	Qcharacter_unification_table_for_decode.  Declare
	Ffind_operation_coding_system as Lisp functions.  Declare
	Vstandard_character_unification_table_for_decode and
	Vstandard_character_unification_table_for_encode as Lisp
	variables.

	* charset.c (Fchar_width): Check if the current buffer has display
	table.

	* fileio.c (Finsert_file_contents): Doc-string fixed.  Call
	Ffind_operation_coding_system.
	(Fwrite_region):  Call Ffind_operation_coding_system.

	* callproc.c: Call Ffind_operation_coding_system.

	* process.c (Fstart_process): Call Ffind_operation_coding_system.
	(Fopen_network_stream): Likewise.

	* fontset.h: Move "#endif /* _FONTSET_H */" at the tail.

1997-07-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sysdep.c (init_system_name): Don't accept "(none)" as domain.

	* xterm.c (x_make_frame_visible): Check has_been_visible
	field before the UNBLOCK_INPUT.

1997-07-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* coding.c (syms_of_coding): Change initial values of
	eol_mnemonic_... variables.

	* xdisp.c (decode_mode_spec_coding): Clean up handling of
	eol conversions.

	* .gdbinit (xcons): Print car and cdr in hex.
	(nextcons): New command.

	* xfns.c (x_set_scroll_bar_width): By default, use enough
	columns to give 14 or more pixels.

1997-06-30  Geoff Voelker  <voelker@cs.washington.edu>

	* emacs.c (decode_env_path): Ensure path elements use proper
	directory separator.

	* keyboard.c (make_lispy_event):
	Check that ISO_FUNCTION_KEY_OFFSET is defined.

	* process.c (READ_CHILD_OUTPUT): Deleted.
	(read_process_output): Use read instead of READ_CHILD_OUTPUT.

	* makefile.nt (OBJ2): Include new source files.
	
	* s/ms-w32.h: Duplicate undefs from config.in to check completeness.
	(STDC_HEADERS, HAVE_TZNAME, HAVE_MKTIME): Define to have a value.
	(HAVE_GETPAGESIZE, HAVE_SETLOCALE, HAVE_SHUTDOWN, HAVE_TZSET,
	HAVE_LIMITS_H, HAVE_STRERROR): Define.
	[HAVE_NTGUI] (HAVE_MENUS): Define.
	(SYSTEM_PURESIZE_EXTRA): Increase value.

	* unexw32.c, w32heap.c: Add pragma to force zero initialized 
	data into .data segment.

	* w32console.c, w32term.c: Include charset.h.

	* w32fns.c (syms_of_w32fns): Delete defsubrs of Sfocus_frame and
	Sunfocus_frame.

	* w32heap.c (getpagesize): Define.

1997-06-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* editfns.c (Fformat_time_string): Move doc string outside DEFUN.

	* buffer.c (overlay_str_buf): Declare as unsigned char *.

	* fns.c (Fy_or_n_p, Fyes_or_no_p): Obey use_dialog_box.
	(use_dialog_box): New variable, controls whether to use dialog boxes.
	(syms_of_fns): Set up Lisp variable.

1997-06-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (syms_of_buffer): enable-multibyte-characters is a user var.

	* callproc.c (Fcall_process): Fix previous change.

	* fns.c (concat): Use XCONS rather than Fcar, Fcdr--for known cons.
	(Fassq, assq_no_quit, Fassoc, Frassq, Frassoc, Fdelq): Likewise.
	(Fdelete, Fplist_get, mapcar1, Fmember, Fmemq): Likewise.

	* lread.c (init_lread): Add leim subdir, like lisp subdir.

	* syntax.c (scan_sexps_forward): Split up a complex if-test.

	* keyboard.c (read_char): Add a call to swallow_events
	when deciding whether to redisplay.
	(swallow_events): Add forward declaration.

	* sysdep.c [HAVE_TERMIOS_H]: Include termios.h.

	* callproc.c (Fcall_process): Avoid storing alloca result
	directly into array element.

	* process.c (wait_reading_process_input): If wait_for_cell,
	do check for keyboard input and swallow events, just don't exit.
	(max): New macro.
	(wait_reading_process_input): Pass a smaller first arg to select.

	* buffer.c (Fbury_buffer): Undo previous change.

1997-06-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (temp_output_buffer_show):
	Copy default-directory from current buffer.

	* cm.h (ospeed): Always use `extern' in the declaration.

	* Makefile.in (lisp, shortlisp): Some files are in international/.

	* unexelf.c [__NetBSD__]: Add some conditionals for NetBSD.

	* unexelf1.c: File deleted.

1997-06-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/unixware.h: New file.

1997-06-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Finsert_file_contents):
	Pass new arg to prepare_to_modify_buffer.

	* insdel.c (prepare_to_modify_buffer, signal_before_change):
	New argument PRESERVE_PTR.
	(del_range_1): Use PRESERVE_PTR to preserve FROM.
	Save the length of the range separately.
	(NULL): Define if not defined.

1997-06-23  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* fileio.c (Ffile_directory_p): Doc fix.

1997-06-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (Fbuffer_list): New optional argument FRAME.

	* fns.c (Freverse): Simplify.

1997-06-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/bsdos3.h: New file.
	
	* s/bsdos2.h (KERNEL_FILE): New overriding definition.

	* keyboard.c (read_avail_input): Check for failure with EIO.

	* s/gnu-linux.h (LD_SWITCH_SYSTEM) [__mips__]: Alternate definition.

	* m/mips.h: Test __linux__ along with NEWSOS5.
	(KERNEL_FILE, UNEXEC): Don't redefine them if __linux__.
	[__linux__] (TEXT_START, DATA_START, DATA_SEG_BITS):
	Alternate definitions.
	
	* emacs.c (Fdump_emacs): Bind command-line-processed to nil here.

	* xdisp.c (init_xdisp): Pay attention to FRAME_MENU_BAR_LINES.

	* emacs.c (Fdump_emacs): Error if not run in batch mode.

	* s/hpux10.h (LIBS_TERMCAP): Use -ltermcap instead of -lc.

	* unexelf.c [__sony_news && _SYSTYPE_SYSV]: Include sym.h
	and sys/elf_mips.h.
	(unexec): Add __sony_news && _SYSTYPE_SYSV conditionals.
	Add a _nec_ews_svr4 conditional.

	* s/newsos6.h: New file.

	* m/news-risc6.h: New file.

	* frame.c (Fdelete_frame): Clear echo_area_glyphs if it was
	in this frame.

	* process.c (wait_reading_process_input): Don't check for
	keyboard input if wait_for_cell.

	* minibuf.c (read_minibuf): New arg allow_props.
	If it is 0, discard text properties from the result.  Callers changed.
	(minibuffer_allow_text_properties): New variable.
	(Fread_from_minibuffer): That variable controls allow_props arg.
	(syms_of_minibuf): Set up Lisp var.

1997-06-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* insdel.c (del_range_1): Make markers for TO and FROM
	in case prepare_to_modify_buffer changes the text.

1997-06-21  Kenichi Handa  <handa@etl.go.jp>

	* fontset.h (font_idx_temp): Extern it.
	(FS_LOAD_FONT): New macro.

	* fontset.c (font_idx_temp): New temprary variable used in
	FS_LOAD_FONT.

	* xfaces.c (Fset_face_attribute_internal): Use FS_LOAD_FONT
	instead of calling fs_load_font directly.

	* xterm.c (dumpglyphs): Use FS_LOAD_FONT.
	(x_new_fontset): If frame F has already using FONTSET, avoid the
	duplicated work.  Use FS_LOAD_FONT.
	(x_list_fonts): Call Fassoc to search Valternate_charset_table.
	(x_load_font): Get around a buf of XListFonts

1997-06-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* print.c (Ferror_message_string): Optimize (error STRING) case.

1997-06-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (Fprocess_send_eof): Properly conditionalize prev. change.

1997-06-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (Fprocess_send_eof): Use shutdown, if it's a socket.
	Don't close the output descriptor if that is also the input descriptor.
	
	* config.in (HAVE_SHUTDOWN): Add #undef.

	* editfns.c (Fchar_before): Validate N after decrementing.
	Don't use POS as integer.

1997-06-18  Kenichi Handa  <handa@etl.go.jp>

	* coding.c (detect_coding_iso2022): Initilize mask correctly.

	* fns.c (concat): Pay attention to multibyte characters when
	TARGET_TYPE is Lisp_String.

1997-06-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): Fix previous change.

1997-06-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Fdo_auto_save): Use stdio to write the save-list file.

	* fileio.c (Finsert_file_contents): Don't give up on the fast
	replace method if the coding remains undecided.

1997-06-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): When exiting because
	the process WAIT_PROC has terminated, first read all its output. 

1997-06-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* editfns.c (Fchar_after, Fchar_before): Make arg optional.

1997-06-14  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* buffer.h (point): Obsolete macro deleted in favor of PT.
	* editfns.c (Fprevious_char): Use PT, not point.
	* cmds.c (internal_self_insert): Use PT, not point.

1997-06-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* bytecode.c (Bread_char): Deleted.
	(Bsave_current_buffer_1): New byte code.
	(Fbyte_code): Delete handling Bread_char.
	Handle Bsave_current_buffer_1 like Bsave_current_buffer.

1997-06-11  Paul Eggert  <eggert@twinsun.com>

	* callproc.c (Fcall_process): Use setsid to disconnect child
	process from controlling terminal.

1997-06-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* unexalpha.c (unexec): Call update_dynamic_symbols unconditionally.
	(update_dynamic_symbols): Define unconditionally, but do nothing
	if __linux__or __NetBSD__.

	* s/netbsd.h (HAVE_TEXT_START, START_FILES, UNEXEC):
	Don't define these if __ELF__.
	(RUN_TIME_REMAP, N_PAGSIZ, N_BSSADDR, N_TRELOFF): Likewise.

	* m/alpha.h (TEXT_END, COFF, DATA_END): 
	Define them if __NetBSD__ just as if LINUX.
	(HAVE_TEXT_START): Define, if __NetBSD__ and __ELF__.

1997-06-10  Erik Naggum  <erik@naggum.no>

	* fileio.c (Fwrite_region): Fix previous doc change.

1997-06-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): Return if unread events
	appear.

	* keyboard.c (kbd_buffer_get_event): When wait_reading_process_input
	returns, check Vunread_command_events.

1997-06-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sysdep.c (init_sys_modes): Enable VSTART and VSTOP
	if flow_control.

	* editfns.c (Finsert_char): Check QUIT.

	* fontset.c (list_fontsets, fs_load_font): 
	fast_c_string_match_ignore_case renamed.
	
	* xterm.c (x_list_fonts): fast_c_string_match_ignore_case renamed.

	* search.c (fast_c_string_match_ignore_case):
	Renamed from fast_string_match_ignore_case.  Set re_match_object.

1997-06-09  Kenichi Handa  <handa@etl.go.jp>

	* buffer.c (init_buffer_once): Inititialize the member
	buffer_file_coding_system.
	(syms_of_buffer): Declare Lisp variables
	default-buffer-file-coding-system and buffer-file-coding-system.

	* buffer.h (struct buffer): New member buffer_file_coding_system.

	* coding.c (Vcoding_system_alist): Deleted.
	(Qcoding_system_spec): Renamed from Qcoding_system_vector.
	(Vdefault_process_coding_system, Vfile_coding_system_alist,
	Vprocess_coding_system_alist, Vnetwork_coding_system_alist): New
	variables.
	(Ffind_coding_system): Adjusted for the above change.
	(syms_of_coding): Declare them as lisp variables.
	(Fcheck_coding_system): Pass list as DATA argument to Fsignal.

	* coding.h (Vdefault_process_coding_system): Extern it.

	* callproc.c (Fcall_process): Pay attention to
	Vdefault_process_coding_system.
	(Fcall_process_region): Likewise.

	* process.c (Fstart_process): Likewise.
	(Fopen_network_stream): Likewise.

	* xdisp.c (decode_mode_spec): Access the value of
	buffer-file-coding-system by b->buffer_file_coding_system.

	* fileio.c (Fwrite_region): Cancel the 7th argument CODING_SYSTEM
	added by the previous change.
	(auto_save_1): Adjusted for the above change.

	* data.c (Faset): Inherit default value correctly while creating
	sub char table.

	* xselect.c (selection_data_to_lisp_data): Change coding system
	name to iso-latin-1.
	(lisp_data_to_selection_data): Likewise.

	* xterm.c (dumpglyph): Shift baseline for such a font that is
	shorter but ascent or descent exceed the line height.
	For a larger font, draw a small hook at right-bottom edge instead
	of a rectangle.

1997-06-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (Fcopy_keymap): After copying a sub-char-table,
	do store the copy.

1997-06-04  Kenichi Handa  <handa@etl.go.jp>

	* casefiddle.c (casify_object): Fix bug on handling a character
	argument.

1997-06-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/netbsd.h (NO_SHARED_LIBS): Test __alpha__ && ! __ELF__.

	* keyboard.c (syms_of_keyboard): Doc fix.

	* search.c (Freplace_match): If opoint is 0, that's relative to ZV.

	* intervals.c (find_interval): No longer inline.

1997-06-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lisp.h (VALMASK, GCTYPEMASK, MARKBIT, ARRAY_MARK_FLAG)
	(PSEUDOVECTOR_FLAG, enum pvec_type, PSEUDOVECTOR_SIZE_MASK): 
	Define regardless of NO_UNION_TYPE.
	
	* xfns.c (Fx_create_frame): Use XINT to access parent.

	* syntax.c (Fsyntax_table_p, check_syntax_table): Use EQ.
	(Fmodify_syntax_entry): Use XINT to access c.
	(describe_syntax): Use XINT to access first.

	* search.c (search_buffer): Use XINT around refs to trt.

	* lisp.h (concat3, get_truename_buffer): Declare them.

	* keyboard.c (read_key_sequence): Change some locals to `int'.

	* indent.c (compute_motion): Use XFASTINT on width_table elts.

	* fns.c (map_char_table): Use XSETFASTINT.

	* fileio.c (Fwrite_region, build_annotations):
	Set start and end using XSETFASTINT.

	* editfns.c (Fcompare_buffer_substrings): trt contains Lisp_Objects.
	(transpose_markers): Use marker_position, not Fmarker_position.

	* buffer.c (Fmove_overlay): Clean up setting o_beg and o_end.

	* alloc.c (Fmake_byte_code): Set val from p, not from val.
	(make_event_array): Convert nargs to Lisp_Object.

	* m/powerpcle.h: New file.

	* unexalpha.c [__NetBSD__]: Don't include filehdr.h, aouthdr.h
	scnhdr.h or syms.h.  Add many other conditionalized definitions.

	* m/alpha.h [__NetBSD__]: Include stdlib.h, not alloca.h.
	(ORDINARY_LINK): Defined (if __NetBSD__).

	* s/netbsd.h [__alpha__] (NO_SHARED_LIBS): Defined.
	
1997-05-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (init_lread): Sometimes add to load-path
	the lisp and site-lisp dirs under the source directory.

	* xfaces.c: Include frame.h unconditionally.

	* Makefile.in (stamp-oldxmenu): Always define this
	one way or another.

	* search.c (Freplace_match): Fix previous change.

	* syntax.c (back_comment): Detect 2-char comment starts properly.
	New arg COMSTYLE; callers changed.
	(Fforward_comment): Handle unmatched two-character comment starters.

	* intervals.c (move_if_not_intangible): Fix previous change.

	* Makefile.in (XOBJ, MSDOS_OBJ, SOME_MACHINE_OBJECTS): Delete xfaces.o.
	(obj): Add xfaces.o.
	(FACE_SUPPORT, SOME_MACHINE_LISP): Delete faces.elc.
	(shortlisp, lisp): Add faces.elc

	* emacs.c (main): Call syms_of_xfaces whenever ! HAVE_NTGUI.

	* xfaces.c (Fframe_face_alist, Fset_frame_face_alist):
	Define unconditionally.
	(Finternal_next_face_id, next_face_id): Likewise.
	(syms_of_xfaces): Define unconditionally,
	but conditionalize some of the contents.

1997-06-01  Roderick Schertler  <roderick@ibcinc.com>

	* sysdep.c (init_baud_rate): Use INIT_BAUD_RATE if it's defined.
	(sys_signal): Lose DGUX special case.

	* s/dgux.h (signal): Define only if not NO_DGUX_SIGNAL_REDEF.
	* s/dgux4.h: New file.

1997-05-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (process_expose_from_menu, XTread_socket): 
	Set has_been_visible field.
	(x_make_frame_visible): Don't do XMoveWindow unles has_been_visible.

	* xterm.h (struct x_output): New field has_been_visible.

	* lread.c (intern): Don't make a pure string here,
	since Fintern does that.

	* Makefile.in (lisp, shortlisp): Use cus-start.el, not .elc.

	* data.c (Farrayp): Accept bool-vectors and char-tables.

	* fns.c (Fchar_table_range, Fset_char_table_range):
	Make one-element vector work for RANGE.

1997-05-30  NIIBE Yutaka  <gniibe@mri.co.jp>

	* term.c (insert_glyphs): Use &, not &&.

1997-05-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* search.c (Freplace_match): Use move_if_not_intangible
	to handle intangible text better.

	* intervals.c (move_if_not_intangible): New function.

	* editfns.c (Fcurrent_time_string): Doc fix.

	* eval.c (Fsignal): Use call2 to call Vsignal_hook_function.

1997-05-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dispnew.c (scrolling): If a line is not enabled,
	give it an infinite draw_cost.

	* data.c (Faset): Doc fix.

	* alloc.c (Fmake_bool_vector): Doc fix.

	* buffer.c (syms_of_buffer): Doc fix.

1997-05-27  Kenichi Handa  <handa@etl.go.jp>

	* fontset.h (FONT_ENCODING_NOT_DECIDED): New macro.

	* fontset.c (fs_load_font): Before using a fontset, be sure to
	load the ASCII font of the fontset.  Size and height of a fontset
	is set to the same as those of the ASCII font of the fontset.  Use
	macro FONT_ENCODING_NOT_DECIDED.

	* xterm.c (x_load_font): Use macro FONT_ENCODING_NOT_DECIDED.

	* fns.c (map_char_table): For sub char-table, index should be
	start from 0 (not from 32) considering a composite character.
	(Fmap_char_table): Doc-string adjusted.  The variable indices is
	declared as an array of Lisp_Object.

	* coding.h (struct iso2022_spec): Member requested_designation is
	changed to array of `unsigned char'.
	(CODING_SPEC_ISO_NO_REQUESTED_DESIGNATION): New macro.

	* coding.c (encode_invocation_designation): Use macro
	CODING_SPEC_ISO_NO_REQUESTED_DESIGNATION.
	(encode_designation_at_bol, setup_coding_system): Likewise.
	(Fset_terminal_coding_system_internal): Renamed from
	Fset_terminal_coding_system.  Make it non-interactive.
	Do not call Fredraw_display.
	(Fset_keyboard_coding_system_internal): Renamed from
	Fset_keyboard_coding_system.  Make it non-interactive.

	* charset.c (Ffind_charset_string): The variable CHARSETS is
	changed to (int *).

	* casetab.c (case_temp1, case_temp2): New variables temporarily
	used in macros DOWNCASE and UPCASE1.
	(set_case_table): Setup canonical table correctly.  Use
	map_char_table instead of compute_trt_inverse.
	(set_canon, set_identity, shuffle): New functions given to
	map_char_table.
	(compute_trt_identity, compute_trt_shuffle, compute_trt_inverse):
	Deleted.

	* casefiddle.c (casify_object): Handle multibyte characters.
	(casify_region): Change the way of handling multibyte characters.

	* lisp.h (CHAR_TABLE_REF): Do not check validity of CT.
	(CHAR_TABLE_SET): Likewise.
	(DOWNCASE_TABLE): Return case-table instead of the `contents' field.
	(UPCASE_TABLE): Likewise.
	(DOWNCASE): Use CHAR_TABLE_REF.
	(NOCASEP): Use UPCASE1.
	(UPCASE1): Use CHAR_TABLE_REF.

	* search.c (looking_at_1): Change using DOWNCASE_TABLE.
	(string_match_1): Likewise.

	* editfns.c (Fchar_equal): Make it handle case of multibyte
	characters.

1997-05-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (Fsplit_window): Ignore FRAME_NO_SPLIT_P here.
	(inhibit_frame_unsplittable): Variable deleted.
	(syms_of_window): Don't set up Lisp variable.

	* xterm.c (XTread_socket) <ConfigureNotify>: Don't call
	x_wm_set_size_hint if window has no parent yet.
	Simplify the call to x_real_positions.
	(x_make_frame_visible): Use win_gravity to decide whether to
	call XMoveWindow.  Also, don't do it if frame already visible.
	
	* xfns.c (x_real_positions): Subtract border width from results.

1997-05-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (syms_of_window): Initialize inhibit_frame_unsplittable.

	* w16select.c (Fwin16_set_clipboard_data): Pass new arg to sit_for.

	* fileio.c (Fdo_auto_save): Pass new arg to sit_for.

	* callint.c (Fcall_interactively): Pass new arg to sit_for.

	* keyboard.c (command_loop_1): Pass 1 as new arg to sit_for.
	(read_char): Likewise, pass 0 for it.

	* dispnew.c (sit_for): New arg initial_display.
	(Fsit_for): Pass new arg.

	* indent.c (compute_motion): Return correctly if skip_invisible
	takes us past TO.

	* xterm.c (XTread_socket) <UnmapNotify>: Don't make an iconify_event
	when frame was made invisible.
	(x_make_frame_visible): Put the call to x_set_offset back as it was.
	Near the end, instead call XMoveWindow, but only if original
	positions were not negative.

1997-05-26  Simon Marshall  <simon@diazepam.gnu.ai.mit.edu>

	* window.c (syms_of_window): Change frame_override_unsplittable to
	inhibit_frame_unsplittable.
	(Fsplit_window): Check inhibit_frame_unsplittable.

1997-05-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (Fdisplay_buffer): Use B not b for interactive argument.

	* xfns.c (x_real_positions): Directly compare the frame's window
	or parent with the root window.

	* xterm.c (x_make_frame_visible): Call x_set_offset only after
	mapping the window and accepting input.
	(x_calc_absolute_position): Do nothing if current position
	is already for the top-left corner.
	Handle errors in XTranslateCoordinates.
	(XTread_socket): Simplify handling of ConfigureNotify events.
	Always call x_wm_set_size_hint for them.
	No need to call XTranslateCoordinates here.
	(x_clear_errors): New function.
	
1997-05-20  Erik Naggum  <erik@naggum.no>

	* editfns.c (Fformat_time_string): Doc update.
	
1997-05-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* editfns.c (Fformat_time_string): Doc update.
	Handle emacs_strftime returning -1.
	If it returns 0, compute actual buffer size needed.

	* Makefile.in (shortlisp): Add custom.elc and cus-start.elc.

	* fns.c (internal_equal): When comparing strings, ignore text props.
	Friedman offers to fix anything that has trouble due to this.

	* dispnew.c (sit_for): Delete #if 0.

	* keymap.c (access_keymap, store_in_keymap): Don't look in a char-table
	for a character that has modifier bits.

1997-05-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (access_keymap): For a char-table,
	look only for chars with no modifier bits.

1997-05-19  Kenichi Handa  <handa@etl.go.jp>

	* s/osf1.h (HAVE_TERMIOS): Define it.

	* m/alpha.h (PTY_OPEN): Call sigblock instead of sigblockx.

	* Makefile.in (xdisp.o): Add coding.h in dependency list.

	* fontset.h (struct font_info): Change the declaration of encoding
	from `char' to `unsigned char'.

	* xterm.c (x_load_font): Set 4 instead of -1 in fontp->encoding[1]
	for the meaning of `can not be decided'.

	* fontset.c (fs_load_font): Modified to cope with the above
	change.

	* charset.c (Ffind_charset_region): Change the declaration of
	charsets from `char' to `int'.
	(find_charset_in_str): Likewise.

	* xselect.c (lisp_data_to_selection_data): Likewise.

	* coding.h (struct iso2022_spec): Change the declaration of
	requested_designation from `char' to `int'.

1997-05-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* callint.c (Fcall_interactively): Use num_input_events.

	* keyboard.h (num_input_events, num_nonmacro_input_events):
	Renamed from ..._input_chars.

	* eval.c (num_nonmacro_input_events):
	Renamed from num_nonmacro_input_chars.

	* keyboard.c (num_nonmacro_input_events):
	Renamed from num_nonmacro_input_chars.
	(syms_of_keyboard): Rename Lisp variable.

1997-05-18  Erik Naggum  <erik@naggum.no>

	* lisp.h (Vtty_erase_char): Declared.
	* keyboard.c (Vtty_erase_char): Variable defined
	(syms_of_keyboard): Set up Lisp variable.
	Also set up `num-nonmacro-input-chars' to report actual keystrokes.
	* sysdep.c (init_sys_modes): Initialize Vtty_erase_char if
	possible from the stty settings, otherwise to nil.

	* lread.c (Fintern): Give keywords a value when interned.

	* dired.c (Ffile_attributes): Return inode number as a cons
	only if necessary.

1997-05-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (copy_keymap_1): Do nothing if ELT isn't a keymap.

1997-05-17  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* frame.c (make_terminal_frame): Don't add `Emacs' to frame name.

1997-05-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* sysselect.h (SELECT_TYPE): Don't define if already defined.

	* cmds.c (nonascii_insert_offset): New variable.
	(Fself_insert_command, internal_self_insert):
	Add nonascii_insert_offset to what we insert, when appropriate.
	(syms_of_cmds): Set up Lisp variable.

	* xdisp.c (display_text_line): Move the code to fill out the line
	with the newline's face to the end of the newline code.
	Add changes (commented out) to record ellipsis positions in charstarts.

	* charset.c (strwidth): Fix previous change.

	* ralloc.c (mallopt): Declare, if appropriate.
	(r_alloc_init) [DOUG_LEA_MALLOC]: Call mallopt,
	instead of setting __malloc_extra_blocks.

Thu May 15 22:21:18 1997  Ken'ichi Handa  <handa@diazepam.gnu.ai.mit.edu>

	* Makefile.in (charset.o): Add disptab.h in dependency list.

	* charset.c: Include disptab.h.

1997-05-16  Kenichi Handa  <handa@etl.go.jp>

	* xterm.c (dumpglyphs): Draw glyphs one by one if the font for
	them is narrower than required.

	* fns.c (copy_sub_char_table): Declare the argument ARG as
	Lisp_Object.

	* fontset.c (fontset_pattern_regexp): Cast to (char *) before
	assigning to P0.

	* ccl.c (struct ccl_prog_stack): Declear the member ccl_prog as
	Lisp_Object *.

	* editfns.c: Declare Fuser_full_name as Lisp_Object in advance to
	avoid compiler error.

	* data.c: Declare set_internal as Lisp_Object in advance to avoid
	compiler error.

	* alloc.c (BYTES_USED): Put # at the beginning of line.
	(emacs_blocked_malloc): Likewise.

	* xterm.c (x_connection_closed): Likewise.
	(x_load_font): Cast to (char *) before assigning to FONTNAME.

	* keymap.c: Declare Fcopy_keymap as Lisp_Object in advance to
	avoid compiler error.

1997-05-16  Kenichi Handa  <handa@etl.go.jp>

	* charset.h (VALID_CHAR_P): New macro.

	* fns.c (Fset_char_table_default): New function.

1997-05-15  Kenichi Handa  <handa@etl.go.jp>

	* charset.c (non_ascii_char_to_string): Signal error if the
	argument C is an invalid character code.
	(Fconcat_chars): Use alloca instead of malloc.

	* charset.h (CHAR_STRING):  Comment reflect the above change.

	* coding.h: Name change through the code:
	coding-category-internal => coding-category-emacs-mule,
	XXX_coding_internal => XXX_coding_emacs_mule,
	coding_type_internal => coding_type_emacs_mule,
	coding_type_automatic => coding_type_undecided,
	CODING_CATEGORY_MASK_INTERNAL => CODING_CATEGORY_MASK_EMACS_MULE,
	CODING_CATEGORY_IDX_INTERNAL => CODING_CATEGORY_IDX_EMACS_MULE,
	CODING_EOL_AUTOMATIC => CODING_EOL_UNDECIDED.
	* coding.c: Likewise.
	* fileio.c: Likewise.
	
	* xfns.c (Fx_create_frame): Delete unnecessary code.

1997-05-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Finsert_file_contents): Use xmalloc. not malloc.
	Check correctly for whether no code translation is needed.
	(Finsert_file_contents): Use xrealloc too.

	* charset.c (strwidth, Fchar_width): Handle display table.

1997-05-15  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* casefiddle.c: Include charset.h.
	(Qidentity): Define this variable.
	(syms_of_casefiddle): Initialize and staticpro it.
	(casify_object, casify_region): Handle multibyte.

1997-05-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* casetab.c (compute_trt_identity): Use make_sub_char_table.
	(compute_trt_identity, compute_trt_shuffle):
	Set up bytes[0] with the charset code.
	Check for a sub-char-table when deciding to recurse.
	Terminate the loop properly for a sub-char-table.

	* callint.c (Fcall_interactively): Pass extra arg to Fread_string.

	* minibuf.c (Fread_from_minibuffer): Add gcpro.

	* fns.c (Fcopy_sequence): Correctly copy the char-table contents.

	* keymap.c (describe_vector): Identify charset row numbers clearly.

	* casetab.c: Include charset.h.
	(compute_trt_inverse): Totally rewritten.
	Args are now Lisp_Object.  Callers changed.
	(compute_trt_identity, compute_trt_shuffle): New subroutines.
	(init_casetab_once): Use XSETFASTINT to store into case table;
	use CHAR_TABLE_SINGLE_BYTE_SLOTS to end the loop.
	
1997-05-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* syntax.c (describe_syntax_1): Pass new args to describe_vector.

	* category.c (describe_category_1): Pass new args to describe_vector.

1997-05-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (get_keyelt): Handle an indirect entry with meta char.
	(describe_vector): Rewrite char-table handling.

	* data.c (wrong_type_argument): Pass new arg to Fstring_to_number.

1997-05-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfns.c (Fx_create_frame): Get X resources from the display
	we are making the frame on.
	(x_get_arg): New arg DPYINFO.  Callers changed.
	(display_x_get_resource): New function.

1997-05-11  Lars Magne Ingebrigtsen  <larsi@ifi.uio.no>

	* data.c (Fstring_to_number): Handle bases 2...16.
	(digit_to_number): New subroutine.

1997-05-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fns.c (map_char_table): New arg SUBTABLE.  Callers changed.
	Pass the whole chartable to C_FUNCTION.
	Pass index character as a Lisp_Object.

	* keymap.c (Fmake_keymap): Make a char-table.
	(access_keymap, store_in_keymap): Likewise,
	(describe_map, Fset_keymap_parent, Faccessible_keymaps): Likewise.
	(Fwhere_is_internal, Fcopy_keymap): Handle a char-table.
	(copy_keymap_1, accessible_keymaps_char_table): New subroutines.
	(where_is_internal_1, where_is_internal_2): New functions.
	(syms_of_keymap): Set up Qchar_table_extra_slots prop on Qkeymap.
	
1997-05-10  Ken'ichi Handa  <handa@etl.go.jp>

	* callproc.c (Fcall_process_region): Supply 7th new arg
	CODING_SYSTEM as Qnil to Fwrite_region.

	* ccl.c (Fccl_execute_on_string): Add 4th optional arg
	CONTINUE.

	* charset.c (unify_char): New function.
	(Fdefine_charset): Doc-string modified.
	(find_charset_in_str): Add 4th arg TABLE which is a character
	unification table.
	(Ffind_charset_region): Add optional arg TABLE which is a
	character unification table.
	(Ffind_charset_string): Likewise.

	* charset.h (unify_char): Extern it.

	* coding.c (Valternate_charset_table): The valiable deleted.
	(Venable_character_unification,
	Vstandard_character_unification_table_for_read,
	Vstandard_character_unification_table_for_write,
	Qcharacter_unification_table): New variables.
	(syms_of_coding): Initialize and declare them.
	(DECODE_ISO_CHARACTER): Modified to handle a character unification
	table instead of Valternate_charset_table.
	(DECODE_DESIGNATION): Delete handling of Valternate_charset_table.
	(decode_coding_iso2022): Handle a character unification table.
	(ENCODE_ISO_CHARACTER): New macro.
	(encode_designation_at_bol): Handle a character unification table.
	Do not return -1 even if end-of-line is not in the current run.
	(encode_coding_iso2022): Handle a character unification table.
	Call macro ENCODE_ISO_CHARACTER instead of calling
	ENCODE_ISO_CHARACTER_DIMENSION1 and
	ENCODE_ISO_CHARACTER_DIMENSION2 directly.  Check the size of
	carryover before copying it to destination.
	(setup_coding_system): Initialize the member
	character_unification_table of the struct coding system to Qnil.
	(Fset_keyboard_coding_system): Doc string augmented.

	* coding.h (CODING_SPEC_ISO_PLANE_CHARSET): Return -1 if no
	character set is invoked to PLANE.
	(struct coding_system): New member character_unification_table.

	* fileio.c (Fwrite_region): Add 7th optional arg
	CODING_SYSTEM.  Move gap after a newline code if we are encoding
	in a coding system which requires designation sequences to be put
	at beginning of line.  Set coding.last_block to 1 before calling
	a_write for an empty file.
	(build_annotations): Code tuned up for handling
	pre_write_conversion of a coding system.
	(e_write): Delete code for handling carryover of code conversion.
	It is now handled in encode_coding.
	(auto_save_1): Supply 7th new arg CODING_SYSTEM as Qnil to
	Fwrite_region.

	* fontset.c (Vfontset_alias_alist): New variable.
	(fontset_pattern_regexp): Delete code for handling nickname of a
	fonset.  It is now handled in Fquery_fontset by consulting
	Vfontset_alias_alist.
	(Fquery_fontset): Handle Vfontset_alias_alist.
	(syms_of_fontset): Terminate each line by `\n\' in doc-string of
	alternate-fontname-alist.  Declare Lisp valiable
	fontset-alias-alist.  Doc-string of highlight-wrong-size-font
	and clip-large-size-font modified.

	* xfns.c (Fx_create_frame): Delete code for handling the X
	resouce "Fontset".

	* xselect.c (selection_data_to_lisp_data): If TYPE is `STRING'
	and DATA contains 8-bit codes, decode them as Latin-1 characters.
	(lisp_data_to_selection_data): Supply 4th arg TABLE as Qnil to
	find_charset_in_str.

	* xterm.c (dumpglyphs): Even if font (not fontset) is used,
	display Latin1 characters correctly if the font contains glyphs
	for them.  Fix bug of displaying cursor on a composite character.

1997-05-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keyboard.c (Fexecute_extended_command):
	Pass new arg to Fcompleting_read.
	(command_loop_1): Use an int for last_command_char.

	* lisp.h (read_minibuf): Declaration deleted.

	* callint.c (Fcall_interactively): Pass new arg to
	Fread_from_minibuffer and Fread_variable.

	* fns.c (Fyes_or_no_p): Pass new arg to Fread_from_minibuffer.

	* minibuf.c (Fread_command): New optional arg DEFAULT-VALUE.
	Callers changed.
	(Fread_variable, Fread_string, Fread_from_minibuffer): Likewise.
	(read_minibuf): Now static.  New arg DEFALT.  Callers changed.
	Bind minibuffer-default here.
	(read_minibuf_unwind): Now static.
	(Fcompleting_read): Past DEF to Fread_from_minibuffer;
	no need to use it directly here.

	* fileio.c (Fread_file_name): Finish previous change.

	* coding.c (Fread_coding_system, Fread_non_nil_coding_system): 
	Pass new arg to Fcompleting_read.

	* callint.c (Fcall_interactively): Pass new arg to Fcompleting_read.

	* xmenu.c (Fx_popup_menu): Doc fix.

1997-05-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (TAGS): Fix typo.

	* xdisp.c (mark_window_display_accurate, redisplay_internal):
	Test highlight_nonselected_windows.
	(display_text_line): Likewise (in more places).
	(syms_of_xdisp): Initialize highlight_nonselected_windows to 0.

	* keyboard.c (Qtimer_event): Variable deleted.
	(Qtimer_event_handler): New variable.
	(syms_of_keyboard): Don't initialize Qtimer_event.
	Do initialize Qtimer_event_handler.
	(read_char): Don't check for timer event.
	(swallow_events): Don't handle timer events.
	(timer_check): Likewise.
	(make_lispy_event): Likewise.

1997-05-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/bsd386.h: Delete the code that was trying to define BSD "right"
	now that Emacs doesn't use the symbol BSD this way.

1997-05-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (MOUSE_SUPPORT): Delete menu-bar.elc.
	(lisp): Move menu-bar.elc here.
	Add custom.elc and cus-start.elc.

	* m/intel386.h (LIBS_MACHINE): Add -lelf.

1997-05-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xdisp.c (display_text_line): Clear region_showing to Qnil if the
	window should not show a region.
	(redisplay_internal): Do update region_showing when ! all_windows.

	* window.c (Fset_window_configuration): Set last_selected_window
	in the new selected window's new buffer.

	* xdisp.c (display_text_line): Set w->region_showing to the mark
	position if there's a mark; to nil, otherwise.

	* w32fns.c (x_set_mouse_color): Fix previous change.

	* xselect.c (x_reply_selection_request): Delete the inner
	unbind_to call, since x_uncatch_errors does the job.

1997-05-04  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (Fcompleting_read): New arg DEF.
	Callers changed.
	(Qminibuffer_default): New variable.
	(syms_of_minibuf): Initialize it.

	* fileio.c (Fread_file_name): Pass default to Fcompleting_read.

1997-05-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* w32fns.c (x_set_mouse_color): Update calls to x_catch_errors
	and x_uncatch_errors.

	* xfns.c (x_set_scroll_bar_width): If arg is too small, round it up.

	* window.c (Fdisplay_buffer): If we give up and try other frames,
	look again for a window in those frames already showing BUFFER.

1997-05-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xselect.c (x_reply_selection_request): Fix previous change.

1997-04-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (XTmouse_position, x_term_init): 
	Save value from x_catch_errors and pass to x_uncatch_errors.

	* xselect.c (x_own_selection, x_reply_selection_request)
	(x_get_foreign_selection):
	Save value from x_catch_errors and pass to x_uncatch_errors.

	* xfns.c (x_real_positions, x_set_mouse_color, Fx_list_fonts):
	Save value from x_catch_errors and pass to x_uncatch_errors.

	* xterm.c (x_catch_errors): Use specpdl so can be nested.
	Use a Lisp string to as the buffer for the X message.
	(x_uncatch_errors, x_had_errors_p, x_check_errors): Related changes.
	(x_catch_errors_unwind): New function.
	(x_error_quitter): Call x_error_catcher if appropriate.
	(x_error_message_string): New variable.
	(syms_of_xterm): Defvar it.
	(x_caught_error_message): Variable deleted.
	(X_ERROR_MESSAGE_SIZE): Renamed from X_CAUGHT_ERROR_MESSAGE_SIZE.
	(x_error_handler): New function, calls x_error_quitter or ..._checker.
	(x_initialize): Use x_error_handler as error handler for X.

1997-04-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Fexpand_file_name): Check length > 0 when necessary.

1997-04-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* syntax.c (skip_chars): Fix previous change in syntax/backward case.

	* lread.c (init_lread): Don't add ../lisp to the dump-time load path.

	* buffer.c (Fbury_buffer): If buffer is in selected window, remove it.
	Otherwise, remove it from other windows.

	* fileio.c (Fsubstitute_in_file_name): Use xnm uniformly, never nm,
	when handling /~ and // at the end.

	* process.c (read_process_output): Update opoint, old_begv and old_zv
	based on actual buffer change rather than size of string.
	old_begv and old_zv are now ints.
	(status_notify): Likewise for opoint.

1997-04-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_destroy_window): Free saved_menu_event, if any.

	* frame.c (Fdelete_frame): Free FRAME_MESSAGE_BUF.

	* xrdb.c (get_user_app): Free the gethomedir value.

	* buffer.c (reset_buffer): Initialize clip_changed field.

1997-04-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (sort_args): Free the malloc'd memory.

	* fileio.c (Fwrite_region): GCPRO `start' near the beginning.

	* xfns.c (x_set_menu_bar_lines): Increment windows_or_buffers_changed.

1997-04-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* syntax.c (skip_chars): Merge mule changes back in.

1997-04-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (frame_override_unsplittable): New variable.
	(Fsplit_window): Ignore `unsplittable' if frame_override_unsplittable.
	(syms_of_window): Set up Lisp var.

	* xmenu.c (set_frame_menubar): When widget is new,
	forget records of old contents.

1997-04-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_set_offset): Turn off the code that added the border_width
	to modified_left and modified_top; it seems incorrect to do that.

1997-04-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (Faccessible_keymaps): Convert PREFIX to a vector
	at the beginning, if it has any definition.

1997-04-19  Erik Naggum  <erik@naggum.no>

	* keymap.c (describe_vector): Test for suppressed commands in
	all cases.  Call get_keyelt with two arguments.

1997-04-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* print.c (print): Symbols like e2 and 2e are not confusing.

1997-04-17  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Fexpand_file_name): Fix expansion of "/foo/../".

1997-04-15  Ken'ichi Handa  <handa@etl.go.jp>

	* coding.c (setup_coding_system): Setup coding->eol_type as LF
	for a invalid coding system.

1997-04-14  Ilya Zakharevich  <ilya@math.ohio-state.edu>

	* dired.c (Fdirectory_files): Set re_match_object.

	* intervals.c (update_interval): New function.

	* intervals.h (update_interval): New function declaration.

	* regex.c (PTR_TO_OFFSET): New macro.
	(POS_AS_IN_BUFFER): New macro.
	(SYNTAX_ENTRY_VIA_PROPERTY): Set to take `syntax-table' text
	property into account when doing SYNTAX (c).
	(re_compile_fastmap): disable fastmap if any of wordbound
	notwordbound wordbeg wordend notsyntaxspec syntaxspec are seen.
	(re_search_2): SETUP_SYNTAX_TABLE_FOR_OBJECT at the start.
	(re_match_object): New variable.
	(re_match_2): SETUP_SYNTAX_TABLE_FOR_OBJECT at the start.
	(re_match_2_internal): For any of wordbound notwordbound wordbeg
	wordend notsyntaxspec syntaxspec call UPDATE_SYNTAX_TABLE before
	doing SYNTAX (c).

	* regex.h (re_match_object): New variable.

	* search.c (looking_at_1): Set re_match_object.
	(string_match_1): Set re_match_object.
	(fast_string_match): Set re_match_object.
	(Fskip_chars_forward): Move to syntax.c.
	(Fskip_chars_backward): Move to syntax.c.
	(Fskip_syntax_forward): Move to syntax.c.
	(Fskip_syntax_backward): Move to syntax.c.
	(skip_chars): Move to syntax.c.
	(search_buffer): Set re_match_object.
	(syms_of_search): Move initialization of skip* to syntax.c.

	* syntax.c (SYNTAX_ENTRY_VIA_PROPERTY): Set to take `syntax-table'
	text property into account when doing SYNTAX (c).
	(ST_COMMENT_STYLE, ST_STRING_STYLE): New codes to denote
	delimiters for new types of strings and comments.
	(Vparse_sexp_lookup_properties): New variable.
	(struct lisp_parse_state): Comment updated.
	(gl_state): New global variable.
	(update_syntax_table): New function.
	(char_quoted): Move earlier, update gl_state when needed.
	(find_defun_start): Update gl_state when needed.
	(back_comment): New function.
	(Scomment_fence, Sstring_fence): New delimeter char classes
	denoted by `!' and `|'.
	(Fchar_syntax, Fmatching_paren): Update gl_state to whole-buffer state.
	(scan_words): Update gl_state when needed.
	(Fskip_chars_forward): Move from search.c.
	(Fskip_chars_backward): Move from search.c.
	(Fskip_syntax_forward): Move from search.c.
	(Fskip_syntax_backward): Move from search.c.
	(skip_chars): Move from search.c.
	(Fforward_comment, scan_lists): Update gl_state when needed.
	Handle Scomment_fence, Sstring_fence.
	(Fbackward_prefix_chars) update gl_state when needed.
	(scan_sexps_forward): update gl_state when needed.
	Handle Scomment_fence, Sstring_fence.
	If comment_stop==-1, stop at start or end of comment or string.
	(Fparse-partial-sexp): Doc fix.
	(syms_of_syntax): Move initialization of skip* from search.c.

	* syntax.h (enum syntaxcode):
	New members Scomment_fence, Sstring_fence.
	(SYNTAX_ENTRY): Depending on the value of SYNTAX_ENTRY_VIA_PROPERTY
	may do a lookup for syntax table in gl_state.
	(UPDATE_SYNTAX_TABLE_FORWARD, UPDATE_SYNTAX_TABLE_BACKWARD,
	UPDATE_SYNTAX_TABLE, SETUP_SYNTAX_TABLE,
	SETUP_SYNTAX_TABLE_FOR_OBJECT): New macros.
	(struct gl_state_s): New struct.

	* textprop.c: Style of comments corrected. 
	(interval_of): New function.

1997-04-14  Eli Zaretskii  <eliz@wombat.gnu.ai.mit.edu>

	* w16select.c: New file, MS-Windows clipboard support from
	Emacs running as MSDOS application.
	
	* s/msdos.h (SYMS_SYSTEM): Add `syms_of_win16select'.

        * Makefile.in (MSDOS_OBJ): Add w16select.o.
	(dependencies): Add dependencies for w16select.o.

1997-04-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* undo.c (Fprimitive_undo): When inserting, always insert
	after markers (the ordinary kind of insertion).

	* insdel.c (adjust_markers): Don't be confused by the gap
	when computing the arg to record_marker_adjustment.

1997-04-11  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* category.c (Fmodify_category_entry): Delete second arg in call
	to make_sub_char_table.

	* lisp.h (DOWNCASE): Return int, not Lisp_Object.
	(UPPERCASEP): Use DOWNCASE.
	(UPCASE_TABLE): New macro.
	(NOCASEP, UPCASE1): Use UPCASE_TABLE.
	[!NO_UNION_TYPE] (make_number): Declare.

1997-04-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (read_minibuf): Get the string from the minibuffer
	even if the user has selected a different buffer.

	* fileio.c (Finsert_file_contents): Do call signal_after_change
	when REPLACE is handled by reading directly from the file.
	Use insert_1 to insert replacement text, to avoid
	query about whether to modify the buffer.
	
1997-04-10  Marcus G. Daniels  <marcus@cathcart.sysc.pdx.edu>

	* Makefile.in (mallocobj): Make non-REL_ALLOC configuration work
	with glibc's malloc--do use vm-limit.o.

1997-04-10  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* cmds.c (internal_self_insert): Fix return value.
	* category.c (Fmake_category_set): Use XSETFASTINT.
	* minibuf.c (scmp): Fix Lisp_Object/integer confusion.
	(Fdisplay_completion_list): Likewise.
	* insdel.c (Fcombine_after_change_execute): Likewise.
	* xselect.c (expect_property_change): Likewise.
	* xterm.c (construct_menu_click, note_mouse_highlight): Likewise.
	(fast_find_position): Likewise.
	* ccl.c (ccl_driver): Likewise.
	* coding.c (Ffind_coding_system): Likewise.
	* charset.c (Fconcat_chars, ONE_BYTE_CHAR_WIDTH): Likewise.
	* xmenu.c (Fx_popup_menu, set_frame_menubar): Likewise.
	* disptab.h (DISP_TABLE_P): Likewise.
	* xdisp.c (display_text_line): Likewise.
	* dispnew.c (Fframe_or_buffer_changed_p): Likewise.
	* window.c (Fset_window_buffer, Fdisplay_buffer): Likewise.
	(delete_window): Don't return value from void function.

1997-04-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/freebsd.h (BSD_SYSTEM): Alternate definition for FreeBSD v3.

	* systty.h (GETPGRP_NO_ARG): If Glibc 2.1 or later,
	don't define this if _BSD_SOURCE is defined.

1997-04-08  Marcus G. Daniels  <marcus@cathcart.sysc.pdx.edu>

	* emacs.c (malloc_get_state, malloc_set_state): New declarations.
	(main): Restore internal malloc state when loading from dumped image.
	(Fdump_emacs): Copy internal malloc state for dumping, then free it.

	* alloc.c: For glibc's malloc, include <malloc.h> for mallinfo,
	mallopt, struct mallinfo, and mallopt constants.
	(BYTES_USED): New macro.
	(memory_full, emacs_blocked_free): Replace _bytes_used with BYTES_USED.
	(emacs_blocked_malloc): Set sbrk padding value for glibc, as is
	done with gmalloc.
	(allocate_vectorlike, make_uninit_string):
	Prevent using mmap for possible large chunks.
	(init_alloc_once): Set trim and mmap malloc parms, when using glibc.

	* config.in (DOUG_LEA_MALLOC): Add #undef.
	
	* Makefile.in (mallocobj): Don't add gmalloc if using glibc.
	Drop check for `old malloc'; it isn't distributed with Emacs.

1997-04-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* casetab.c (init_casetab_once): Initialize the purpose slot.

1997-04-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keyboard.c (read_key_sequence): New argument FIX_CURRENT_BUFFER.
	Restore the current buffer from selected window on occasion.
	All callers changed.

1997-04-07  Kenichi HANDA  <handa@etl.go.jp>

	* Makefile.in (lisp, shortlisp): Include english.elc and
	tibetan.elc.

	* alloc.c (Fmake_char_table): Adjusted for the new structure of
	Lisp_Char_Table.
	(make_sub_char_table): New function.

	* category.c (category-table-p): Check only type and purpose.
	(copy_category_table, Fmodify_category_entry): Adjusted for the
	new structure of Lisp_Char_Table.

	* ccl.c: (ccl_driver): Fix bug of the case CCL_WriteArrayReadJump.

	* charset.h (CHARSET_TABLE_ENTRY): Handle ASCII charset correctly.
	(SPLIT_NON_ASCII_CHAR, SPLIT_CHAR): Return -1 in C2 for DIMENSION1
	characters.

	* charset.c (non_ascii_char_to_string, update_charset_table,
	Fsplit_char): Adjusted for the above change.

	* coding.c (detect_coding_iso2022, detect_coding_mask): Ignore
	invalid ESC sequence for ISO 2022.
	(Fencode_sjis_char, Fencode_big5_char): Adjusted for the change of
	SPLIT_CHAR.

	* data.c (Faref, Faset): Adjusted for the new structure of
	Lisp_Char_Table.

	* disptab.c (disp_char_vector): Extern it.
	(DISP_CHAR_VECTOR): Handle multibyte characters.

	* fns.c (copy_sub_char_table): New function.
	(Fcopy_sequence): Call copy_sub_char_table for copying a sub char
	table.
	(Fchar_table_range, Fset_char_table_range, map_char_table,
	Fmap_char_table): Handle multibyte characters correctly.

	* fontset.c (Vhighlight_wrong_size_font, Vclip_large_size_font):
	New variables.
	(syms_of_fontset): Declare them as Lisp variables.

	* fontset.h (Vhighlight_wrong_size_font, Vclip_large_size_font):
	Extern them.

	* keymap.c (describe_vector): Adjusted for the new structure of
	Lisp_Char_Table.

	* lisp.h (CHAR_TABLE_STANDARD_SLOTS): Now 4 more slots than
	CHAR_TABLE_ORDINARY_SLOTS for top, defalt, parent, and purpose.
	(SUB_CHAR_TABLE_ORDINARY_SLOTS, SUB_CHAR_TABLE_STANDARD_SLOTS):
	New macros.
	(CHAR_TABLE_REF, CHAR_TABLE_SET): Enclose args by parenthesis.
	(struct Lisp_Char_Table): New member `top'.  The member `defalt'
	is moved before `contents' so that XCHAT_TABLE (val)->defalt can
	also be used for a sub char table.
	(SUB_CHAR_TABLE_P): New macro.
	(make_sub_char_table): Extern it.

	* lread.c (read1): Adjusted for the new structure of
	Lisp_Char_Table.

	* print.c (print): Likewise.

	* xdisp.c (disp_char_vector): New function to be used from the
	macro DISP_CHAR_VECTOR for multibyte characters.

	* xterm.c (dumpglyphs): Clip and highlight glyphs displayed with
	fonts of wrong size.

Sun Apr  6 10:26:53 1997  Eli Zaretskii  <eliz@wombat.gnu.ai.mit.edu>

	* emacs.c (init_cmdargs) [MSDOS]: Make the change that sets
	`installation-directory' if `info' is found as its subdirectory or
	sibling, be conditioned on MSDOS (it makes trouble on Unix).


1997-04-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* coding.c (Ffind_coding_system): Doc fix.

1997-04-03  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* fns.c (Fcopy_sequence): Delete unused variable.
	(Fchar_table_extra_slot, Fset_char_table_extra_slot): Doc fix.
	(map_char_table): When expanding indices, don't increase depth;
	that's amount used, not amount allocated.

	* category.h [!__GNUC__] (CATEGORY_SET): Fix syntax error.

	* lisp.h (CHAR_TABLE_REF): Fix syntax error.
	(LOWERCASEP): Use NOCASEP instead of its expansion.
	(UPCASE): Use UPPERCASEP instead of its expansion.

1997-04-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Finsert_file_contents): When handling REPLACE,
	first try comparing block by block; if we discover a need for
	nontrivial code conversion, give up and try convert-whole-file method.

	* fileio.c (Fcopy_file): Fix error message.

	* fileio.c (Finsert_file_contents): Handle non-regular files.

1997-04-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* search.c (skip_chars): Make `c' an unsigned int.

1997-04-01  Erik Naggum  <erik@naggum.no>

	* eval.c (Fuser_variable_p): If not a symbol, return nil.

1997-03-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Fcopy_file): Use Qfile_date_error if can't set file date.
	(Qfile_date_error): New variable.
	(syms_of_fileio): Set it up.
	(Fcopy_file): Fix previous change.
	(Finsert_file_contents): Determine the character coding
	before we see if REPLACE can be handled.
	Do handle REPLACE even if code conversion is needed. 

1997-03-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (Faccessible_keymaps): When metizing, convert a
	string to a vector.  But don't metize a character that is
	part of PREFIX.

	* window.c (Qwindow_configuration_change_hook): New variable.
	(Vwindow_configuration_change_hook): New variable.
 	(syms_of_window): Initialize; set up Lisp var.
	(delete_window): New subroutine, from Fdelete_window.
	Most callers changed.
	(Fdelete_window): Call Vwindow_configuration_change_functions.
	(Fset_window_buffer, Fenlarge_window, Fshrink_window):
	Call the Vwindow_configuration_change_functions.
	(Fset_window_configuration): Likewise.

	* dispnew.c (change_frame_size_1): Call Fset_window_buffer,
	so that Vwindow_configuration_change_hook gets run.

1997-03-25  Erik Naggum  <erik@naggum.no>

	* process.c (Fopen_network_stream): Use same socket for in and out.

1997-03-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* frame.c (frames_bury_buffer): New function.
	* buffer.c (Fbury_buffer): Call frames_bury_buffer.

1997-03-22  Mark W. Eichin  <eichin@kitten.gen.ma.us>

	* keyboard.c (make_lispy_event): Use iso_lispy_function_keys for
	XK_ISO_* keys found in XFree86. 
	(ISO_FUNCTION_KEY_OFFSET): New macro.
	(iso_lispy_function_keys): New table.
	
	* xterm.c (XTread_socket): Accept XK_ISO_* keys.

1997-03-19  Kenichi Handa  <handa@etl.go.jp>

	* xterm.c (dumpglyphs): Set a clipping region when we draw glyphs
	with a font of inappropriate size.
	(x_list_fonts): Try alternative fonts if we can't find a font of an
	appropriate size.

	* fontset.c (Valternative_fontname_alist): New variable.
	(syms_of_fontset): Declare Lisp variable alternative-fontname-alist.

	* fontset.h (Valternative_fontname_alist): Extern it.

	* term.c (insert_glyphs): Fix a bug which turns up when
	TS_ins_multi_chars is 0.

1997-03-18  Kenichi Handa  <handa@etl.go.jp>

	* xterm.c (x_list_fonts): Comment about cached font list added.

	* fns.c (map_char_table): Handle multibyte characters.

	* lisp.h (CHAR_TABLE_ORDINARY_SLOTS): Change to 384 (== 256 + 128).
	(CHAR_TABLE_STANDARD_SLOTS): Adjusted for the above change.
	(CHAR_TABLE_SINGLE_BYTE_SLOTS): New macro.
	(CHAR_TABLE_REF, CHAR_TABLE_SET): New macros.

	* data.c (Faref, Faset): Adjusted for the above change.

	* syntax.h (SET_RAW_SYNTAX_ENTRY, SYNTAX_ENTRY): Likewise.

	* category.h (CATEGORY_SET): Likewise.

	* category.c (Fmodify_category_entry): Likewise.

	* keymap.c (describe_vector): Likewise.
	(push_key_description): A key code less than 512 is printed with 3
	octal numbers.  Print only entries of valid charsets.

	* disptab.h (GLYPH_FOLLOW_ALIASES): Assure that the resulting G
	contains valid character code.

	* xdisp.c (copy_part_of_rope): Declare glyph as type GLYPH.  For a
	invalid character code, use ' ' (space).
	(display_string, display_text_line): Check validity of character
	code before calling fix_glyph.

	* term.c (encode_terminal_code): Check validity of character code.

	* charset.h (MAX_CHARSET): Definition changed to the actual
	maximum valid charset.
	(MAX_CHAR): New macro.

	* charset.c, coding.h, coding.c, fontset.h, fontset.c, xselect.c:
	Adjusted for the above change.

	* charset.c (str_cmpchar_id): Return -1 if we have no more room
	for a new composite character.
	(Fmake_char_internal): Docstring is moved to lisp/mule.el.

	* fontset.h (struct font_info): Typo in comment of
	`relative_compose' fixed.

1997-03-14  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* window.c (change_window_height): Handle shrink as well as enlarge.

1997-03-13  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* buffer.c (reset_buffer): Initialize display_count slot.

	* search.c (Freplace_match): Give error if
	NEWTEXT uses backslash in an invalid way.

1997-03-10  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* lisp.h (FAST_MAKE_GLYPH): Don't cast CHAR arg; character codes
	are now wider than C chars.

1997-03-09  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* buffer.c (Fkill_buffer): Call frames_discard_buffer.
	(record_buffer): Move buffer to front of frame_buffer_list.
	(Fother_buffer): Use frame_buffer_list.

	* frame.h (struct frame): New field buffer_list.

	* frame.c (frame_buffer_list, set_frame_buffer_list): New functions.
	(store_frame_param): Handle buffer-list parameter.
	(Qbuffer_list): New variable.
	(syms_of_frame_1): Initialize it.
	(make_frame): Initialize buffer_list field.
	(Fframe_parameters): Handle buffer-list parameter.
	(frames_discard_buffer): New function.
	(make_frame): Initialize buffer_list.

	* alloc.c (mark_object): Mark the buffer_list field.

1997-03-05  Ken'ichi Handa  <handa@etl.go.jp>

	* coding.c (decode_eol): Fix bug of converting CRLF to LF.

1997-03-05  NIIBE Yutaka  <gniibe@mri.co.jp>

	* indent.c: (compute_motion): When POS >= TO, don't call
	find_before_next_newline as it assumes POS < TO.

1997-03-02  Ken'ichi Handa  <handa@etl.go.jp>

	* category.h (CATEGORY_SET): Cast arg C to
	`unsigned char' before indexing category table directly.

1997-03-01  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): If wait_for_cell,
	ignore subprocess input and respond only to keyboard.
	(non_process_wait_mask): New variable.
	(add_keyboard_wait_descriptor): Update it.
	(delete_keyboard_wait_descriptor): Update it.
	(init_process): Initialize it.

1997-03-01  NIIBE Yutaka  <gniibe@mri.co.jp>

	* gmalloc.c [__GLIBC__ >= 2]: Don't declare __getpagesize.

1997-02-28  Tomohiko MORIOKA  <morioka@jaist.ac.jp>

	* coding.c (create_process, Fopen_network_stream): Typo in indexes
	of array proc_encode_coding_system fixed.

1997-02-28  Kenichi HANDA  <handa@etl.go.jp>

	* Makefile.in (lisp, shortlisp): Add lao.elc.

	* buffer.c (init_buffer_once): Make member
	enable_multibyte_characters of struct buffer not always local.
	(reset_buffer): Do not reset b->enable_multibyte_characters.
	(syms_of_buffer): Declare default-enable-multibyte-characters.

	* category.h (CATEGORY_SET): For a composite character, return
	category set of the first component.

	* ccl.c (Fregister_ccl_program): Escape newlines in docstring.

	* coding.h (struct iso2022_spec): Member requested_designation is
	changed to array of `char' just for saving memory.
	(CODING_FLAG_ISO_INIT_AT_BOL, CODING_FLAG_ISO_DESIGNATE_AT_BOL):
	New macros.

	* coding.c (setup_coding_system): Now, flags of ISO2022 coding
	systems contains charsets instead of charset IDs.  Correct setting
	coding->symbol and coding->eol_type.  The performance improved.
	(encode_coding) : Fix typo ("=" -> "==").
	(detect_coding_iso2022, decode_coding_iso2022): Make the code
	robust against invalid SI and SO.
	(ENCODE_RESET_PLANE_AND_REGISTER): Argument `eol' is deleted.
 	Don't call ENCODE_DESIGNATION if nothing designated initially.
	(encode_designation_at_bol) New function.
	(encode_coding_iso2022): Handle CODING_FLAG_ISO_INIT_AT_BOL and
	CODING_FLAG_ISO_DESIGNATE_AT_BOL.
	(detect_coding_iso2022): Detect coding-category-iso-8-2 more
	precisely.
	(Ffind_coding_system, syms_of_coding): Escape newlines in
	docstring.
	
	* charset.h (INC_POS, DEC_POS): Don't increase or decrease too
	much if there's binary code (invalid character code).

	* data.c (Faref, Faset): Handle a composite char correctly in
	char-table.

	* disptab.h (DISP_CHAR_VECTOR): Allow bare 8-bit in display-table.

	* charset.c (Fcmpchar_cmp_rule): Escape newlines in docstring.

	* editfns.c (Fuser_full_name): Likewise.

	* fileio.c (Finsert_file_contents, Fwrite_region): Do not perform
	character code conversion if enable-multibyte-characters is nil.

	* fontset.h (Vuse_default_ascent): Extern.

	* fontset.c (syms_of_fontset): Intern Qfontset.  Declare new lisp
	variable use-default-ascent.
	(Vuse_default_ascent): New variable.
	(Ffont_info): Return also the value of default-ascent of a font.
	(fs_load_font): Disable updating fontsetp->height by non-ASCII
	character sets.  This should be enabled when Emacs supports
	variable height lines.
	(fs_load_font, Fset_fontset_font): Bug fix to cope
	with the change of charsets to symbols.

	* keymap.c (describe_vector): Do not describe deeper char-table if
	enable-multibyte-characters is nil.

	* process.c (proc_decode_coding_system,
	proc_encode_coding_system): Changed to array of pointers to struct
	coding_system to reduce the size of dumped Emacs.
	(create_process, Fopen_network_stream): Allocate them dynamically.
	(init_process): Initialize these pointers to NULL.
	(Fstart_process, Fopen_network_stream): Do not perform character
	code conversion if enable-multibyte-characters is nil.

	* search.c (skip_chars): If enable-multibyte-characters is nil,
	don't handle multibyte characters.

	* syntax.h (SET_RAW_SYNTAX_ENTRY, SYNTAX_ENTRY): Cast arg C to
	`unsigned char' before indexing syntax table directly.

	* syntax.c (init_syntax_once): Add trick to avoid compiler warning
	of "comparison is always 1 ...".
	(describe_syntax): Handle the case that the argument VALUE is
	char-table.

	* xdisp.c (display_mode_line): Avoid error while compiling with
	--with-x=no.

	* xfns.c (syms_of_xfns): Documentation of
	x-pixel-size-width-font-regexp modified.

	* xselect.c (lisp_data_to_selection_data, selection_data_to_lisp_data):
	Remove prefix "coding-system-" from coding system symbol names.

	* xterm.h (struct x_display_info): New member
	Xatom_MULE_DEFAULT_ASCENT.

	* xterm.c (dumpglyphs): Pay attention to characters registered in
	use-default-ascent.  Fill background in advance if font has
	non-zero _MULE_BASELINE_OFFSET property.
	(x_load_font, x_term_init): Handle font property
	_MULE_DEFAULT_ASCENT.

1997-02-28  NIIBE Yutaka  <gniibe@mri.co.jp>

	* sysdep.c: `ospeed' should be short if not HAVE_TERMIO_H.

	* xdisp.c (display_text_line): Correct displaying multi-column
	binary data.
	(try_window_id): Display blank lines from the next line, when
	xp.bufpos == ZV.  (This bug is introduced by changes of Mule).
 	Compare height against xp.vpos instead of xp.bufpos.

1997-02-27  Erik Naggum  <erik@naggum.no>

	* lread.c (Fload): Call Vload_source_file_function with 4 args.

1997-02-22 Tsugutomo ENAMI  <enami@ba2.so-net.or.jp>

	* regex.c: Include charset.h and category.h

	[!emacs] (BASE_LEADING_CODE_P, WORD_BOUNDARY_P,	CHAR_HEAD_P,
	SINGLE_BYTE_CHAR_P, SAME_CHARSET_P, MULTIBYTE_FORM_LENGTH,
 	STRING_CHAR_AND_LENGTH, GET_CHAR_AFTER_2, GET_CHAR_BEFORE_2):
	New dummy macros.

	(enum re_opcode_t): New member categoryspec and
	notcategoryspec.

	(STORE_CHARACTER_AND_INCR, EXTRACT_CHARACTER,
	CHARSET_LOOKUP_RANGE_TABLE_WITH_COUNT,
	CHARSET_LOOKUP_RANGE_TABLE, CHARSET_BITMAP_SIZE,
	CHARSET_RANGE_TABLE_EXISTS_P, CHARSET_RANGE_TABLE
	CHARSET_PAST_RANGE_TABLE): New macros.

	(TRANSLATE): Cast return value to unsigned char, not char.

	(struct range_table_work_area): New structure.

	(EXTEND_RANGE_TABLE_WORK_AREA, SET_RANGE_TABLE_WORK_AREA,
	FREE_RANGE_TABLE_WORK_AREA, CLEAR_RANGE_TABLE_WORK_USED,
	RANGE_TABLE_WORK_USED, RANGE_TABLE_WORK_ELT): New macros.
	(FREE_STACK_RETURN): Call FREE_RANGE_TABLE_WORK_AREA.

	(regex_compile): Declare `c' and `c1' as int to store
	multibyte characters.
	Declare range_table_work and initialize	it.
	Initialize bufp->multibyte to 0 if not emacs.
	For case '[' and `default', code re-written to handle
	multibyte characters.
	Add code for case 'c' and 'C' to handle category spec.

	(re_compile_fastmap): New local variables k, simple_char_max,
	and match_any_multibyte_characters.
	Use macro CHARSET_BITMAP_SIZE.
	Handle multibyte characters in cases charset, charset_not,
	wordchar, notwordchar, anychar, syntaxspec, notsyntaxspec,
	categoryspec, notcategoryspec.

	(STOP_ADDR_VSTRING, POS_ADDR_VSTRING): New macros.

	(re_search_2): Code re-written to handle multibyte characters.

	(AT_WORD_BOUNDARY): Macro disabled.

	(re_match_2_internal): New local variable multibyte.  `d' is
	incremented while paying attention to multibyte characters if
	necessary.
	For case charset, charsetnot, wordbound, notwordbound,
	wordbeg, wordend, matchsyntax, and matchnotsyntax, code
	re-written to handle multibyte characters.
	Add code for case categoryspec and notcategoryspec.
	 
	* regex.h (struct re_pattern_buffer): New member multibyte.

1997-02-21  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* window.c (Fset_window_buffer): Increment display_count
	if it is an integer.

	* buffer.c (init_buffer_once): Set up display_count.
	(syms_of_buffer): Set up Lisp variable.

	* buffer.h (struct buffer): New field display_count.

1997-02-20  NIIBE Yutaka  <gniibe@mri.co.jp>

	* dispnew.c (direct_output_forward_char): #if-0-out redundant
 	check against truncated text at end of line.
	Add giving-up for buffers with reverse direction.
	(remake_frame_glyphs): Use FRAME_MESSAGE_BUF_SIZE
 	instead of FRAME_WIDTH, as the message may include multi-byte
 	character and the length may be longer than width.
	(width_run_cache_on_off): Disable width-run-cache when
 	multi-byte characters are enabled.
	(skip_invisible): Don't put the boundary in the middle of
 	multibyte characters.

	* indent.c (current_column_bol_cache): New variable.  This makes
 	move_to_column faster.
	(current_column): Set current_column_bol_cache.
	(current_column_1): Likewise.
	(Fmove_to_column): Use current_column_bol_cache.

	* xdisp.c (display_text_line): Introduce new local variable
	rev_dir_bit to display right to left characters (not yet used).
	* xdisp.c (message): Use FRAME_MESSAGE_BUF_SIZE.
	(redisplay_internal): Add canceling code for continuation at
 	wide-column.
	(display_text_line): Don't just decrement left_edge->bufpos,
	it may be multi-byte character, use DEC_POS instead.

1997-02-20  NIIBE Yutaka  <gniibe@mri.co.jp>

	Handle multi-byte and wide-column character in computing columns.
 	Note that we will find the continuation (linebreak) _AFTER_ it
 	occurs.

	* indent.c (current_column): When the buffer may have multi-byte
 	characters, call current_column_1.
	(compute_motion): Handle multi-byte characters.
	(current_column_1): Likewise.
	(Fmove_to_column): Likewise.

1997-02-20  NIIBE Yutaka  <gniibe@mri.co.jp>

	Tab offset calculation changes.  We need this change because the
 	line may be less than WIDTH columns because of wide-character
 	continuation.

	* indent.h (struct position): New member tab_offset to accumulate
	tab offset.

	* xdisp.c (try_window): Change the way of calculation of tab
 	offset.  We now use val.tab_offset to maintain tab offset.
  	Removed local variable tab_offset.
	(try_window_id): Likewise.

	* indent.c: Include "charset.h".
	(compute_motion): Remove the variable PREV_VPOS.
	Introduce new local variables (multibyte, wide_column, prev_pos,
 	contin_hpos, prev_tab_offset) to handle multi-byte characters and
 	wide-column characters.

	(pos_tab_offset): Return COL (Modulo is no longer valid).
	Add the line to set tab_offset member.
	Use pos.tab_offset.

1997-02-20  NIIBE Yutaka  <gniibe@mri.co.jp>

	* window.c (Fpos_visible_in_window_p): Bug fix.  Specify big
 	negative number for the argument TOHPOS of compute_motion.
	We don't need to calculate to (HPOS==0), but can stop immediately
	when VPOS pasts HEIGHT.
	* xdisp.c (redisplay_window): Likewise.
	(try_window_id): Likewise.

	* indent.c (pos_tab_offset): Specify "- (1 << (BITS_PER_SHORT - 1))"
 	to express big negative number (for consistency with xdisp.c).

1997-02-20  NIIBE Yutaka  <gniibe@mri.co.jp>

	* indent.c (vmotion): Specify "1 << (BITS_PER_SHORT - 1)" to
 	express "Don't care".
	* xdisp.c (tri_window_id): Likewise.

	* dispnew.c (direct_output_forward_char): Bug fix.  Add
	XFASTINT (w->left) for losing cursor check.

1997-02-20  Kenichi HANDA  <handa@etl.go.jp>

	* Makefile.in: The following changes are for new source codes
	related to Mule.
 	(XOBJ): Include fontset.o.
	(obj): Include charset.o, coding.o, category.o, and ccl.o.
	(lisp, shortlisp): Include Mule related elc files.
	(buffer.o, cmds.o, dispnew.o, doprnt.o): Depend on charset.h.
	(editfns.o, indent.o, insdel.o, keymap.o): Depend on charset.h.
	(minibuf.o, xdisp.o, xfaces.o, xselect.o): Depend on charset.h.
	(data.o, print.o, lread.o): Depend on charset.h.
	(callproc.o, fileio.o, process.o, term.o): Depend on charset.h and
	coding.h.
	(regex.o, search.o, syntax.o): Depend on charset.h and category.h.
	(fontset.o): Depend on charset.h and fontset.h.
	(xterm.o): Depend on charset.h, ccl.h, and fontset.h.
	(category.o, ccl.o, charset.o, coding.o, fontset.o): New targets.

	* alloc.c (Fmake_char_table): Typo in doc-string fixed.	 Handle
	the case that PURPOSE is nil (in a deeper char-table).
	(Fmake_bool_vector): Make correct size of Lisp_Object for
	bool-vector.

	* buffer.c: Include charset.h.
	(Fget_buffer_create): Allocate an extra byte for a buffer, and
	make it always 0 for anchoring.
	(reset_buffer): Handle a new member `enable_multibyte_characters'
	in the struct buffer.
	(fix_overlay_before): New function.
	(init_buffer_once): Handle new members in the struct buffer.
	(syms_of_buffer): Declare new buffer local variables
	`enable-multibyte-characters' and `direction-reserved'.

	* buffer.h (BEGV_ADDR, PT_ADDR, ZV_ADDR): Use macro POS_ADDR.
	(Z_ADDR, BUF_GPT_ADDR, BUF_Z_ADDR): New macros.
	(struct buffer): New members `category_table',
	`direction_reserved', and `enable-multibyte-characters'.
	(POS_ADDR): New macro used at all places instead of &FETCH_CHAR.
	(FETCH_BYTE): New macro used at any places to check the argument
	against an ASCII character.
	(FETCH_MULTIBYTE_CHAR): New macro used at any places to get a
	character code of the argument when it is known to be a multibyte
	character.
	(_fetch_multibyte_char_p, _fetch_multibyte_char_len): New
	variables.
	(FETCH_CHAR): Use macros FETCH_MULTIBYTE_CHAR and FETCH_BYTE.

	* callint.c (doc-string of `interactive'): Describe new code
	letters `i', `z', and `Z'.
	(Fcall_interactively): Handle them.

	* callproc.c: Include charset.h and coding.h.
	(Fcall_process): Perform character code conversion of a process
	arguments and the process output.
	(Fcall_process_region): Encode coding of a text given to a
	process.

	* cmds.c: Include charset.h.
	(forward_point, Fforward_point): New functions.
	(Fforward_char, Fdelete_char): Handle multibyte characters by
	calling forward_point.
	(Fdelete_backward_char): Pay attention to multibyte characters
	in overwrite-mode.
	(internal_self_insert): Handle self inserting a multibyte
	character.
	(syms_of_cmds): Handle the new function Fforward_point.

	* data.c: Include charset.h.
	(Qprocess): Now extern, not static.
	(Faref, Faset): Enable indexing a char table by a multibyte
	character.

	* dispextern.h (struct face): New members `non_ascii_gc' and
	`fontset'.
	[HAVE_FACES]: New macros FACE_NON_ASCII_GC and FACE_FONTSET.

	* dispnew.c: Include charset.h.
	(update_line): Handle wide-column characters.

	* disptab.h (DISP_CHAR_VECTOR): Always return nil for multibyte
	characters.

	* doprnt.c: Include charset.h.
	(doprn1): Handle multibyte characters.

	* editfns.c: Include charset.h.
	(Fchar_to_string, Fstring_to_char): Handle multibyte characters.
	(Fsref): New function.
	(Fgoto_char): Force point to be at a character boundary.
	(Ffollowing_char, Fpreceding_char): Handle multibyte characters.
	(Fchar_after): Handle multibyte characters.
	(Fchar_before): New function.
	(general_insert_function): New function.
	(Finsert, Finsert_and_inherit, Finsert_before_markers): Use it.
	(Finsert_char): Doc-string refer to markers of
	before-insertion-type. Handle multibyte characters.
	(Fsubst_char_in_region): Handle multibyte characters.
	(Fchar_equal): Don't consider `case' of multibyte characters.
	(syms_of_editfns): Handle the new function `char-before'.

	* emacs.c (main): Call several initialization function introduced
	by Mule.

	* eval.c (init_eval_once): Increase max_lisp_eval_depth to 300.

	* fileio.c: Include charset.h and coding.h.
	(READ_BUF_SIZE): New macro.
	(Finsert_file_contents): Refer to a coding system in the docstring.
	Perform character code conversion of a text read in.
	(Fwrite_region): Refer to a coding system in the docstring.
	Setup a coding system for character code conversion.
	Pass a new arg `pre_write_conversion' (Lisp function) to
	build_annotations.
	Pass a new arg `coding' to a_write.
	(build_annotations): Handle the new arg.
	(a_write): Handle the new arg `coding' by passing it to e_write.
	(WRITE_BUF_SIZE): New macro.
	(e_write): Perform character code conversion of a text to write
	out according to the new arg `coding'.

	* fns.c (Fcopy_sequence, concat, internal_equal, Ffillarray):
	Fix a bug of miscalculation of `size_in_chars' of a bool vector.
	(Fset_char_table_range): When range is vector, make the original
	char table deeper if necessary.

	* frame.c: Include "charset.h"
	[HAVE_WINDOW_SYSTEM]: Include fontset.h.
	(make_frame): Allocate member `fontset_data' of the struct frame.
	(Fdelete_frame): Free the area for the member.

	* frame.h (struct frame): New member `fontset_data'.
	(FRAME_MESSAGE_BUF_SIZE): New macro.

	* insdel.c: Include charset.h.
	(gap_left, gap_right): Put an anchor `\0' at the end of GAP.
	(adjust_markers_for_insert): If any markers are adjusted, check
	and fix the order of overlays in overlays_before.
	(make_gap): Allocate an extra byte and set to `\0' for anchoring.
	(insert1, insert_from_buffer_1): Put an anchor `\0' at the head of
	GAP.

	* keyboard.c (command_loop_1): Pay attention to a multibyte
	character while handling forward-char and backward-char.
	[!HAVE_NTGUI && XK_kana_A] (lispy_kana_keys): New variable.
	[!HAVE_NTGUI] (lispy_function_keys): New variable.
	(make_lispy_event) [XK_kana_A]: Handle kana keys.

	* keymap.c: Include charset.h.
	(push_key_description): If enable-multibyte-characters is t, use
	octal representation for a code of range 128..255 as binary.
	(Ftext_char_description): Handle multibyte characters.
	(describe_vector): Provide prettier description of a char table
	which contains multibyte characters.

	* lisp.h (CHARACTERBITS, GLYPH_MASK_REV_DIR): New macros.
	(GLYPH_MASK_PADDING, GLYPH_MASK_FACE, GLYPH_MASK_CHAR): New macros.
	[HAVE_FACES] (FAST_MAKE_GLYPH, FAST_GLYPH_CHAR, FAST_GLYPH_FACE):
	Use CHARACTERBITS.
	[!HAVE_FACES] (FAST_MAKE_GLYPH, FAST_GLYPH_CHAR, FAST_GLYPH_FACE):
	New macros.
	[!HAVE_FACES] (GLYPH_CHAR, GLYPH_FACE): Mask appropriate bits.
	(Fcoding_system_p, Fcheck_coding_system): Declare external.
	(Fread_coding_system, Fread_non_nil_coding_system): Likewise.

	* lread.c: Include charset.h.
	(Vload_source_file_function): New variable.
	(Fload): Call Vload_source_file_function if defined while loading
	an Emacs Lisp source file.  */
	(read_multibyte): New function.
	(read_escape): Handle multibyte characters.
	(read1): Correct the value of size_in_chars of a bool vector.
	Handle the case `?' is followed by a multibyte character.
	(Vload_source_file_function): New variable.

	* minibuf.c: Include charset.h.
	(read_minibuf): Pay attention to multibyte characters in the arg
	INITIAL while handling the arg BACKUP_N.
	(scmp, Fminibuffer_complete_word): Handle multibyte characters.

	* print.c: Include charset.h.
	(printchar, strout): Handle multibyte characters.
	(print): Correct the value of size_in_chars of a bool vector.

	* process.c: Include charset.h and coding.h.
	(proc_decode_coding_system, proc_encode_coding_system): New
	variables.
	(Fstart_process, create_process, Fopen_network_stream): Setup
	coding systems for character code conversion.
	(READ_CHILD_OUTPUT): New macro.
	(read_process_output): Perform character code conversion of a
	process output.
	(send_process): Perform character code conversion of a text sent
	to a process.
	(Fset_process_coding_system, Fprocess_coding_system): New
	functions.
	(syms_of_process): Handle them.

	* process.h (struct Lisp_Process): New members
	decode_coding_system, decoding_buf, encode_coding_system, and
	encoding_buf.

	* puresize.h (BASE_PURESIZE): Increase.

	* search.c: Include category.h and charset.h.
	(compile_pattern_1): Handle new argument `multibyte'.
	(compile_pattern): Handle the flag `enable-multibyte-characters'.
	(Vascii_downcase_table): Declare external.
	(fast_string_match_ignore_case): New function.
	(skip_chars): Handle multibyte characters.
	(trivial_regexp_p): Handle regular expression "\\Cc" and "\\CC"
	for category.

	* syntax.c: Include charset.h and category.h.
	(Vsyntax_code_object): New variable.
	(Fmodify_syntax_entry): Handle multibyte characters.  A multibyte
	character in matching parenthesis is also handled correctly.  Use
	shared object in the vector Vsyntax_code_object for an ASCII
	character.
	(describe_syntax): Handle a multibyte character in matching
	parenthesis.
	(describe_syntax_1): Describe also parent syntax tables.
	(scan_words, Fforward_comment): Handle multibyte characters.
	(scan_lists, char_quoted, Fbackward_prefix_chars): Likewise.
	(scan_sexps_forward): Likewise.
	(init_syntax_once): Initialize Vsyntax_code_object.
	Initialize Vstandard_syntax_table by share objects in
	Vsyntax_code_object.
	(syms_of_syntax): Staticpro Vsyntax_code_object.

	* syntax.h (SET_RAW_SYNTAX_ENTRY): Handle syntax of multibyte
	characters.
	(SYNTAX_ENTRY_FOLLOW_PARENT): New macro.
	(SYNTAX_ENTRY): Handle syntax of multibyte characters.
	(SYNTAX, SYNTAX_WITH_FLAGS, SYNTAX_MATCH): Don't signal error even
	if a syntax entry is not cons.

	* term.c: Include charset.h and coding.h.
	(TS_end_italic_mode, TS_italic_mode, TS_bold_mode): New variables.
	(TS_end_bold_mode, TS_end_underscore_mode): New variables.
	(TS_underscore_mode): New variable.
	(encode_terminal_code): New function.
	(write_glyphs, insert_glyphs): Perform character code conversion
	on output to a terminal.
	(term_init): Initialize TS_bold_mode, TS_end_bold_mode,
	TS_end_underscore_mode, and TS_underscore_mode.

	* xdisp.c: Include charset.h, coding.h, and process.h.
	(display_text_line): Handle multibyte characters.
	(display_mode_line): Pay attention to wide-column characters.
	(decode_mode_spec_coding): New function.
	(decode_mode_spec): Handle %-constructs `%z' and `%Z' to print
	coding system mnemonics.
	(display_string): Handle multibyte characters.

	* xfaces.c: Include charset.h.
	(allocate_face, copy_face, face_eq1): Handle member `fontset' of
	struct face, i.e. initialize, copy, and check it.
	(intern_face, clear_face_cache): Handle member `non_ascii_gc' of
	struct face, i.e. initialize and free it.
	(free_frame_faces): Unload font only when fontset is not used.
	Free non_ascii_gc.
	(frame_update_line_height, merge_faces, compute_base_face): Handle
	fontset.
	(recompute_base_faces): Free non_ascii_gc.
	(Fset_face_attribute_internal): Handle fontset.

	* xfns.c: Include charset.h and fontset.h.
	(Vx_pixel_size_width_font_regexp): New variable.
	(x_set_font): Handle fontset.
	(Fx_create_frame): Create fontsets in Vglobal_fontset_alist.
	(Fx_list_fonts): Handle fontset.
	(syms_of_xfns): Initialize Vx_pixel_size_width_font_regexp.
	Setting callback functions for fontset handler.

	* xselect.c: Include charset.h and coding.h.
	(QCOMPOUND_TEXT): New variable.
	(symbol_to_x_atom): Handle it.
	(selection_data_to_lisp_data): Decode a selection data if
	selection type is TEXT or COMPOUND_TEXT.
	(lisp_data_to_selection_data): Encode a text to COMPOUND_TEXT if
	it contains multibyte characters.
	(syms_of_xselect): Initialize and staticpro QCOMPOUND_TEXT.

	* xterm.c: Include charset.h, ccl.h, and fontset.h.
	(PER_CHAR_METRIC): New macro.
	(dumpglyphs): New argument CMPCHARP.  Handle multibyte characters.
	(XTwrite_glyphs, redraw_previous_char, redraw_following_char):
	Supply argument CMPCHARP to dumpglyphs.
	(dumprectangle): Display whole glyph of wide-column characters.
	Supply argument CMPCHARP to dumpglyphs.
	(show_mouse_face): Supply argument CMPCHARP to dumpglyphs.
	(x_draw_box): Pay attention to wide-column characters.
	(x_draw_single_glyph): Supply argument CMPCHARP to dumpglyphs.
	(x_new_font): Call fs_load_font for actual font loading work.
	(x_new_fontset): New function.
	(x_get_font_info, x_list_fonts, x_load_font, x_query_font): New
	functions providing API to fontset handler.
	(x_term_init): Initialize several new members of struct x_display_info.

	* xterm.h (struct font_info): This definition is moved to
	fontset.h.
	(struct x_display_info): New members Xatom_PIXEL_SIZE,
	Xatom_MULE_BASELINE_OFFSET, Xatom_RELATIVE_COMPOSE, and null_pixel.
	(x_list_fonts, x_get_font_info, x_load_font, x_query_font):
	Declare external.
	(struct x_output): New members font_baseline and fontset.
	(FRAME_FONTSET, FRAME_X_FONT_TABLE): New macros.

	* category.h, category.c, ccl.h, ccl.c, charset.h: New files.
	* charset.c, coding.h, coding.c, fontset.h, fontset.c: New files.

1997-02-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* print.c (print): Generate a backslash in \2e10.
	
1997-02-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (change_window_height): Take size from multiple siblings,
	nearest ones first, when that can be done without deleting any of them.

1997-02-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (Fminibuffer_message): New function.
	(syms_of_minibuf): Set up Lisp function.

	* syntax.c (scan_lists): Signal errors using scan-error.
 	(syms_of_syntax): Set up Qscan_error.

1997-02-06  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (Feval_buffer): Doc fix.

1997-02-03  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (scroll_preserve_screen_position): New variable.
	(keys_of_window): Set up Lisp var.
	(window_scroll): If scroll_preserve_screen_position is 0,
	behave the old way (advancing point the minimum distance).

1997-02-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (main): Don't extend stack limit too far.

Sun Feb  2 10:36:26 1997  Eli Zaretskii  <eliz@wombat.gnu.ai.mit.edu>

	* msdos.c (dos_rawgetc): When international keyboard doesn't have
 	to be supported, recognize Alt-key combinations even if the Alt
	key is no longer pressed.

1997-01-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfns.c (Vx_resource_class): New variable.
	(syms_of_xfns): Set up Lisp variable.
	(Fx_get_resource, x_window): Use Vx_resource_class.
	(validate_x_resource_name): Ensure Vx_resource_class is a string.

1997-01-27  Paul Eggert  <eggert@twinsun.com>

	* data.c (isnan): Define even if LISP_FLOAT_TYPE is not defined,
 	since fmod might need it.
	(fmod): Ensure that the magnitude of the result does not exceed that
	of the divisor, and that the sign of the result does not disagree with
	that of the dividend.  This does not yield a
	particularly accurate result, but at least it will be in the
	range promised by fmod.
	
	* doprnt.c: Include <float.h> if STDC_HEADERS.
	(DBL_MAX_10_EXP): Define if not defined; default is IEEE double.
	(doprnt1): Allocate enough buffer space to handle very large floating
	point numbers, or very large field widths or precisions.
	Detect overflow in field widths or precisions.

1997-01-26  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* config.in (HAVE_RINT, HAVE_CBRT): Add undefs.

1997-01-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (openp): Handle remote file names in path.
	Don't use the path for an absolute name.
	(Fload): Handle openp finding a remote file name.

1997-01-25  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* floatfns.c [!HAVE_RINT] (rint): Convert macro to an actual
	function, so we can take its address.

1997-01-22  Andreas Schwab  <schwab@issan.informatik.uni-dortmund.de>

	* indent.c (pos_tab_offset): Take the width of the minibuffer
	prompt into account.
	(vmotion): In calls to compute_motion use a value for tab_offset
	that is corrected by the minibuffer prompt width.

	* xdisp.c (try_window): Remove frobnication of tab_offset in a
 	minibuffer window.
	(display_text_line): Likewise, for the taboffset parameter.

1997-01-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (Qinhibit_file_name_operation): New variable.
	(syms_of_lread): Initialize and staticpro.
	(Fload): Bind inhibit-file-name-operation to nil.

1997-01-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* eval.c (unbind_to, specbind): Use set_internal.

	* data.c (set_internal): New subroutine.  New arg BINDFLAG.
	Don't make a new buffer-local binding if BINDFLAG is 0.
	(Fset): Use set_internal.

1997-01-21  Paul Eggert  <eggert@twinsun.com>

	* editfns.c (set_time_zone_rule_tz1, set_time_zone_rule_tz2):
	Put "+" in value; needed if we are a Solaris 1 executable
	running under Solaris 2.
	Define these variables only if LOCALTIME_CACHE is defined.

1997-01-21  Eli Zaretskii  <eliz@wombat.gnu.ai.mit.edu>
		
	* msdos.c (run_msdos_command): Remove unused variables.
	(crlf_to_lf): Remove unused variables.
	(Fmsdos_downcase_filename): Remove unused variable.
	(IT_set_frame_parameters): Declare prototypes for external functions.
	(IT_set_frame_parameters): Correct format specifier.
	(IT_set_terminal_modes): Remove unused variable.
	(top level): Add header files which declare used functions.

1997-01-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (stamp-oldxmenu): New target.
	(temacs): Depend on stamp-oldxmenu, not on ${OLDXMENU}.

1997-01-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lisp.h (FAST_MAKE_GLYPH): Rename args to CHAR and FACE.
	Cast CHAR to unsigned char before using it.

	* xterm.c (dumpglyphs): Declare g as GLYPH.

1997-01-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* term.c (fatal): Print a newline at the end.
	(term_init): Calls to fatal changed.

	* eval.c (Fsignal): Call fatal if no error handlers and no catch.

	* dispnew.c (init_display): Check for overflow in screen size.
	Use `fatal'.
	
1997-01-19  Geoff Voelker  <voelker@cs.washington.edu>

	* w32.c (init_environment): Rebuild Vsystem_configuration at startup.

	* w32gui.h: Update include conditionals to use new name.

	* w32gui.h: Renamed from win32.h.
	* dispextern.h, w32term.h, makefile.nt: Use new name w32gui.h.
	* makefile.nt: Update header comment.
	
	* w32console.c (initialize_w32_display): Renamed from 
	initialize_win_nt_display.
	* term.c (term_init): Use new name initialize_w32_display.
	
	* w32.c, w32console.c, w32faces.c, w32fns.c, w32heap.c,
	w32inevt.c, w32menu.c, w32proc.c, w32select.c, w32term.c,
	w32xfns.c, win32.h, w32inevt.h, w32term.h: Change all uses of win95,
	winnt, and win32 into Windows 95, Windows NT, and W32, respectively.
	Expand "win" substring in variables referring to Microsoft Windows 
	constructs into "windows".
	Canonicalize header comments to use same terminology.

1997-01-18  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* search.c (skip_chars): Optimize by not calling SET_PT in the loop.

1997-01-16  Erik Naggum  <erik@naggum.no>

	* keymap.c (push_key_description): Print C-j, not TAB.

1997-01-16  Eli Zaretskii  <eliz@wombat.gnu.ai.mit.edu>

	* msdos.c (XMenuActivate): Don't allow non-positive menu
	coordinates.

1997-01-15  Eli Zaretskii  <eliz@is.elta.co.il>

	* keyboard.c (interrupt_signal): Make emergency exit work on MSDOS
	frames.  Block further SIGINTs while `interrupt_signal'	runs.

	* msdos.c (sigprocmask, sig_suspender): New functions, implement
	signal blocking on MSDOS.

1997-01-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/hpux9.h (HAVE_PSTAT_GETDYNAMIC): New definition.

1997-01-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* w32.c (get_emacs_configuration): Return windows95 instead of win95.

1997-01-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* dispnew.c (change_frame_size_1): Reject new sizes if they cause
	overflow.

1997-01-13  Eli Zaretskii  <eliz@is.elta.co.il>

	* emacs.c (init_cmdargs) [MSDOS]: Allow `installation-directory'
	to be set if either `lib-src' or `info' are found as its
	subdirectories or siblings.

1997-01-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fns.c (concat): Take modulus of thisindex before shifting.
	Declare thisindex as unsigned.

1997-01-12  Geoff Voelker  <voelker@cs.washington.edu>

	* w32menu.c (x-popup-menu): Pass in insist flag to mouse_position_hook.

1997-01-11  Paul Eggert  <eggert@twinsun.com>

	* floatfns.c (rounding_driver): New function for systematic support of
	2-argument rounding functions, so that `floor' isn't the only one
	that supports 2 arguments.
	(Fceiling, Ffloor, Fround, Ftruncate): Use it.
	(ceiling2, floor2, round2, truncate2, double_identity): New functions.
	(syms_of_floatfns): Define ceiling, round, and truncate even if
	LISP_FLOAT_TYPE is not defined.

1997-01-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* lread.c (read1): Round size of bool-vector properly.

	* print.c (print): Round size of bool-vector properly.

	* lread.c (read1): Fix error messages.

1997-01-09  Steve Nygard  <nygard@telusplanet.net>

	* unexnext.c: Include <mach-o/reloc.h>.
	(fgrowth): Initialize to zero.
	(vmaddr_growth, dataseg_vmaddr, dataseg_vmend): New variables.
	[NS_TARGET] (extreloff, nextrel, dysymtab, reloc_info): New variables.
	(unexec_doit): Adjust file offsets of segments that follow the
	enlarged data segment.  Adjust vmaddr of the SEG_LINKEDIT segment that
	follows the data segment.
	[NS_TARGET] (unexec_doit): Adjust file offsets in the LC_DYSYMTAB load
	command that follows the data segment.  Zero out relocation entries
	that fall within the data segment.

1997-01-07  Karl Berry  <karl@cs.umb.edu>

	* filelock.c (LOCK_PID_MAX): Use sizeof (unsigned long) instead
	of hardwiring 21.
	(lock_file_1): Use LOCK_PID_MAX when allocating lock_info_str
	instead of hardwiring 21.

1997-01-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (bright_bg): Save the original state of video blink bit.
	(maybe_enable_blinking): New function, restores the original state
	of the blink bit.
	(IT_reset_terminal_modes): Restore the original state of the blink
	bit when suspending/exiting.
	(run_msdos_command): Make sure bright background colors are again
	enabled after subsidiary program returns.

1997-01-06  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* data.c (Fset_default): For a BUFFER_OBJFWD, store into
	buffer_defaults even if mask < 0.

1997-01-04  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* keyboard.c (command_loop_1, read_char):
	Run Qecho_area_clear_hook when clearing echo area.
	(Qecho_area_clear_hook): New variable.
	(syms_of_keyboard): Initialize it.

	* buffer.c (Fpop_to_buffer): New arg NORECORD.

1997-01-04  Geoff Voelker  <voelker@cs.washington.edu>

	* w32proc.c (compare_env, merge_and_sort_env): New functions.
	(sys_spawnve): Sort environment variables for subprocess.
	(ppid_env_var_buffer): Variable deleted.

1997-01-02  Karl Berry  <karl@cs.umb.edu>

	* filelock.c (lock_info_type): Declare pid as unsigned long
	instead of int.
	(lock_file_1): Use %lu instead of %d in printf.

1997-01-01  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* cmds.c (internal_self_insert): Check the property
	on the hook, not on the abbrev symbol.

	* dispnew.c (update_frame): Call detect_input_pending
	for X as well as for termcap frames.

1996-12-31  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* bytecode.c (HANDLE_RELOCATION): New macro.
	(MAYBE_GC): Call HANDLE_RELOCATION.  Swallow following semicolon.
	(Fbyte_code): Use HANDLE_RELOCATION.

1996-12-31  Paul Eggert  <eggert@twinsun.com>

	* s/nextstep.h, s/sco4.h (BROKEN_MKTIME): New macro.
	* Makefile.in (MKTIME_OBJ), config.in (mktime):
	Use BROKEN_MKTIME to determine whether mktime is broken.

1996-12-30  Paul Eggert  <eggert@twinsun.com>
	
	* data.c, floatfns.c: <float.h>: Include if STDC_HEADERS.
	(IEEE_FLOATING_POINT): New symbol.
	* data.c (float_arith_driver, Fmod), floatfns.c (Ffloor):
	Test for division by 0 only if ! IEEE_FLOATING_POINT.
	* floatfns.c (fmod_float): New function.

	* Makefile.in (MKTIME_OBJ): Use our mktime instead of SCO
 	3.2v4.2's, since SCO's botches time arithmetic as used by display-time.

1996-12-30  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* bytecode.c (Fbyte_code): Add error check for jumping out of range.

	* s/hiuxmpp.h, m/sr2k.h: New files.

1996-12-29  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* Makefile.in (process.o): Depend on blockinput.h.

	* process.c: Include blockinput.h.
	(create_process): Block input around the fork.

1996-12-27  Karl Berry  <karl@owl.HQ.Ileaf.COM>

	* filelock.c: Total rewrite.

1996-12-26  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* data.c (Ffset): Change argument name and doc string.
	(Fdefalias): Likewise.

1996-12-26  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* xterm.c (x_iconify_frame): Clear visible when we set iconified.

1996-12-25  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* window.c (window_scroll): Preserve vpos of point
	if we cannot preserve the actual position of it.
	Make it static.  New arg WHOLE; callers changed.
	
	* keyboard.c (read_char_x_menu_prompt): Unread and record all the
	input events from here.
	(record_menu_key): New subroutine.

	* xmenu.c (single_keymap_panes): New arg DEPTH.
	Cut off recursion at that depth.  Callers changed.

1996-12-23 +02  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (dos_set_keyboard): Test whether KEYB.COM is installed
	for international keyboard support.
	(dos_get_modifiers): If international keyboard support is NOT
	required, make both Right and Left Alt key behave like Meta key.

1996-12-22  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* emacs.c (standard_args): Add -find-file and -visit.

	* cmds.c (internal_self_insert): If the abbrev has no expansion,
	just a hook, inhibit the insertion of the character.

	* abbrev.c (Fexpand_abbrev): Return the abbrev symbol,
	or nil if no expansion.

1996-12-20  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xdisp.c (try_window): Add error check for POS.

1996-12-19  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* s/nextstep.h (LD_SWITCH_SYSTEM): Use just -X.
	(LIB_STANDARD): Alternate definition if NS_TARGET.

	* xfns.c (x_set_title): Check data type of NAME.

	* search.c (Fmatch_data): Doc fix.

1996-12-19  Werner Benger  <werner@ast1.uibk.ac.at>

	* keyboard.c (modify_event_symbol):
	Don't index thru name_table if it is null.

1996-12-19  Erik Naggum  <erik@naggum.no>

	* process.c (read_process_output, exec_sentinel):
	* w32menu.c (set_frame_menubar):
	* xdisp.c (prepare_menu_bars, update_menu_bar):
	* xmenu.c (set_frame_menubar):
	Call Fmatch_data with new explicit arguments.

1996-12-18  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* search.c (Fmatch_data): New args INTEGERS and REUSE.

	* process.c (send_process) [EMACS_HAS_USECS]:
	When we wait for the buffer to clear, wait just .02 second.

	* intervals.c (adjust_intervals_for_insertion):
	Be smarter about when to split an interval
	for properties that are not sticky on either side.

	* intervals.h (FRONT_NONSTICKY_P): New macro.

	* intervals.c (set_point): Use virtual bounds, not real bounds,
	in the abort test for POSITION.
	Skip the intangibility test if POSITION is at either end of buffer.

1996-12-18  Jonathan I. Kamens  <jik@annex-1-slip-jik.cam.ov.com>

	* config.in (HAVE_LIBMAIL, HAVE_MAILLOCK_H, HAVE_TOUCHLOCK):
	Add #undefs.

1996-12-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Finsert_file_contents): Handle BEG and END non-nil
	when REPLACE is non-nil.

1996-12-15  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* intervals.c (merge_properties_sticky): Don't discard explicit nil
	properties.  Don't put on a front-sticky property if we inherit
	one from the category that does the job.

	* config.in (HAVE_LIMITS_H): Add #undef.

1996-12-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* intervals.c (set_point): Check for intangible properties
	on overlays.

	* textprop.c (Fnext_char_property_change): New function.
	(Fprevious_char_property_change): New function.
	(syms_of_textprop): defsubr them.

1996-12-14  Lars Magne Ingebrigtsen  <larsi@ifi.uio.no>

	* editfns.c (Fuser_full_name): Return nil if the specified user
	doesn't exist.
	(init_editfns): Set Vuser_full_name to "unknown" if the user name
	can't be resolved.

1996-12-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* strftime.c: Replace this with the version from libc.

1996-12-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfns.c (x_set_scroll_bar_width): Reject a width that's too small.

1006-12-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (syms_of_buffer): Doc fix (transient-mark-mode).

1996-12-10  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Fwrite_region): Be careful not to destroy contents of
	existing file when appending.

1996-12-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fileio.c (Fread_file_name_internal): Verify STRING is a string.
	(Fread_file_name): Don't insert DIR or INITIAL if it isn't a string.

1996-12-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/aix4-2.h: New file.

1995-12-08  Lars Magne Ingebrigtsen  <larsi@ifi.uio.no>

	* editfns.c (Fuser_full_name): Use build_string instead of make_string.

1996-12-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* callproc.c (Fcall_process_region): Define missing local `count'.

	* xdisp.c (message2_nolog): Handle minibuffer_auto_raise.

	* minibuf.c (syms_of_minibuf): Doc fix.

1996-12-07  Lars Magne Ingebrigtsen  <larsi@ifi.uio.no>

	* editfns.c (Fuser_full_name): Accept a string (the login name) as
	a parameter.  Do ampersand expansion, if required.
	(init_editfns): Use it.

1996-12-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (IT_cmgoto): Don't update FRAME_CURSOR_X when the cursor
	is in echo area.

1996-12-05  Erik Naggum <erik@naggum.no>

	* keyboard.c (syms_of_keyboard): Doc fix.

1996-11-28  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* callproc.c (Vtemp_file_name_pattern): New variable.
	(syms_of_callproc): Set up Lisp variable.
	(init_callproc): Initialize it.
	(Fcall_process_region): Use it.

	* bytecode.c (MAYBE_GC): New macro.
	(Fbyte_code): Use MAYBE_GC in every goto opcode.

1996-11-25  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* editfns.c (Fline_beginning_position, Fline_end_position): New fns.
	* cmds.c (Fend_of_line, Fbeginning_of_line):
	Use Fline_beginning_position, Fline_end_position.
	* lisp.h  (Fend_of_line, Fbeginning_of_line): Declared.

1996-11-23  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* window.c (window_scroll): Don't set w->start or w->force_start
 	if signaling an error.

	* xmenu.c (Vmenu_updating_frame): New variable.
	(syms_of_xmenu): Set up Lisp var.
	(Fx_popup_menu, set_frame_menubar): Initialize it.

1996-11-23  Erik Naggum  <erik@naggum.no>

	* keyboard.c (syms_of_keyboard): Doc fix for num-input-keys.

1996-11-22  Lars Magne Ingebrigtsen  <larsi@ifi.uio.no>

	* editfns.c (Fuser_full_name): Accept an optional UID and return
	the full name of that user instead.

1996-11-20  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32fns.c (w32_wnd_proc): Use dummy message to wake up thread on
 	quit_char.

1996-11-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c [__DJGPP__ >= 2] (dos_direct_output): Faster method of
	writing characters to the screen.
	(SCREEN_SET_CURSOR): Remove.
	(IT_display_cursor): New function, to turn the cursor on and off.
	(IT_cmgoto): New function, sets the cursor to its final position
	whenever frame update is complete.
	(internal_terminal_init): Set IT_cmgoto as the hook to be called
	when frame is up to date.
	(dos_rawgetc): Call IT_cmgoto instead of the SCREEN_SET_CURSOR
	macro (which is gone now).
	(XMenuActivate): Turn off the cursor while the menu is displayed,
	to prevent it from showing through the menu panes.

1996-11-19  Geoff Voelker  <voelker@cs.washington.edu>

	* w32.c, w32.h: Renamed from nt.c, nt.h.
	* w32heap.c, w32heap.h: Renamed from ntheap.c, ntheap.h.
	* w32inevt.c, w32inevt.h: Renamed from ntinevt.c, ntinevt.h.
	* w32proc.c: Renamed from ntproc.c.
	* w32console.c: Renamed from w32term.c.
	* unexw32.c: Renamed from unexnt.c.
	* s/ms-w32.h: Renamed from s/windowsnt.h.
	
	* dispnew.c (init_display) [HAVE_NTGUI]: Use w32 for window-system.

	* Makefile.in, callproc.c, makefile.nt: Use new names for w32 files.

1996-11-18  Geoff Voelker  <voelker@cs.washington.edu>

	* emacs.c, frame.c, frame.h, keyboard.c, nt.c, nt.h,
 	ntheap.c, ntheap.h, ntinevt.c, ntinevt.h, ntproc.c, ntterm.c,
 	termhooks.h, unexnt.c, w32faces.c, w32fns.c, w32menu.c, w32reg.c,
 	w32select.c, w32term.c, w32term.h, w32xfns.c, s/windowsnt.h:
	Change identifiers of the form win32* to w32*.

	* window.c (special-display-p, same-window-p): Add missing
	newlines and backslashes in help strings.

1996-11-12  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xdisp.c (redisplay_window): When handling scroll_conservatively,
	scroll a little farther for the sake of scroll_margin.

1996-11-11  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* abbrev.c (Fexpand_abbrev): If the abbrev's expansion is nil,
	don't expand it, but do still call the hook.
	(Fdefine_abbrev): Allow anything for EXPANSION.

	* frame.c (Fmodify_frame_parameters): Use alist in reverse order.

1996-11-10  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* process.c (status_notify): Test p->infd > 0
	before each call to read_process_output.
	(read_process_output): Handle match data properly in recursive calls.
	(exec_sentinel): Likewise.

	* window.c (window_scroll): Handle scroll_margin
	by putting point at a place that won't force recentering.

	* xdisp.c (scroll_margin): New variable.
	(init_xdisp): Set up Lisp variable.
	(redisplay_window): Implement scroll_margin; don't use old start pos
	if point is inside the margin.

1996-11-09  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* window.h (struct window): New field optional_new_start.
	* xdisp.c (redisplay_window): Handle optional_new_start.
	* window.c (Fdelete_other_windows): Set optional_new_start
	instead of force_start.

	* insdel.c (signal_after_change): If Vcombine_after_change_calls,
	save up changes in combine_after_change_list.
 	(Fcombine_after_change_execute)
	(Fcombine_after_change_execute_1): New subroutines.
	(syms_of_insdel): New function.

	* emacs.c (main): Call syms_of_insdel.

	* fns.c: Include frame.h and window.h.
	(Fy_or_n_p): Handle minibuffer_auto_raise here.

	* Makefile.in (fns.o): Depend on frame.h and window.h.

1996-11-08  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* macros.c (Fcall_last_kbd_macro): Set this_command from last_command
	on entry and again on exit.

1996-11-07  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* frame.c (Fmodify_frame_parameters): Doc fix.

	* fileio.c (USG5 or BSD_SYSTEM or LINUX): Include fcntl.h.
	(Ffile_readable_p): Return immediately if stat fails.
	Call S_ISFIFO correctly.

1996-11-06  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* editfns.c (Fencode_time): Doc fix.

1996-11-06  John F. Carr  <carrj@polaroid.com>

	* dired.c (Ffile_attributes): Represent inode number as a pair of
	integers in case inode numbers do not fit in a Lisp integer.

1996-11-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c [__DJGPP_MINOR__ == 0] (_rename): New function, a
	substitute for library low-level file-renaming function which
	works around Windows 95 bug.

1996-11-06  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* window.c (window_loop, case GET_BUFFER_WINDOW):
	Don't find any minibuffer window
	except the one that is currently in use.

1996-11-05  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* fileio.c (S_ISFIFO): Default definition (if S_IFIFO is defined).

	* editfns.c (Fencode_time): Use xfree, not free.

	* print.c (PRINTFINISH): Use xfree, not free.

1996-11-04  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xfns.c (Fx_create_frame): Look for X-resource for minibuffer.

	* alloc.c (Fgarbage_collect): Use Vhistory_length
	for truncating Vcommand_history.

	* print.c (PRINTPREPARE): Really do set free_print_buffer.

	* xdisp.c (scroll_conservatively): New variable.
	(redisplay_window): Obey it.
	(syms_of_xdisp): Set up Lisp var.

1996-11-02  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* minibuf.c (choose_minibuf_frame): Don't change selected_frame's
	selected window even if it is a minibuffer window,
	if it is active.

1996-11-01  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* print.c (PRINTDECLARE): Declare specpdl_count and free_print_buffer.
	(PRINTPREPARE): If print_buffer is nonzero,
	save its contents in a string using record_unwind_protect.
	(PRINTFINISH): Restore old print_buffer contents.
	Free it only if this PRINTPREPARE malloc'd it.
	(print): Don't call PRINTFULLP after all.
	(print_unwind): New function.

	* print.c (printchar, strout): Do QUIT for echo area output.
	(PRINTFULLP): New macro.
	(print): Exit if PRINTFULLP.
	When printing a symbol, don't save a pointer to the name.
	(PRINTFINISH): Null out print_buffer after freeing it.

1996-10-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (cancel_mouse_face): New function.  Code copied from
	x_set_window_size, fixing a bug.
	(x_set_window_size): Use cancel_mouse_face.
	(XTread_socket): When frame size has changed, call cancel_mouse_face.

	* widget.c (EmacsFrameResize): Use cancel_mouse_face.

1996-10-31  Erik Naggum  <erik@naggum.no>

	Reorganize function definitions so etags finds them.
	* abbrev.c (Finsert_abbrev_table_description).
	* editfns.c (Finsert_and_inherit_before_markers).
	* eval.c (Frun_hook_with_args, Frun_hook_with_args_until_success,
 	Frun_hook_with_args_until_failure).
	* window.c (Fcurrent_window_configuration).
	* xselect.c (Fx_own_selection_internal, Fx_get_selection_internal,
 	Fx_disown_selection_internal).

1996-10-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (main): Clear out *Messages* before init_callproc.

	* keyboard.c (command_loop_1): Update selected buffer again
	after read_key_sequence.

1996-10-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* callproc.c (init_callproc): Use dir_warning.

	* lread.c (dir_warning): New function.
	(init_lread): Use dir_warning.

1996-10-28  Erik Naggum  <erik@naggum.no>

	* alloc.c (Fmake_char_table): Doc fix.

1996-10-25  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* keymap.c (describe_buffer_bindings): Pass 1 for PARTIAL
	in some calls to describe_map_tree.

1996-10-24  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* process.c (status_notify): Update p->tick again
	just before running the sentinel, in case it dies.

1996-10-23  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* xdisp.c (decode_mode_spec): In the `L' case,
	remove a buffer from base_line_pos if window has switched buffers.

1996-10-15  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* minibuf.c (read_minibuf_unwind): Don't restore minibuf_window;
	instead call choose_minibuf_frame.
	(choose_minibuf_frame): Don't let any other frame keep its minibuf
	window selected.

	* xterm.c (XTread_socket, KeyPress case): Clear compose_status
	if the key has the meta modifier.

1996-10-14  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* eval.c (Vdebug_on_signal): Renamed from Vdebug_force.

1996-10-13  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* m/pmax.h (BROKEN_O_NONBLOCK): Define only if Ultrix.
	(LIBS_MACHINE, KERNEL_FILE): Don't define if __NetBSD__.
	(C_SWITCH_X_MACHINE): Define only if Ultrix.
	[__NetBSD__] (START_FILES, CANNOT_DUMP): New definitions.
	[__NetBSD__] (RUN_TIME_REMAP, UNEXEC): Undef them.

	* m/mips.h (UNEXEC): Undef before defining.

	* fileio.c (Fexpand_file_name):
	No longer discard .../ before another / or ~.
	That is now only in Fsubstitute_in_file_name.

1996-10-12  Simon Marshall  <simon@duality.gnu.ai.mit.edu>

	* data.c (Fdefine_function): Function definition deleted.
 	(syms_of_data): Don't call defsubr for it.

1996-10-12  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.c (XTwrite_glyphs, XTclear_end_of_line, XTclear_frame)
	(clear_cursor, x_display_bar_cursor, x_display_box_cursor)
	(x_set_window_size): Use phys_cursor_on field in frame.
	(x_update_cursor): Negative phys_cursor_x no longer means anything.

	* frame.h (struct frame): New field phys_cursor_on.

1996-10-08  David Kågedal  <davidk@lysator.liu.se>

	* xmenu.c (Fx_popup_menu): Give the menu a title when the menu is
 	a single keymap.

1996-10-07  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* s/ptx.h (POSIX_SIGNALS): New definition.

	* dispnew.c (init_display): If not yet initialized,
	we can't really use X, so we must do the real work.

1996-10-06  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xdisp.c (display_text_line): New arg ovstr_done.  (Callers changed).
	Ignore that many chars from start of overlay strings.
	Return updated value in ovstring_chars_done field.

	* indent.c (vmotion, compute_motion): Fill in ovstring_chars_done
	in the return value.

	* indent.h (struct position): New field ovstring_chars_done.

1996-10-06  Erik Naggum  <erik@naggum.no>

	* window.c (Fspecial_display_p, Fsame_window_p): New functions.
	(Fdisplay_buffer): Use them, instead of doing the work here.
	(syms_of_window): Defsubr them.

1996-10-05  Marcus G. Daniels  <marcus@coulee.tdb.com>

	* xfns.c (x_set_internal_border_width):  Only change
 	an edit_widget's internal_border_width for the toolkit case.

1996-10-04  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* lread.c (openp): Omit /: from start of file name.

1996-10-03  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* buffer.c (init_buffer): Add /: to dir names that could be magic.
	* emacs.c (decode_env_path): Add /: to dir names that could be magic.
	(init_cmdargs): Add /: to argv[0] if it could be magic.

1996-10-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfns.c (syms_of_xfns): For x-sensitive-text-pointer-shape, use
	DEFVAR_LISP.

1996-10-01  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* frame.c (store_frame_param): Allow setting a frame's minibuffer
	to the value that it already has.

1996-10-01  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (syms_of_buffer): Doc fix.

1996-09-28  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.c (show_mouse_face): Undo 1996-08-30 change.

	* s/irix5-0.h (ospeed): New definition.
	* s/irix6-0.h (ospeed): New #undef to counteract that definition.

1996-09-27  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.c (XTflash): Don't flash in the internal borders.
	or between a scroll bar and the edge.

	* eval.c (Vdebug_force): New variable.
	(syms_of_eval): Set up Lisp var.
	(find_handler_clause): If Vdebug_force, call debugger
	even if there are handlers.

1996-09-26  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xfns.c (x_set_scroll_bar_width): Move cursor to the 
	left margin, past a scroll bar, if any.

1996-09-26  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* lread.c (isfloat_string): Accept E like e.

	* callint.c (Fcall_interactively): Bind cursor-in-echo-area to t
	for `k' and `K'.

	* s/hpux10.h (KERNEL_FILE): Redefine it here.

1996-09-25  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* textprop.c (Fset_text_properties, Fadd_text_properties)
	(Fremove_text_properties): Call modify_region and signal_after_change
	only for buffers, not for strings.

	* xterm.c (XTflash): Flash just top and bottom screen line.

	* window.c (syms_of_window): Doc fixes.

1996-09-25  Marcus Daniels  <marcus@sysc.pdx.edu>

	* s/irix5-0.h (sigsetmask, _longjmp, _setjmp): #undef them.
	(_BSD_SIGNALS): Definition deleted.

1996-09-25  Eli Zaretskii  <eliz@is.elta.co.il>

	* dosfns.c (init_dosfns): When setting `__opendir_flags' value,
	override the bits recorded when dumping.

1996-09-24  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* w32term.c (w32_read_socket): Delete WAITP arg.

	* keyboard.c (read_avail_input): Don't pass WAITP to read_socket_hook.

	* xterm.c (XTread_socket): Delete WAITP arg.

	* config.in (HAVE_GETCWD): Add #undef.

	* fileio.c (Vuser_login_name): Declared extern.
	(minibuf_level): extern decl moved to top level.
	(Fwrite_region): Query before writing to a file that is locked,
	even if it is locked by the same user.

	* textprop.c (set_properties, add_properties, remove_properties):
	Don't call modify_region or signal_after_change here.
	(Fset_text_properties, Fadd_text_properties, Fremove_text_properties):
	Call them here when appropriate.

	* Makefile.in (LIBES): Add LOADLIBES and LDLIBS.

1996-09-24  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (run_msdos_command): When testing whether a shell
	belongs to the MSDOS family, convert its name to lower-case.

1996-09-24  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* eval.c (Vsignal_hook_function): New variable.
	(syms_of_eval): Set up Lisp variable.
	(Fsignal): Call that function.

	* xfns.c (x_set_internal_border_width, Fx_create_frame):
	Call widget_store_internal_border.
	(Fx_create_frame): Don't use a superclass when
	checking for an internalBorder resource.

	* widget.c (widget_store_internal_border): New function.
	(EmacsFrameSetValues): Undo previous change.

1996-09-23  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xfns.c (x_window): With Motif, double extra_borders.
	Use a preprocessor conditional to test for Motif.

	* frame.h (struct frame): New field window_width.
	(FRAME_WINDOW_WIDTH): Refer to window_width field.
	(SET_FRAME_WIDTH): Set window_width field as well as width field.

1996-09-22  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* eval.c (syms_of_eval): Initialize Vrun_hooks here.
	Don't make it a Lisp variable.

	* frame.c (Fdelete_frame): Set update_mode_lines.

	* emacs.c (main): Add copyright etc. to --version output.

1996-09-21  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* bytecode.c (Bsave_current_buffer): New macro.
	(Fbyte_code): Handle Bsave_current_buffer.

	* editfns.c (Fsave_current_buffer): New function.
	(syms_of_editfns): defsubr it.

	* search.c (REGEXP_CACHE_SIZE): Increase to 20.
	(compile_pattern): Check for size match before calling Fstring_equal.

1996-09-21  Paul Eggert  <eggert@twinsun.com>

	* editfns.c: For time zone difference calculations, use the same
 	code as the GNU C Library; this fixes a bug with large negative years.
	(tm_diff): Renamed from difftm.  Yield int, not long.
	(TM_YEAR_BASE): Renamed from TM_YEAR_ORIGIN.

1996-09-21  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xdisp.c (echo_area_display): Clear the left-side scroll bar columns.

1996-09-20  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.c (x_scroll_bar_create, x_scroll_bar_move): 
	(x_scroll_bar_expose): Use VERTICAL_SCROLL_BAR_WIDTH_TRIM.

	* xterm.h (VERTICAL_SCROLL_BAR_WIDTH_TRIM): Renamed from
	LEFT_VERTICAL_SCROLL_BAR_WIDTH_TRIM.
	(VERTICAL_SCROLL_BAR_INSIDE_WIDTH): Use VERTICAL_SCROLL_BAR_WIDTH_TRIM.

	* widget.c (EmacsFrameSetValues): Copy internal_border_width
	from the Emacs frame if caller isn't changing it.

	* xfns.c (Fx_create_frame): Default Qinternal_border_width to 1.

	* xterm.c (XTchange_line_highlight, dumpglyphs, XTclear_end_of_line)
	(do_line_dance, pixel_to_glyph_coords): Use FRAME_WINDOW_WIDTH.

	* xfns.c (x_set_scroll_bar_width): Default the width to 3 cols.
	Call change_frame_size.

	* xterm.c (x_scroll_bar_move, x_scroll_bar_create):
	Add a border around the actual window.

	* dispnew.c (make_frame_glyphs, update_line, update_frame)
	(scroll_frame_lines, char_ins_del_cost): Use FRAME_WINDOW_WIDTH.

	* minibuf.c (read_minibuf): Use FRAME_LEFT_SCROLL_BAR_WIDTH
	to set the cursor position at the end.

	* xterm.c (x_scroll_bar_expose): Don't trim the width here.

	* xdisp.c (display_mode_line): Use faces for inverse video mode line
	whenever that possible.

	* xfns.c (Fx_create_frame): Default Qvertical_scroll_bars to `left'.

Fri Sep 20 02:37:37 1996  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xterm.c (XTclear_end_of_line): Shift end-of-line when there is a
 	left-side scroll bar by FRAME_LEFT_SCROLL_BAR_WIDTH.
	(do_line_dance): Take into account the width of a left-side scroll bar.
	(dumprectangle): Trim at FRAME_WINDOW_WIDTH instead of FRAME_WIDTH.
	(fast_find_position): Use new macro WINDOW_LEFT_MARGIN.
	(show_mouse_face): Likewise.
	(x_scroll_bar_set_handle): VERTICAL_SCROLL_BAR_INSIDE_WIDTH now
 	requires the frame as an argument.
	(x_scroll_bar_expose): Narrow the box slightly for a left-side
 	scroll bar.

	* xfns.c:  Add the symbol `right'; this symbol is used to indicate
	that a right-side scroll bar is wanted.
	(x_set_vertical_scroll_bars): Check for left<->right<->none 
	scroll bar changes, and modify the vertical scroll bar type
	as appropriate.
	(x_figure_window_size): Use new SET_FRAME_WIDTH macro.
	(Fx_create_frame): Likewise.
	(Fx_horizontal_line): Use new macro WINDOW_LEFT_MARGIN.

	* xdisp.c (echo_area_display): Shift display_string past a
 	left-side scroll bar.
	(redisplay_window): Likewise.
	(redisplay_internal): Shift cursor past a left-side scroll bar.
	(redisplay_window): Likewise.
	(try_window_id): Likewise.
	(display_text_line): Likewise.
	(redisplay_internal): Shift charstarts past a left-side scroll bar.
	(display_text_line): Likewise.
	(redisplay_internal): Use new macro WINDOW_FULL_WIDTH_P.
	(redisplay_window): Likewise.
	(display_text_line): Likewise.
	(display_text_line): Shift output past left-side scroll bar.
	(display_text_line): Use new WINDOW_RIGHTMOST_P macro.
	(display_text_line): Don't pad right columns unless using
 	a right-side scroll bar.  Don't draw vertical bars unless there
 	isn't any kind of scroll bar.
	(display_string): Likewise.
	(display_mode_line): Use new macros WINDOW_LEFT_MARGIN,
 	WINDOW_RIGHT_MARGIN, and WINDOW_FULL_WIDTH_P.
	(display_string): Use new macro WINDOW_RIGHTMOST_P.

	* window.c (Fwindow_edges): Use new WINDOW_RIGHT_EDGE macro.
	(coordinates_in_window): Use WINDOW_LEFT_MARGIN, WINDOW_RIGHT_MARGIN,
	and WINDOW_RIGHT_EDGE.  Adjust for left-side scroll bar margin.
	(window_loop, Fdisplay_buffer): Use new WINDOW_FULL_WIDTH_P macro.
	(window_internal_width): Window width now always includes the
 	scroll bar, if any.  Use WINDOW_RIGHTMOST_P and WINDOW_FULL_WIDTH_P.

	* w32term.c (fast_find_position, show_macro_face): Use new
 	WINDOW_LEFT_MARGIN macro.

	* w32fns.c (Qright): New variable.
	(syms_of_win32fns): Initialize and staticpro Qright.
	(x_set_vertical_scroll_bars): Check for left<->right<->none 
	scroll bar changes, and modify the vertical scroll bar type
	as appropriate.
	(x_figure_window_size): Use new SET_FRAME_WIDTH macro.
	(Fx_create_frame): Likewise.

	* term.c (term_init): Use new vertical scroll bar enumerated type.
	(term_init): Use new macro SET_FRAME_WIDTH.

	* sunfns.c (Fsun_menu_internal): Use new WINDOW_LEFT_MARGIN macro.

	* ntterm.c (initialize_win_nt_display): Use SET_FRAME_WIDTH.

	* keyboard.c (make_lispy_event): When converting from pixel to
 	glyph coordinates, offset by WINDOW_LEFT_MARGIN instead of XINT
 	(XWINDOW (window)->left; this is necessary when there are
 	left-side scrollbars.

	* frame.c (make_frame): Switch from boolean
 	`has_vertical_scrollbars' integer to an enumerated type.
	Use new macro SET_FRAME_WIDTH.

	* dispnew.c (preserve_other_columns, preserve_my_columns): Use new
	macros WINDOW_LEFT_MARGIN and WINDOW_RIGHT_EDGE.
	(adjust_window_charstarts, verify_charstarts, cancel_my_columns):
	Use new macro WINDOW_LEFT_MARGIN instead of w->left.
	(direct_output_for_insert, direct_output_forward_char): Likewise.
	(buffer_posn_from_coords): Likewise.
	(verify_charstarts): Use new macro WINDOW_FULL_WIDTH_P.
	(update_frame): For determining when to wrap the cursor, use the
	new macro FRAME_WINDOW_WIDTH instead of FRAME_WIDTH; they aren't
	necessarily the same any more.
	(change_frame_size_1): Use FRAME_WINDOW_WIDTH to check for changes.
	Give `set_window_width' the window width value.
  	Use new macro SET_FRAME_WIDTH.
	
	* xterm.h (VERTICAL_SCROLL_BAR_INSIDE_WIDTH): Add frame as an
 	argument, and use it to decrease the width in the case of a
 	left-side scroll bar; this prevents the bar and adjacent text
 	from scrunching together.
	(LEFT_VERTICAL_SCROLL_BAR_WIDTH_TRIM): Add constant.

	* frame.h (vertical_scroll_bar_type): Add enumerated
 	none/left/right type for identifying vertical scroll bars.
	(struct frame): Use vertical_scroll_bar_type.
	(FRAME_HAS_VERTICAL_SCROLL_BARS): Use vertical scroll bar type.
	(FRAME_VERTICAL_SCROLL_BAR_TYPE): New macro.
	(FRAME_HAS_VERTICAL_SCROLL_BARS_ON_LEFT): New macros.
	(FRAME_HAS_VERTICAL_SCROLL_BARS_ON_RIGHT): New macros.
	(FRAME_SCROLL_BAR_WIDTH, FRAME_LEFT_SCROLL_BAR_WIDTH): New macros.
	(FRAME_WINDOW_WIDTH, FRAME_WINDOW_WIDTH_ARG): New macros.
	(SET_FRAME_WIDTH): New macro for assigning to both
 	`external_width' and `width'.
	(WINDOW_VERTICAL_SCROLL_BAR_COLUMN): Modify to handle left-side
 	scroll bars too.
  	
	* window.h (WINDOW_LEFT_MARGIN): New macro.
	(WINDOW_RIGHT_EDGE, WINDOW_RIGHT_MARGIN): New macros.
	(WINDOW_FULL_WIDTH_P, WINDOW_RIGHTMOST_P): New macros.

1996-09-20  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.h (VERTICAL_SCROLL_BAR_INSIDE_HEIGHT): New arg F (not used).
	(VERTICAL_SCROLL_BAR_TOP_RANGE): New arg F (not used).
	* xterm.c: Pass frame arg in calls to VERTICAL_SCROLL_BAR_INSIDE_HEIGHT
	and VERTICAL_SCROLL_BAR_TOP_RANGE.
	
	* sysdep.c (init_system_name): Retry gethostbyname only 5 times
	and don't sleep after the last time.

1996-09-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* dired.c (file_name_completion): Remove code which sets and
	restores the `stat' control flags (they might not be restored if
	C-g is pressed during completion).
	(file_name_completion_stat): Set and restore flags that make
	`stat' faster here instead of in `file_name_completion'.

1996-09-18  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* buffer.c (overlay_strings): Declare pstr using unsigned char.

	* xdisp.c (display_text_line): Declare ovstr as unsigned char *.

	* minibuf.c (Fcompleting_read): Doc fix.

1996-09-17  Erik Naggum  <erik@naggum.no>

	* lisp.h: Declare make_symbol.

	* lread.c (init_obarray): staticpro Qvariable_documentation.

	* keymap.c (syms_of_keymap): staticpro global_map.

	* keyboard.c (syms_of_keyboard): Initialize and staticpro
	internal_last_event_frame and read_key_sequence_cmd.

	* fileio.c (syms_of_fileio): staticpro Qset_visited_file_modtime.

	* dired.c (syms_of_dired): staticpro Qdirectory_files,
	Qfile_name_completion, Qfile_name_all_completions, and Qfile_attributes.

	* casetab.c (syms_of_casetab): staticpro Vascii_canontable,
	Vascii_eqv_table, and Vascii_upcase_table.

	* alloc.c (Fmake_symbol): Initialize `obarray' field.

1996-09-16  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* Makefile.in: Replaced symbol BSD with BSD_SYSTEM.
	* emacs.c, floatfns.c, keyboard.c, mem-limits.h, process.c: Likewise.
	* sysdep.c, syssignal.h, syswait.h, xterm.c: Likewise.
	* s/bsd386.h, s/bsd4-1.h, s/bsd4-2.h, s/bsd4-3.h, s/dgux.h: Likewise.
	* s/freebsd.h, s/msdos.h, s/rtu.h, s/umax.h, s/umips.h: Likewise.
	* m/intel386.h, m/mips.h, m/mips4.h, m/vax.h: Likewise.

1996-09-16  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* buffer.c (Fget_buffer_create): Initialize BUF_OVERLAY_MODIFF.

	* minibuf.c (read_minibuf_unwind): Clear last_overlay_modified field.

	* msdos.c (IT_set_menu_bar_lines): Clear last_overlay_modified field.

	* w32term.c (note_mouse_highlight): Test last_overlay_modified field.

	* xterm.c (note_mouse_highlight): Test last_overlay_modified field.

	* window.c (Fset_window_start): Clear last_overlay_modified field.
	(set_window_height, set_window_width, Fset_window_buffer)
	(change_window_height, window_scroll, Fset_window_configuration): 
	Clear last_overlay_modified field.
	(Fpos_visible_in_window_p): Test last_overlay_modified field.

	* Makefile.in (frame.o, textprop.o, abbrev.o): Depend on window.h.

	* process.c (stream_process): Variable deleted.
	(syms_of_process): staticpro deleted.

1996-09-15  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* sysdep.c: Don't explicitly Include termios.h.
	(ospeed): Use HAVE_TERMIOS to decide whether to use speed_t.

	* s/hpux9.h (C_SWITCH_X_SYSTEM): Add -I/usr/contrib/X11R5/include.
	(LD_SWITCH_X_DEFAULT): Add -L/usr/contrib/X11R5/lib.

1996-09-14  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* buffer.h (struct buffer): New field overlay_modiff.
	(MODIFF, BUF_OVERLAY_MODIFF): New macros.
	* window.h (struct window): New field last_overlay_modified.

	* xdisp.c (redisplay_internal, mark_window_display_accurate)
	(redisplay_window): Test and update last_overlay_modified field
	along with last_modified.

	* dispnew.c (direct_output_for_insert): Set last_overlay_modified
	field in window.

	* keyboard.c (command_loop_1): Test last_overlay_modified
	along with last_modified.

	* xdisp.c (overlay_unchanged_modified): New variable.
 	(redisplay_internal): Set overlay_unchanged_modified.
	* insdel.c (gap_left, gap_right, modify_region): 
	Compare overlay_unchanged_modified with OVERLAY_MODIFF.

	* buffer.c (modify_overlay): Renamed from redisplay_region
	moved here from xdisp.c, and made static.  Callers changed.
	Update OVERLAY_MODIFF instead of MODIFF.
	* xdisp.c (redisplay_region): Renamed and moved to buffer.c.
	
	* s/sco5.h (C_SWITCH_SYSTEM, LD_SWITCH_SYSTEM): 
	Don't define them if using GCC.

1996-09-13  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* keyboard.c (recursive_edit_1): Handle a string as the
	throw value.

	* minibuf.c (read_minibuf): If not in minibuffer window,
	cancel the active minibuffer.

1996-09-12  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* frame.c (Fmake_terminal_frame): Use Vdefault_frame_alist.

	* s/hpux9.h (C_SWITCH_X_SYSTEM, LD_SWITCH_X_DEFAULT):
	Don't specify dirs for X, only for Motif.

1996-09-11  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* lread.c (Fload): Move ... to ends of messages.

	* puresize.h (BASE_PURESIZE): Increased.

	* s/sco5.h (LIBX11_SYSTEM): Don't use ..._s libraries.

1996-09-10  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* insdel.c (signal_before_change): Fix previous change.

	* lisp.h (struct Lisp_Symbol): New field `obarray'.

	* xterm.c (x_connection_closed): Call XtCloseDisplay.

1996-09-09  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* keyboard.c (Fexecute_extended_command): Delete junk lines.
	Print the key bindings after the command, temporarily;
	then bring back the previous message.
	
	* buffer.c (syms_of_buffer): Doc fixes.

	* filelock.c (lock_superlock): Delete superlock file if it stayed
	locked for 20 seconds.

1996-09-08  Erik Naggum  <erik@naggum.no>

	* lread.c: Add #n=object, #n#, and #:symbol constructs to reader.
	(readevalloop, read, Fread_from_string): Empty list of read objects
	before read0 call.
	(read1): New variable `uninterned_symbol', which controls how to
	make symbols.  Support #:, #n=object and #n#.
	(make_symbol): New function, used in read1 to make uninterned symbols
	(Fintern): Set `obarray' field of interned symbols.
	(init_obarray): Explicit set `obarray' field of symbol `nil'.
	(syms_of_lread): staticpro read_objects, the list of read objects.

	* print.c: Add #n=object, #n#, and #:symbol constructs to printer.
	(PRINTDECLARE): New macro to declare required variables.
	(PRINTPREPARE, PRINTFINISH): Set printed_genyms to nil.
	(Fwrite_char, write_string, write_string_1, Fterpri, Fprin1,
	Fprin1_to_string, Fprinc, Fprint): Use new macro PRINTDECLARE.
	(print): Print uninterned symbols readable.
	(syms_of_print): Defvar `print-gensym', staticpro printed_gensyms.

1996-09-05  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* editfns.c (Finsert_buffer_substring): Check for deleted buffer.
	(Fcompare_buffer_substrings): Likewise.

1996-09-04  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* lisp.h: Add many declarations.
	
	* lisp.h (BITS_PER_EMACS_INT): New macro.
	(XMARKBIT): Test BITS_PER_EMACS_INT to conditionalize fast definition.
	* m/alpha.h (BITS_PER_EMACS_INT): New definition.

	* s/sol2.h (LIBS_SYSTEM): Use -lkstat instead of -lelf -lkvm

	* process.c (create_process): Test HAVE_SETPGID for using setpgid.

	* config.in (HAVE_SETPGID): Add #undef.

	* keymap.c (syms_of_keymap): staticpro current_global_map;

	* intervals.c (get_local_map): Call indirect-function.

	* m/alpha.h (UNEXEC): Use unexelf.c.

	* unexelf.c: unexelf1.c merged into this file.

	* terminfo.c: Include config.h.
	[HAVE_TERMIOS_H]: Include termios.h.
	(ospeed) [HAVE_TERMIOS_H]: Use ospeed_t.

	* process.c (create_process_1, sigchld_handler) [POSIX_SIGNALS]:
	Don't reestablish handler.

	* keyboard.c (input_available_signal) [POSIX_SIGNALS]:
	Don't reestablish handler.
	(interrupt_signal) [POSIX_SIGNALS]: Likewise.

	* data.c (arith_error) [POSIX_SIGNALS]: Don't reestablish handler.

	* config.in (HAVE_TERMIOS_H): Add #undef.

	* cm.h, sysdep.c [HAVE_TERMIOS_H]: Include termios.h.
	(ospeed) [HAVE_TERMIOS_H]: Use ospeed_t.

	* eval.c (Fmacroexpand): Don't declare `form' as register.

	* frame.c (Fredirect_frame_focus): Don't call Ffocus_frame.

	* keyboard.c (Fexecute_extended_command): Fix previous change.

	* intervals.c (copy_intervals_to_string): Take arg as buffer.

	* keyboard.c (Fcommand_execute): gcpro cmd and prefixarg
	while calling do_autoload.

	* eval.c (Fmacroexpand): gcpro form while calling do_autoload.
	(do_autoload): gcpro fun, funname, fundef.

1996-09-03  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* keyboard.c (Fexecute_extended_command): gcpro prefixarg.

	* xfns.c, w32fns.c (x_set_frame_parameters):
	Make height and width ints.

	* fns.c (map_char_table): Declare depth as int.

	* xterm.c (note_mouse_highlight):
	Pass POS argument to fast_find_position as int.

	* textprop.c (set_properties, add_properties, remove_properties): 
	Call modify_region with ints.

	* insdel.c (prepare_to_modify_buffer): Take integer arguments.
	(signal_before_change): Take integer arguments.

	* alloc.c (Fmake_byte_code): Call make_pure_vector using nargs.

	* alloc.c (Fpurecopy): Cast arg to make_pure_vector.
	(Fmake_byte_code): Use XFASTINT when calling make_pure_vector.

	* doprnt.c (doprnt1): If lispstrings, accept a string
	as a `struct Lisp_String *'.

	* editfns.c (Fformat): Pass a string using XSTRING.

	* xdisp.c (message): Cast size arg to doprnt.

	* term.c (term_init): Avoid type-mismatch calling get_frame_size.
	(OUTPUT_IF, OUTPUT): Cast frame height to int.

	* search.c (search_buffer): Use EMACS_UINT.

1996-09-03  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* emacs.c (sort_args): Don't rearrange any args that follow "--".

1996-09-03  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xfns.c, w32fns.c (Ffocus_frame, Funfocus_frame): Functions deleted.

	* xfns.c (x_get_and_record_arg): New function.
	(x_icon): Use that, for Qicon_top and Qicon_left.
	(x_report_frame_params): Report the Qparent_id parameter.
	
1996-09-03  Paul Eggert  <eggert@twinsun.com>

	* config.in (mktime): Define to emacs_mktime if we are using our own
	mktime, since Nextstep doesn't let Emacs redefine the builtin mktime.
	* Makefile.in (MKTIME_OBJ):  Use our mktime instead of NEXTSTEP's,
	since NEXTSTEP's wrongly ignores TZ.
	(mktime): #undef, to avoid messing up the file name mktime.c.
	* editfns.c (Fencode_time):  Remove NEXTSTEP workaround;
	we now use our mktime instead.

1996-09-03  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* process.c (create_process): Undo previous change.

1996-09-02  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* editfns.c (Fencode_time) [_NEXT_SOURCE]: Use ZONE, not ABSZONE.

	* Make region highlighting show in just one window.
	* xdisp.c (redisplay_internal): Test last_selected_window slot.
	(mark_window_display_accurate, display_text_line): Likewise.
	* window.c (unshow_buffer): Clear last_selected_window slot, maybe.
	(Fset_window_buffer): Set last_selected_window slot.
	(Fselect_window): Set last_selected_window slot.
	(delete_all_subwindows): Maybe call unshow_buffer.
	* buffer.c (reset_buffer): Initialize last_selected_window slot.
	* buffer.h (strict buffer): New slot last_selected_window.

1996-09-01  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* process.c (Fprocess_contact): New function.
 	(NETCONN_P): Use GC_CONSP.
	(list_processes_1): Use new childp format.
	(Fopen_network_stream): Store a cons cell in childp.

	* keyboard.c (record_asynch_buffer_change, gobble_input):
	Use sigblock instead of sigblockx.

	* syssignal.h (sigunblockx): Definitions deleted.
	(sigpausex, sigblockx, sigholdx): Definitions deleted.

	* process.c (create_process): Test defined (TIOCSCTTY)
	and defined (HAVE_SETSID) instead of DONT_REOPEN_PTY.

	* fileio.c (Faccess_file): New function.
	(Qaccess_file): New variable.
	(syms_of_fileio): defsubr function; init and staticpro Qaccess_file.

1996-09-01  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* config.in (MULTI_FRAME): Obsolete macro deleted.
	* Makefile.in: Removed support for !MULTI_FRAME.
	* dispextern.h, frame.h, keyboard.h, lisp.h, puresize.h: Likewise.
	* alloc.c, buffer.c, data.c, dispnew.c, frame.c: Likewise.
	* keyboard.c, minibuf.c, print.c, sysdep.c, w32faces.c: Likewise.
	* window.c, xdisp.c, xfaces.c: Likewise.

	* abbrev.c, bytecode.c: Change all references from point to PT.
	* callint.c, casefiddle.c, cmds.c, dispnew.c, editfns.c: Likewise.
	* fileio.c, indent.c, lread.c, print.c, process.c: Likewise.
	* search.c, syntax.c, undo.c, window.c: Likewise.

1996-09-01  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* Makefile.in (TAGS): Use $(srcdir) in deps.

1996-08-31  Boris Goldowsky  <boris@gnu.ai.mit.edu>

	* fileio.c (build_annotations): Remember original buffer that the
	region came from; pass this to `format-annotate-function'.

1996-08-31  Geoff Voelker  <voelker@cs.washington.edu>

	* Makefile.in (MSDOS_SUPPORT, WINNT_SUPPORT, SOME_MACHINE_LISP): 
	Include dos-nt.elc.

1996-08-31  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* keyboard.c (requeued_events_pending_p): New function.

	* config.in (HAVE_SETRLIMIT): Add #undef.

	* emacs.c [HAVE_SETRLIMIT]: Include time.h and resource.h.
	(main) [HAVE_SETRLIMIT]: Call setrlimit to extend the stack limit.
 	New local `rlim'.

	* lread.c (Fload): Add "source is newer" info to the "loading" and
 	"done" messages.

1996-08-31  Paul Eggert  <eggert@twinsun.com>

	* config.in (HAVE_SYS_SYSTEMINFO_H, HAVE_GETDOMAINNAME, HAVE_SYSINFO):
	New macros.
	* sysdep.c (<sys/systeminfo.h>):
	Include if HAVE_SYS_SYSTEMINFO_H is defined.
	(init_system_name): Use sysinfo or getdomainname to append domain name
	if host name is not already fully qualified.

1996-08-31  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xfns.c (Fx_list_fonts): New optional arg MAXIMUM.

1996-08-31  Erik Naggum  <erik@naggum.no>

	* alloc.c (Fgarbage_collect): Report used and free intervals.

1996-08-31  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.h (struct x_display_info): Add element Xatom_FONT.
	* xterm.c (x_term_init): Initialize Xatom_FONT member.
	(x_new_font): Use Xatom_FONT member.

1996-08-31  Kevin Layer  <layer@Franz.COM>

	* ntproc.c (Vwin32_start_process_show_window): New variable.
	(create_child): Conditionally force subprocess to hide window.
	(syms_of_ntproc): DEFVAR it.

1996-08-31  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* s/nextstep.h (LD_SWITCH_SYSTEM): Add alternate definition if
	not __NeXT.

1996-08-30  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xfaces.c (Fset_face_attribute_internal): Set mouse_face_defer flag.
	* xterm.c (XTupdate_end): Always clear mouse_face_defer flag.

	* xterm.c (do_line_dance, dumprectangle): Use x_update_cursor.
	(show_mouse_face, clear_cursor): Likewise.
	(x_display_cursor): New args X and Y.
	(XTupdate_end, XTcursor_to, XTwrite_glyphs): Pass new args.
	(XTupdate_begin): Initialize curs_x, curs_y here.

	* xfns.c (x_set_cursor_color): Use x_update_cursor.

1996-08-29  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.c (XTread_socket): Fix previous change.

	* keyboard.c (cmd_error): Clear executing_macro.

1996-08-29  David Byers  <byers@lysator.liu.se>

	* minibuf.c (Fminibuffer_complete_word): Check for
	unexpected data type returned by Ftry_completion.

1996-08-29  Erik Naggum  <erik@psilocin.gnu.ai.mit.edu>

	* macros.c (init_macros): Initialize executing_macro, too.

1996-08-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (XTread_socket): Call XFilterEvent on all events,
	if HAVE_X_I18N and FRAME_XIC nonzero.

	* keyboard.c (cmd_error): Add number of kbd macro iterations
	to the error message.

	* macros.h (executing_macro_iterations, executing_macro): Declared.
	
	* macros.c (executing_macro_iterations, executing_macro): New vars.
	(Fexecute_kbd_macro): Set them.

1996-08-28  Morten Welinder  <terra@diku.dk>

	* minibuf.c (Vhistory_length, Qhistory_length): New variables.
	(syms_of_minibuf): Register and initialise these.
	(read_minibuf): Truncate history list if needed.

1996-08-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* fns.c (Fsubstring): Handle vectors as well as strings.

	* callint.c (Fcall_interactively): For `N' and `n',
	if we don't get a number, try again.

1996-08-28  Lars Magne Ingebrigtsen  <larsi@dain.ifi.uio.no>

	* alloc.c (syms_of_alloc): Set up Lisp variables ...-consed,
	such as Vcons-cells-consed.

1996-08-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (main): Add bug report info in --help message.

1996-08-26  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* term.c (Vring_bell_function): New variable.
	(syms_of_term): Set up Lisp variable.
	(ring_bell): Use Vring_bell_function.

1996-08-25  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* xterm.c (fast_find_position): Fix previous change.

	* keyboard.c (command_loop_1): Cancel echoing etc.
	before running post-command-hook and such.

	* xterm.c (fast_find_position): Minor fix in handling maybe_next_line.

	* config.in (HAVE_LIBKRB, HAVE_LIBDES): Add #undefs.

1996-08-24  Richard Stallman  <rms@ethanol.gnu.ai.mit.edu>

	* Renamings to avoid conflicting names on MSDOS.
	* s/riscix12.h: Renamed from s/riscix12.h.
	* s/sunos413.h: Renamed from s/sunos4-1-3.h.
	* s/dgux5-4-3.h: Renamed from s/dgux5-4r3.h.
	* s/sunos4-1-2.h: File deleted.
	
	* xmenu.c (set_frame_menubar): Don't add ibw to menubar_size.

	* xfns.c (x_window): Don't add ibw to menubar_size.

1996-08-24  Paul Eggert  <eggert@twinsun.com>

	* editfns.c (Fencode_time, Fset_time_zone_rule):
	Use UTC if the zone is t.

1996-08-24  Erik Naggum  <erik@naggum.no>

	* print.c (print-quoted): New variable.
	(print): Print certain expressions more compactly when set.
	Also use XCAR and XCDR directly -- we know we have conses.

1996-08-23  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xterm.c (x_term_init): If the default Xt font does not exist on
 	the X server, add a resource so that dialog boxes use a common font.

1996-08-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* window.c (Fsplit_window): Treat width just like height;
	no special handling for scroll bars.

1996-08-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Makefile.in (paths.h, config.h): Targets deleted.
	(../config.status): Add two new rules to check need for reconfigure.

	* keyboard.c (command_loop_1): Check column_number_displayed
	in the selected window, not Vcolumn_number_mode.
	(Vcolumn_number_mode): Variable deleted.
	(syms_of_keyboard): Delete Lisp variable column-number-mode.

1996-08-22  Erik Naggum  <erik@psilocin.gnu.ai.mit.edu>

	* dispnew.c (change_frame_size_1): Clean up conditional.

1996-08-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xmenu.c (xdialog_show): Don't allow 9 buttons.

1996-08-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (send_process): GCPRO object.

	* unexalpha.c: Conditionalize previous changes on not __linux__.

	* xfns.c (x_set_scroll_bar_width): Call x_set_window_size
	when arg is nil.

1996-08-20  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* unexalpha.c: Include reloc.h and elf_abi.h.
	(rel_dyn_section, dynstr_section, dynsym_section): New variables.
	(old_data_scnhdr): New variable.
	(CHECK_SCNHDR): Compare just 8 chars of section name.
	(unexec): Check for rel_dyn_section, dynsym_section, dynstr_section.
	Do call update_dynamic_symbols.
	(update_dynamic_symbols): Finish it up and take away #if 0.

1996-08-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* unexalpha.c (unexec): Copy the .got section.

1996-08-16  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* cmds.c (Fdelete_backward_char): Fix off-by-one error.
	Treat deleted newline specially.

1996-08-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* bytecode.c (Fbyte_code): For relative gotos, force signed arithmetic.

1996-08-14  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfns.c (Fx_open_connection): Don't set Vx_resource_name.

1996-08-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Version 19.33 released.

1996-08-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/sco5.h (POSIX_SIGNALS): Don't define it, #undef instead.
	(NO_SOCKETS_IN_FILE_SYSTEM): Definition deleted.
	(sigblock): New definition.

1996-08-10  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* m/sequent-ptx.h (LOAD_AVE_TYPE, FSCALE, LOAD_AVE_CVT):
	Undef them before defining.

	* s/ptx4.h: Fix include file name.
 	(NO_FILIO_H): Move definition.

1996-08-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* m/alpha.h [__ELF__] (UNEXEC): Use unexelf1.c.

1996-08-09  David Mosberger-Tang  <davidm@azstarnet.com>

	* unexelf1.c: New file, copied from unexelf.c.
	[__alpha__]: Include <sym.h> to get COFF debugging
 	info declarations for .mdebug section.
	[__GNU_LIBRARY__ - 0 >= 6]: Include <link.h>.
	[notdef ElfW]: Define backwards compatible ElfW macro.
	(unexec) [__alpha__]: Add code to update Alpha COFF symbol table
 	(.mdebug section).
	(unexec) [__alpha__]: Work around binutils-2.7 bug: for Alpha ELF
 	sometimes unneeded data relocs do not get elided properly which
 	results in reloc entries that contain all zeroes.

	* m/alpha.h [__ELF__ && __GNUC__] (C_SWITCH_MACHINE): Add -fno-common.
	(TEXT_START, DATA_START, DATA_SEG_BITS, UNEXEC): Define only if
 	__ELF__ is not defined.
	(LINUX_SBRK_BUG): Define only if LINUX and __GNU_LIBRARY__ < 6.
	(NO_TERMIO): Always define this.  No Alpha system should need
 	termio.
	(COFF, DATA_END): Define only if __ELF__ is not defined.

1996-08-08  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/usg5-4.h: Don't include filio.h if NO_FILIO_H.

	* s/ptx4.h: New file.

	* config.in (GETTIMEOFDAY_ONE_ARGUMENT): Conditionalize on
	HAVE_GETTIMEOFDAY.

1996-08-07  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xmenu.c (xmenu_show): Set dummy.state.
  	Set dummy.button appropriately.
	(popup_get_selection) [USE_MOTIF]: Set event.xbutton.button.

	* s/osf1.h (LD_SWITCH_SYSTEM): New definition.

1996-08-06  Paul Eggert  <eggert@twinsun.com>

	* editfns.c (set_time_zone_rule): Don't put a string literal
	"TZ=..." in environ.

1996-08-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* minibuf.c (Fread_from_minibuffer): Make position 0 in the initial
	input mean the beginning.

1996-08-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* callproc.c (Fcall_process_region) [DOS_NT]: Avoid downcasing
	the `X' characters in the template passed to `mktemp'.

1996-08-02  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* widget.c (EmacsFrameSetCharSize): Call do_pending_window_change.

1996-07-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* Version 19.32 released.

	* s/hpux10.h (C_SWITCH_X_SYSTEM, LD_SWITCH_X_DEFAULT):
	Override to add /usr/contrib directories.

1996-07-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (XTread_socket): Delete the code to pass menu bar keys
	to the toolkit alone.
	(XTread_socket): Don't fail to pass button events to toolkit.

1996-07-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (XTread_socket): Pass keys in menu bar to toolkit alone
	only for Motif.

	* xdisp.c (prepare_menu_bars): Conditionalize previous change.

1996-07-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* filelock.c (lock_file_owner_name): Always initialize the_pw.

	* xterm.c (XTread_socket): Fixing previous change:
	Clear last_mouse_press_frame on non-menu-bar ButtonPress.
	Always use last_mouse_press_frame as frame for ButtonRelease.
	But ignore the event if frame's output_data.x is null.
	Save the ButtonRelease only if USE_MOTIF.
	(last_mouse_press_frame): This is now a Lisp object.
	(syms_of_xterm): Initialize and staticpro it.

	* xmenu.c (pending_menu_activation): Don't initialize.  Not static.
	(set_frame_menubar): If no saved_menu_event yet, set deep_p.
	Don't clear pending_menu_activation here.

	* xmenu.c (Fx_popup_dialog): Don't fail to initialize WINDOW.

	* xdisp.c (prepare_menu_bars): Clear pending_menu_activation.
	
	* print.c: When printing into a buffer, generate all the text
	first, then insert it all at once.
	(print_buffer): New variable.
	(print_buffer_size, print_buffer_pos): New variables.
	(PRINTPREPARE): Allocate print_buffer.
	(PRINTFINISH): Free print_buffer after inserting its contents.
	(printchar, strout): Output into print_buffer.
	(print_string): If printcharfun is nil, use strout.

1996-07-26  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xmenu.c (pending_menu_activation): New variable.
	(x_activate_menubar): Don't call set_frame_menubar for
	ButtonRelease events.  Instead, set pending_menu_activation.
	(set_frame_menubar): If pending_menu_activation, set deep_p.

	* xterm.c (last_mouse_press_frame): New variable.
	(XTread_socket): Store a saved_button_event for ButtonRelease.

1996-07-25  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xmenu.c (set_frame_menubar): Use -1 for call_data
	in the deep_p = 0 case.

1996-07-24  Geoff Voelker  <voelker@joker.cs.washington.edu>

	* ntinevt.c (win32_read_socket): Never block reading from input queue.

1996-07-24  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* editfns.c (Fencode_time): Assign to tm.tm_gmtoff for NEXTSTEP,
	since timezone environment variable is ignored.

1996-07-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (buffer_permanent_local_flags): New variable.
	(init_buffer_once): Initialize it.
	(reset_buffer_local_variables): New argument PERMANENT_TOO.
	Callers changed.  Now declared static.

	* s/irix6-0.h [__GNUC__] (C_DEBUG_SWITCH): Define as -g3.

	* m/mips.h, m/iris4.h, m/iris5d.h (LIBS_MACHINE) [__GNUC__ and ABIN32]:
	Define as empty.

1996-07-23  Paul Eggert  <eggert@twinsun.com>

	* editfns.c (Fdecode_time, difftm): Work even if tm_year represents
	negative years; this is possible with 64-bit time_t values.

1996-07-20  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* fileio.c (check_writable): Use euidaccess, not eaccess.

1996-07-20  Erik Naggum  <erik@naggum.no>

	* intervals.c (balance_intervals_internal): Recurse directly.

1996-07-19  Eli Zaretskii  <eliz@is.elta.co.il>

	* unexec.c (copy_text_and_data) [DJGPP >= 2]: Switch off two bits
	in `_crt0_startup_flags' so they don't go into the dumped Emacs.
	Restore the value of `_crt0_startup_flags' after .text and .data
	were dumped.

1996-07-19  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* s/irix5-0.h (_BSD_SIGNALS): Define.
	* s/irix6-0.h (SA_RESTART): Add #undef.

1996-07-16  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32term.c (w32_read_socket): Need to erase background
 	immediately before repainting exposed region.

	* makefile.nt (DOC, clean): Use OBJDIR macro.

1996-07-16  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* xfns.c (Fx_create_frame): Do xlwmenu hack only if USE_LUCID.

	* m/alpha.h, unexelf.c: Undo Jul 15 changes.
	* config.in, data.c, keyboard.c, process.c: Undo Jul 15 changes.
	* cm.h, sysdep.c, terminfo.c: Undo Jul 15 and Jul 16 changes.

1996-07-16  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* cm.h, terminfo.c, sysdep.c: Test HAVE_TERMIOS rather than the
	automatically-generated HAVE_TERMIOS_H, in case <termios.h> is
	present but unusable.

1996-07-16  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* fns.c (Fy_or_n_p): Pass 3rd arg to Flookup_key.

	* s/hpux10.h (LIBS_TERMCAP): New definition.

1996-07-15  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* window.c (struct save_window_data, struct saved_window): First
	placeholder member is EMACS_INT, not int.

	* print.c (print): Fix args in strout calls.

	* xterm.h (struct x_output): Member saved_button_event replaced by
	saved_menu_event.
	* xmenu.c (x_activate_menubar): Allow any event, not just ButtonPress.
	* xterm.c (SET_SAVED_MENU_EVENT): New macro.
	(SET_SAVED_BUTTON_EVENT, SET_SAVED_KEY_EVENT): New macros.
	(XTread_socket): Defer key events as well as button presses.

	* frame.c (Qmouse_leave_buffer_hook): Delete redundant definition.
	(syms_of_frame_1): Delete the duplicate assignment and staticpro.
	* lisp.h (Qmouse_leave_buffer_hook, Qfont): Declare here.
	* floatfns.c (Qarith_error): Delete redundant definition.
	* xfns.c (Qfont): Delete redundant definition.
	(syms_of_xfns): Delete the duplicate assignment and staticpro.
	* w32fns.c (Qfont): Delete redundant definition.
	(syms_of_win32fns): Delete the duplicate assignment and staticpro.
	* xfns.c (xlwmenu_default_font): Declare, but don't define.
	* xselect.c (last_event_timestamp): Declare, but don't define.

1996-07-15  David Mosberger-Tang <davidm@AZStarNet.com>

	* m/alpha.h (TEXT_START, DATA_START, DATA_SEG_BITS, UNEXEC, DATA_END):
	Omit these definitions if ELF.
	(LINUX_SBRK_BUG): Omit this if using a recent GNU library.
	[__ELF__] (C_SWITCH_MACHINE): Define.
	(NO_TERMIO): Define this unconditionally.
	(COFF): Omit this if ELF.
	* config.in (HAVE_TERMIOS_H): Add #undef.
	* cm.h [HAVE_TERMIOS_H]: Declare ospeed as speed_t.
	* sysdep.c [HAVE_TERMIOS_H]: Likewise.
	* dispnew.c: Don't delare ospeed; cm.h already did it.
	* terminfo.c: Use <config.h>.
	[HAVE_TERMIOS_H]: Declare ospeed as speed_t.
	[USG]: Include <string.h>.
	* data.c (arith_error): Don't reinstall sig handler if POSIX_SIGNALS.
	* keyboard.c (input_available_signal, interrupt_signal): Likewise.
	* process.c (create_process_1, sigchld_handler): Likewise.
	* unexelf.c: Add 64-bit ELF and Alpha/ELF support.

1996-07-13  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* search.c (Fmatch_data): If no matching done yet, return Qnil.

1996-07-13  Paul Eggert  <eggert@twinsun.com>

	* vmstime.c (sys_gmtime): Don't assume year < 2000.

1996-07-13  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* process.c (wait_reading_process_input) [hpux]: Workaround for
	annoying messages.

1996-07-12  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* indent.c (Fvertical_motion): Doc fix.

1996-07-11  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32fns.c (win32_wnd_proc): Handle WM_ERASEBKGND and
	WM_PALETTECHANGED messages inline (as they should be).

	* w32term.c (w32_read_socket): Remove unused WM_ERASEBKGND code.
	No need to erase background now on (delayed) WM_PAINT.  Move
	WM_PALETTECHANGED processing to raw input thread.

1996-07-11  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* keyboard.c (menu_bar_item): Skip menu-bar equiv keys data
	to get just the keymap.

	* s/irix5-0.h [__GNUC__] (C_DEBUG_SWITCH): New definition.

1996-07-11  David Mosberger-Tang  <davidm@AZStarNet.com>

	* mem-limits.h (lim_data): Make this an unsigned long.

1996-07-11  Bill Mann  <dvmann@dvncr.praxisint.com>

	* s/usg5-4-3.h: New file.

1996-07-11  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xterm.c (XTread_socket): Add #ifdef for previous change.

1996-07-11  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* buffer.c (syms_of_buffer): Doc fix.

1996-07-08  Roland McGrath  <roland@delasyd.gnu.ai.mit.edu>

	* mem-limits.h [_LIBC]: Use weak_extern instead of weak_symbol for
	__data_start.

1996-07-07  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>

	* s/gnu.h: Enable use of ncurses library cleanly.

1996-07-07  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* xterm.c: Undo previous change.
	(XTread_socket): Better way to avoid sending toolkit-specific
	events to Emacs.

1996-07-07  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* xmenu.c (popup_get_selection): For a ButtonRelease on the proper
	display, don't queue it, and always deactivate the menu.

1996-07-07  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (IT_menu_display): Display control characters as ^X.
	(XMenuAddPane, XMenuAddSelection): Adjust menu width for control
	characters (displayed as ^X).

	* dired.c (file_name_completion): Set `stat' flags to avoid
	computing expensive fields in struct stat (makes filename
	completion much faster).

	* fileio.c (Fcopy_file): Use st_ino under DJGPP v2 and later to
	prevent copying file into itself.
	(check_executable): DJGPP v2 `stat' doesn't need to be augmented
	in case of executable files.
	(Ffile_modes): Use `stat' results as is in DJGPP v2 and later.

1996-07-04  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (dostounix_filename): On caseless filesystems, downcase
	the filename.
	(unixtodos_filename): Downcase the drive letter.
	(init_environment): Downcase the pathnames in the environment only
	when running on caseless filesystems.

1996-07-03  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (normalize_filename): Always lower-case drive letters, even
	on systems that preserve case in filenames.

	* fileio.c (DRIVE_LETTER) [WINDOWSNT]: Lower-case drive letters.

1996-07-05  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32term.c (x_set_mouse_pixel_position): Adjust coords by frame
	position.
	(x_set_mouse_position): Call x_set_mouse_pixel_position.

1996-07-05  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (sys_rename): Do not delete newname if only changing case.
	On Windows 95, use our version of mktemp (not the MSVC version)
	and give the temp name a long extension to ensure the final rename
	works as expected.

1996-07-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* callproc.c (Fcall_process) [MSDOS]: Initialize fd[0]; unlink
	`tempfile' in case of errors.
	(Fcall_process): When fd_error is negative,
	don't close fd[0] if it's same as filefd.

1996-07-03  Eli Zaretskii  <eliz@is.elta.co.il>

	* callproc.c (Fcall_process) [MSDOS]: Make the `tempfile'
	parameter passed to `report_file_error' be a Lisp string.
	(Fcall_process): If stderr is redirected to NULL_DEVICE, make
	`report_file_error' print the name of device.  Make the arguments
	a cons cell.

1996-07-06  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* indent.c (Fvertical_motion): Doc fix.

1996-07-03  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xterm.c (XTread_socket): Use lw_tookit_related_event_p to
	avoid sending toolkit-specific events to Emacs.

1996-07-01  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* m/alpha.h (HAVE_X11R4, HAVE_X11R5): Definitions deleted
	since xterm.h and config.h should take care of them.

	* xselect.c (x_clear_frame_selections): Don't call
	redisplay_preserve_echo_area here.

1996-06-30  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* systty.h: Delete spurious period from last change.

1996-07-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* fileio.c (DRIVE_LETTER) [MSDOS]: Lower-case drive letters.

	* msdos.c (msdos_downcase_filename): Always lower-case drive
	letters, even on systems that preserve case in filenames.

1996-06-29  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/sol2-5.h (LIB_MOTIF): Fix typo.

	* emacs.c (main): Add `GNU Emacs' to the response to --version.

	* xfns.c (Fx_create_frame): Gcpro parms, parent, and name.

	* systty.h (GETPGRP_NO_ARG): Always define it, if __GNU_LIBRARY__.

1996-06-28  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* frame.c (make_frame_without_minibuffer): GCPRO the frame f.

	* config.in (AMPERSAND_FULL_NAME): Defined by default.

	* s/sol2-5.h (LIB_MOTIF): New definition.

	* emacs.c (standard_args): Delete `-rn' option.

	* .gdbinit: Add `dir ../lwlib'.

	* print.c (print): Obey Vprint_length for vectors, bitvectors.

	* fileio.c (check_executable): Use euidaccess, not eaccess.

	* config.in (HAVE_EUIDACCESS): This replaces HAVE_EACCESS.

	* xterm.h: Don't define HAVE_X11R5 here.

	* config.in (HAVE_X11R5): Add #undef.

	* unexhp9k800.c (unexec): Cast result of sbrk.
	(run_time_remap): Cat arg to brk.

1996-06-27  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_connection_closed): Call clear_waiting_for_input.

	* keyboard.c (modify_event_symbol): Add properly to *symbol_table.

1996-06-26  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_connection_closed): Add newline when printing error
	message on stderr.
	(XTread_socket, Xatom_wm_save_yourself clause):
	Don't call XSetCommand if f is 0.
	(x_error_quitter): Delete newline from sprintf string.

	* xdisp.c (redisplay_internal): Use last_had_star to decide
	whether to update the mode line to update the star.
	(update_menu_bar): Likewise.
	Also, don't set w->update_mode_line for frames that use
	set_frame_menubar.
	(redisplay_internal, mark_window_display_accurate):
	Set last_had_star.

	* window.h (struct window): New field, last_had_star.

1996-06-25  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_connection_signal): Just return after calling `signal'.
	(X_CONNECTION_LOCK_FLAG): Definition deleted.
	(x_connection_signal_dpyinfo): Variable deleted.
	(x_connection_signal_1): Function deleted.
	(x_connection_close_if_hung): Function deleted.

	* indent.c (Fmove_to_column): Go after invis chars at the goal column.

1996-06-24  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xterm.c (x_connection_closed): If waiting_for_input,
	call quit_throw_to_read_char.

1996-06-24  Paul Eggert  <eggert@twinsun.com>

	* unexelf.c (unexec): Round up section header offset to bss alignment
	before deciding whether it's after the bss section.

1996-06-23  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xfns.c (x_real_positions): Don't call x_uncatch_errors twice.

	* indent.c (current_column_1): Add declaration.

1996-06-22  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* indent.c: Make current-column, move-to-column and current-indentation
	handle invisible chars (both text properties and overlays).
	(skip_invisible): New function.
	(Fmove_to_column): Use skip_invisible.  Get rid of `retry' label.
	(compute_motion): Use skip_invisible.
	(current_column_1): New function.
	(current_column): Use current_column_1 if might have invisible text.

	* data.c (Fdefalias): Doc fix.

	* s/gnu-linux.h (LD_SWITCH_SYSTEM): Just one definition.
	Don't use prefix-args here because Makefile.in
	does that when necessary.

1996-06-21  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/sco5.h: New file.

	* s/gnu-linux.h: Renamed from lignux.h.
	(SYSTEM_TYPE): Changed to gnu/linux.

	* callproc.c (Fcall_process): Fix previous change.

	* xterm.c (x_iconify_frame): If frame is invisible,
	explicitly mark it as iconified.

	* keyboard.c (kbd_buffer_get_event): Don't call x_activate_menubar
	for a deleted frame.

1996-06-19  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* s/sol2-4.h (LD_SWITCH_SYSTEM): Use no space after -L and -R.

1996-06-18  Nico Francois  <nico.francois@scala.nl>

	* w32fns.c (Vwin32_alt_is_meta): New variable.
	(win32_get_modifiers): Map Alt to alt_modifier if required.
	(syms_of_win32fns): DEFVAR new variable.

	* ntinevt.c (Vwin32_alt_is_meta): Declared.
	(win32_kbd_mods_to_emacs): Map Alt to alt_modifier if required.

1996-06-16  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* callproc.c (Fcall_process): Handle t or nil as STDERR_FILE.

	* s/hpux10.h (HPUX10): New macro.

1996-06-14  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32fns.c (win32_wnd_proc): No need to forward WM_ERASEBKGND to
	main thread.

	* w32term.c (w32_read_socket): Erase update rect on WM_PAINT, so
	no need to process WM_ERASEBKGND.

1996-06-13  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xmenu.c (Qmenu_alias): New variable.
	(syms_of_xmenu): Initialize it.
	(menu_item_equiv_key): Check this property on the definition.

	* fileio.c (Fexpand_file_name): When simplifying /foo/..,
	keep the initial slash.

	* s/hpux10.h (LIBS_SYSTEM): Two new definitions (and #undef first).

1996-06-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* emacs.c (main): For SIGHUP, use sigblock and sigunblock,
	not sigblockx and sigunblockx.

	* buffer.c (Fkill_buffer): Doc fix.

1996-06-12  Andrew Innes  <andrewi@harlequin.co.uk>

	* ntproc.c (restrict_dos_process): Variable deleted.
	(sys_spawnve): Restrict DOS processes on NT as well.

	* nt.c: Delete restrict_dos_process.

1996-06-12  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (restrict_dos_process): Renamed from can_run_dos_process.
	(init_ntproc): Refer to restrict_dos_process.

	* ntproc.c (restrict_dos_process): Renamed from can_run_dos_process.
	(sys_spawnve): Refer to restrict_dos_process.

1996-06-12  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* syssignal.h (sigunblockx): Use sigunblock.

1996-06-11  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* process.c (wait_reading_process_input): Move the O_NONBLOCK and
	O_NDELAY conditionals out of the EWOULDBLOCK conditional.

1996-06-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (Fset_keymap_parent): Return early if KEYMAP already has
	the proper parent.

	* s/lignux.h [__ELF__] (LD_SWITCH_SYSTEM): Define it.

	* frame.c (Fmake_terminal_frame): Test MSDOS, not __MSDOS__.

	* xdisp.c (redisplay_internal): Use FRAME_WINDOW_P.
	(decode_mode_spec): Likewise.

	* minibuf.c (choose_minibuf_frame): Eliminate
	MSDOS-non-MULTI_FRAME conditional.

	* dispnew.c (change_frame_size, remake_frame_glyphs):
	Use FRAME_WINDOW_P.

	* msdos.c (check_x): Fix error message.

1996-06-09  Eli Zaretskii  <eliz@is.elta.co.il>

	* xfaces.c (init_frame_faces): Build faces for an MSDOS frame
	like for X frame.
	(Fmake_face_internal): Call `ensure_face_ready' for MSDOS frames.
	(Fset_face_attribute_internal): Support face attributes for MSDOS
	frames.

	* xdisp.c (redisplay_internal): Use `Vterminal_frame' and other
	termcap frame code on MSDOS as well.
	(display_text_line) [HAVE_FACES]: Support faces on MSDOS.
	(decode_mode_spec): Return frame name on MSDOS like for termcap
	frames.

	* window.c (Fset_window_configuration) [HAVE_WINDOW_SYSTEM]: Call
	`x_set_menu_bar_lines' on MSDOS as well.

	* msdos.h (check_x): Macro definition deleted.
	(DisplayWidth): Use `selected_frame'.
	(DisplayHeight): Use `selected_frame'.
	(x_mouse_leave): Remove; it's not used.

	* msdos.c (x_set_menu_bar_lines): New function, copied from xfns.c.
	(IT_set_frame_parameters): Use selected_frame instead of
	the_only_frame.
	(internal_terminal_init): Use selected_frame instead of the_only_frame.
	(check_x): New function, replacing macro in msdos.h.
	(XMenuActivate): Use selected_frame instead of
	the_only_frame.  Don't let the title for the "Buffers" popup
	include a number when it is split into several menus.

	* minibuf.c (choose_minibuf_frame): Support multiple frames on MSDOS.

	* frame.h (FRAME_MSDOS_P): A new macro for MSDOS frames.

	* frame.c (Qpc): New variable.
	(syms_of_frame_1): Define and staticpro it.
	(Fframep): Support MSDOS frames.
	(make_terminal_frame, Fmake_terminal_frame): Support MSDOS frames.
	(Fset_mouse_position, Fset_mouse_pixel_position): Support MSDOS frames.
	(Fframe_parameters, Fmodify_frame_parameters): Support MSDOS frames.

	* dosfns.c (Fset_mouse_position): Remove the DOS-specific
	definition (it's defined on `frame.c').
	(syms_of_dosfns): Remove defsubr of `Fset_mouse_position'.

	* dispnew.c (Fredraw_frame, remake_frame_glyphs)
	(direct_output_for_insert, change_frame_size): Support MSDOS frames.

1996-06-10  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (fix_submap_inheritance): If parent_entry is not a keymap,
	use nil instead.

	* alloc.c (mark_object): Do set ARRAY_MARK_FLAG for bool-vectors.

1996-06-10  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32fns.c (x_to_win32_font): Allow any quality fonts.

1996-06-09  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keyboard.c (read_char): Use unsigned to compare against
	the size of Vkeyboard_translate_table.
	Check size for char-table too.

	* s/freebsd.h (DONT_REOPEN_PTY): New definition.

	* process.c (create_process): Add DONT_OPEN_PTY conditional.

1996-06-07  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (init_environment): Read PRELOAD_WINSOCK from registry if
	not set in environment.

	(winsock_inuse) [HAVE_SOCKETS]: New variable.
	(have_winsock) [HAVE_SOCKETS]: Obsolete variable removed.

	(term_winsock) [HAVE_SOCKETS]: Only unload winsock library if there
	are no active sockets still open, and if the cleanup function
	succeeds.  Return TRUE if winsock is unloaded.

	(init_winsock) [HAVE_SOCKETS]: Load winsock if not already loaded,
	and return TRUE if winsock support is available.  Unload winsock
	immediately if new parameter load_now is false.  Check that
	WSAStartup supports the winsock version we requested.

	(set_errno, check_errno, sys_socket, sys_bind, sys_connect,
	sys_htons, sys_ntohs, sys_inet_addr, sys_gethostname,
	sys_gethostbyname, sys_getservbyname, sys_close, sys_read,
	sys_write) [HAVE_SOCKETS]: Check winsock_lib instead of
	have_winsock to determine if winsock support is available.

	(sys_socket, sys_close) [HAVE_SOCKETS]: Count sockets in use.

	(init_ntproc) [HAVE_SOCKETS]: Only load winsock library on startup
	if PRELOAD_WINSOCK is set in environment (or registry).

	* ntproc.c (Fwin32_has_winsock,
	Fwin32_unload_winsock) [HAVE_SOCKETS]: New functions.
	(syms_of_ntproc) [HAVE_SOCKETS]: defsubr them.

	* process.c (Fopen_network_stream) [WINDOWSNT]: Ensure Windows
	socket library is loaded if available.

1996-06-07  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xterm.c (XTread_socket): Use XtAppNextEvent when using
	toolkit configurations.

1996-06-07  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (sys_mktemp): Complete rewrite.

1996-06-07  Andrew Innes  <andrewi@harlequin.co.uk>

	* ntproc.c (sys_kill): Don't try to terminate a DOS process.

1996-06-06  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Ffile_name_directory) [WINDOWSNT]: Remove previous
	change, which was incorrect and isn't strictly required.

1996-06-06  Eli Zaretskii  <eliz@is.elta.co.il>

	* xfaces.c (Fset_face_attribute_internal) [MSDOS]: Don't mask
	bright color bit in background colors.

	* msdos.c (bright_bg): New function, enables bright background colors.
	(dos_set_window_size): Move code to `bright_bg'.
	(IT_set_terminal_modes): Enable bright background colors.
	(IT_set_frame_parameters): Don't mask bright color bit in
	background colors.  Record colors on `termscript' file.
	(internal_terminal_init): Enable bright background colors.  Fix
	default colors setting from $EMACSCOLORS.

1996-06-07  Geoff Voelker  <voelker@joker.cs.washington.edu>

	* w32fns.c (sync_modifiers): New function.
	(w32_wnd_proc): Synchronize modifiers on each key down.

1996-06-06  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (init_winsock): Dynamically link to SetHandleInformation.
	(sys_socket): If possible, use SetHandleInformation to make socket
	handle non-inheritable to avoid a bug in NT.

1996-06-05  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* keymap.c (Fkeymap_parent, Fset_keymap_parent): New functions.
	(fix_submap_inheritance): New function.
	(access_keymap): Use fix_submap_inheritance.

1996-06-05  Paul Eggert  <eggert@twinsun.com>

	* editfns.c: (set_time_zone_rule):
	Work around localtime cache bug in SunOS 4.1.3_U1 and SunOS 4.1.4.

1996-06-04  Geoff Voelker  <voelker@joker.cs.washington.edu>

	* w32term.c (w32_read_socket): If the dead key was produced using
	AltGr and has a valid AltGr scan code, it's a valid key and
	should not be discarded.

1996-06-03  Kim Storm  <storm@olicom.dk>

        * ntproc.c (Vwin32_downcase_file_names): New variable.
        (syms_of_win32fns): DEFVAR it.

        * fileio.c (DRIVE_LETTER): [DOS_NT] New macro.
        (expand_file_name): Apply DRIVE_LETTER macro to drive names.

        * nt.c (normalize_filename): New function.
        (dostounix_filename, unixtodos_filename): Use it.
        (readdir): Convert upper case file names to lower case
        if win32-downcase-file-names is non-nil.

1996-05-31  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Fexpand_file_name) [WINDOWSNT]: Don't strip trailing /
	when newdir is just "//".
	(Ffile_name_directory) [WINDOWSNT]: Return Qnil if filename is a
	partial UNC name such as "//foo".

1996-05-31  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* xmenu.c (single_submenu): Handle non-keymap lists like symbols.

	* w32fns.c (reset_modifiers): Only clear a modifier if the
	modifier key has been detected to have been released since
	Emacs lost focus.
	(win32_wnd_proc): Have Windows translate VK_NUMLOCK and
	VK_SCROLL key downs; don't reset the modifier state when
	Emacs loses focus.

1996-05-30  Richard Stallman  <rms@psilocin.gnu.ai.mit.edu>

	* buffer.c (Fpop_to_buffer): Doc fix.

	* window.c (Fdisplay_buffer): Doc fix.

1996-05-27  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* s/sol2.h (LIBS_SYSTEM): Define this.

1996-05-25  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* Version 19.31 released.

1996-05-25  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* m/sparc.h [__linux__] (A_TEXT_OFFSET, A_TEXT_SEEK): Don't define.

1996-05-24  Marcus Daniels  <marcus@sayre.sysc.pdx.edu>

	* xterm.c [SOLARIS2]: Include string.h.

1996-05-24  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32fns.c: (Vwin32_mouse_move_interval): New lisp variable.
	(syms_of_win32fns): Add Vwin32_mouse_move_interval to syms.
	(saved_mouse_msg): Renamed to saved_mouse_button_msg.
	(timer_id): Renamed to mouse_button_timer.
	(saved_mouse_move_msg, mouse_move_timer): New variables.
	(win_msg_worker): Delete WM_TIMER code.
	(win32_wnd_proc): Handle WM_TIMER events here. Use separate timers
 	for mouse down and mouse move (including scroll bar drag) events.
	Add new handling code for WM_VSCROLL and WM_MOUSEMOVE events.
	Only filter WM_MOUSEMOVE events when a button is held down.
	Always pass on message to DefWindowProc after calling
	TranslateMessage.  Reset keyboard modifiers when losing focus.

	* w32term.c (x_scroll_bar_handle_click): Repaint scroll bar handle
	when drag is finished.

1996-05-23  Geoff Voelker  <voelker@joker.cs.washington.edu>

	* w32fns.c (win32_wnd_proc): When passing modifier keystrokes back
	to Windows, invoke TranslateMessage on them.
	(reset_modifiers): Don't reset Window's keyboard state.

1996-05-23  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* lread.c (init_lread): Init Vload_file_name to Qnil.

1996-05-21  Geoff Voelker  <voelker@joker.cs.washington.edu>

	* w32fns.c (modifier_set): Check toggle state of CapsLock even
	if modifiers are not being recorded.

1996-05-21  Andrew Innes  <andrewi@harlequin.co.uk>

	* nt.c (get_volume_info): Always update *pPath correctly, even if
	UNC header is incomplete.

1996-05-21  Richard Stallman  <rms@whiz-bang.gnu.ai.mit.edu>

	* indent.c (compute_motion): When calling Fget_char_property,
	don't pass window if window is displaying the wrong buffer.

	* dispnew.c (init_display) [HAVE_LIBNCURSES]: If X, call tgetent.

	* keyboard.c (Fexecute_extended_command): Don't look for
	a key binding if executing a kbd macro.

	* print.c (Fprin1_to_string): Preserve Vdeactivate_mark.

	* systty.h [__GNU_LIBRARY__]: #include <sys/ioctl.h>.

	* cmds.c (internal_self_insert): Don't return 2 for auto-fill
	unless the auto_fill_function returns non-nil.

1996-05-17  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* nt.h (struct _child_process): New member is_dos_process.
	* nt.c (_sys_read_ahead): Handle sleep here.
	(sys_read): Not here.
	(init_ntproc): Initialize can_run_dos_process, dos_process_running.
	* ntproc.c (Vwin32_pipe_read_delay): New var.
	(can_run_dos_process, dos_process_running): New vars.
	(win32_is_dos_binary): New function.
	(reap_subprocess, sys_spawnve): Use them.
	(syms_of_ntproc): Defvar and initialize Vwin32_pipe_read_delay.

	* xdisp.c (display_menu_bar) [HAVE_NTGUI]: Enable the display of
	menus in --no-window mode on NT.

1996-05-17  Geoff Voelker  <voelker@cs.washington.edu>

	* w32term.c (w32_read_socket): Mask out lower 4 bits of wParam
	for WM_SYSCOMMAND messages.

1996-05-15  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* makefile.nt: Fix typo in previous patch.

	* callproc.c (Fcall_process): Don't close the same fd twice.

1996-05-15  Kim Storm  <storm@olicom.dk>

	* nt.c (sys_read): Introduce a small delay before reading from
	a pipe or socket to allow more data to be buffered; otherwise,
	process output is read one byte at a time on fast machines
	(which is slow).

1996-05-14  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* w32select.c (QCLIPBOARD): New symbol.
	(Fx_selection_exists_p): New function.
	(syms_of_win32select): Initialize/staticpro and defsubr them.

1996-05-13  Richard Stallman  <rms@mole.gnu.ai.mit.edu>

	* makefile.nt (w32*.obj): Fix deps.

1996-05-13  Andrew Innes  <andrewi@harlequin.co.uk>

	* eval.c (Fsignal) [HAVE_WINDOW_SYSTEM]: Changed from
 	HAVE_X_WINDOWS, so that TOTALLY_UNBLOCK_INPUT is called on Windows.

	* w32fns.c (win32_wnd_proc): Reenable quit_char detection.

1996-05-13  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* w32menu.c: Include buffer.h.
 	(set_frame_menubar): Make sure input is unblocked
	when we call create_menu_items.
	Switch temporarily to proper buffer, bind inhibit-quit to t,
	and run the same hooks as in smenu.c.
	(syms_of_win32menu): Initialize and staticpro Qdebug_on_next_call.

	* w32term.c (note_mouse_movement): Upwards mouse movement
	recognition corrected.

1996-05-12  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* callproc.c (Fcall_process): Fix previous change (now !MSDOS only).

1996-05-12  Karl Heuer  <kwzh@gnu.ai.mit.edu>

	* macros.c (Fstart_kbd_macro): Add missing xrealloc arg.

1996-05-12  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* Makefile.in (MSDOS_SUPPORT): Use full name disp-table.elc.

1996-05-12  Eli Zaretskii  <eliz@is.elta.co.il>

	* dosfns.c (init_dosfns) [DJGPP >= 2]: Make `opendir' preserve
	filename case (under Windows 95) and find hidden files.

	* msdos.c (Fmsdos_downcase_filename): Don't change the argument,
	return a copy.

1996-05-11  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (msdos_downcase_filename): New function to convert case
	in filenames.
	(Fmsdos_downcase_filename): New function.
	(syms_of_msdos): Defsubr it.

	* s/msdos.h (FILE_SYSTEM_CASE): Call Fmsdos_downcase_filename
	instead of Fdowncase.

1996-05-11  Geoff Voelker  <voelker@cs.washington.edu>

	* s/windowsnt.h (SYSTEM_PURESIZE_EXTRA): Macro defined.

1996-05-11  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32term.c (x_scroll_bar_set_handle): Always use start
	in calling SetScrollPos.
	(x_scroll_bar_handle_click): In line up/down cases, don't alter y.
	Don't call x_scroll_bar_set_handle.

	* nt.c (map_win32_filename): If not a fat volume, cvt name to dos.

1996-05-11  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* ntheap.c (allocate_heap): Clean up conditional.

1996-05-11  Geoff Voelker  <voelker@cs.washington.edu>

	* ntheap.c (allocate_heap): Bump heap base up to 27MB to
	satisfy Windows 95.

1996-05-10  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* callproc.c (Fcall_process): Close fd_error if successful.

1996-05-10  Geoff Voelker  <voelker@cs.washington.edu>

	* w32fns.c (win32_wnd_proc): Disable setting of Vquit_flag
	at this point.

1996-05-10  Andrew Innes  <andrewi@harlequin.co.uk>

	* w32fns.c (win_msg_worker): Use post_msg.
	(win32_wnd_proc): Don't abort if button_state & this, just return.
	Use post_msg instead of my_post_msg in some places.
	(win32_to_x_font): Major rewrite.
	(struct enumfont_t): New element logfont.
	(enum_font_cb2): Add special code for TRUETYPE_FONTTYPE.
	(Fx_list_fonts): Call x_to_win32_font.

	* w32term.c (x_scroll_bar_move): Call my_show_window.
	(x_scroll_bar_clear): Likewise.

	* ntterm.c (prev_console_mode): New variable.
	(unset_kbd): Use prev_console_mode.
	(reset_kbd): Set prev_console_mode.  Call Fset_input_mode.

	* emacs.c (main) [WINDOWSNT]: Call syms_of_ntproc.

	* ntproc.c (Vwin32_quote_process_args): New variable.
	(sys_spawnve): If Vwin32_quote_process_args, quote the args.
	(syms_of_ntproc): Set up Lisp variable.

1996-05-10  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* xterm.c (x_connection_signal_1): Call x_connection_closed properly.

1996-05-08  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* msdos.c (syms_of_msdos): Fix typo.

1996-05-07  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* termhooks.h (enum scroll_bar_part): Delete extra comma.

1996-05-06  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* msdos.c (Fmsdos_long_file_names): New function.
	(syms_of_msdos): Defsubr it.

	* s/msdos.h (GMALLOC_INHIBIT_VALLOC): Defined.

	* casetab.c (set_case_table): Set upcase_table, case_canon_table
	and case_eqv_table in the buffer.

	* casefiddle.c (casify_region, casify_object):
	If case table has been changed, call Fset_case_table.

1996-05-04  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* editfns.c (Fencode_time): Accept MANY args, so as to cope
	with the value of decode-time.

1996-05-03  Andrew Innes  <andrewi@harlequin.co.uk>

	* keyboard.c (Qup, Qdown): New variables.
	(syms_of_keyboard): Initialize and staticpro.
	(scroll_bar_parts): Add Qup and Qdown.
	(make_lispy_event) [WINDOWSNT]: Handle win32_scroll_bar_click.

	* termhooks.h (enum scroll_bar_part): New alternatives
	scroll_bar_up_arrow, scroll_bar_down_arrow.
	(win32_scroll_bar_click): New enum constant.

1996-05-03  Andrw Innes <andrewi@harlequin.co.uk>

	* makefile.nt (SUBSYSTEM) [NTGUI]: Remove conditional.
	(LINK_FLAGS): Explicitly set base address, and stack and heap sizes.
	(nt.obj): Add dependency to nt.h.

	* nt.c (nt_ctime): Function renamed to sys_ctime.

	Undefine macros for shadowed CRT functions.
	(nt_stat, get_unassigned_drive_letter, is_toplevel_share_name,
 	stat_toplevel_share): Functions deleted.

	Include sys/socket.h and
 	undefine macros for shadowed socket functions.

	(getwd): Return NULL if GetCurrentDirectory fails.

	(gethostname) [!HAVE_SOCKETS]: Replace with winsock version.

	(nt_sleep): Renamed to sys_sleep.

	(rename): Renamed to sys_rename. Always rename to a temporary name
 	first on Windows 95.  Unlink new name first if necessary.

	(dir_finding): Variable deleted.
	(dir_is_fat, dir_pathname): New variables.

	(openddir): Fail if dir_find_handle is in use. Save directory name
 	in dir_pathname, and set dir_is_fat appropriately.
	(closedir, readdir): Use dir_find_handle in place of dir_finding.
	(readdir): Copy directory name from dir_pathname on first
 	call. Use IS_DIRECTORY_SEP instead of IS_ANY_SEP.  Force filename
 	to be lower case on FAT volumes.

	(getpwuid): Move struct passwd initialization to init_user_info,
	return information for current user if uid matches.

	(getuid, geteuid): Return uid determined by init_user_info.
	(getgid, getegid): New functions.

	(getpwnam): Ignore case when comparing name.
	(init_user_info): New function.  Determine user name and id from
	NT security calls if possible, otherwise try Windows networking
	calls before falling back to hard-coded defaults.  Ensure HOME and
	SHELL environment variables are set.

	(unixtodos_filename): New function.

	(REG_ROOT): Trailing backslash removed.

	(init_environment): Call init_user_info.

	(get_inode_and_device_vals, pipe_with_inherited_out,
 	pipe_with_inherited_in): Functions deleted.

	(prepare_standard_handles, reset_standard_handles): Moved to
	ntproc.c and simplified to match other changes (all handles are
	already non-inheritable).

	(get_emacs_configuration): Detect Windows flavour (Windows 95 or
	NT) at run-time.  Change OS name for Windows 95 to be "win95".

	(fd_info): New variable. Array of extra info for file descriptors
	needed for pipe/socket support.

	(utc_base_ft, utc_base, init): New internal variables used for
	implementing stat.

	(get_volume_info, is_fat_volume, map_win32_filename, convert_time,
	convert_from_time_t, hashval, generate_inode_val): New
	internal support functions for shadowed C library functions.

	(sys_access, sys_chdir, sys_chmod, sys_link, sys_mkdir,
	sys_mktemp, sys_rmdir, sys_unlink): Call map_win32_filename
	before calling shadowed C library function.

	(sys_fopen, sys_open): Map file names, and ensure file handle is
 	non-inheritable.

	(stat): Replace buggy library function.  Fake reaonsable i-node
	values by hashing the canonical file name, and use uid/gid values
	determined by init_user_info.

	(term_winsock, init_winsock, set_errno, check_errno)
 	[HAVE_SOCKETS]: New internal socket support functions (plus
 	associated variables) required to support dynamic linking to
 	Windows socket library.

	(sys_socket, sys_bind, sys_connect, sys_htons, sys_ntohs,
 	sys_inet_addr, sys_gethostname, sys_gethostbyname,
 	sys_getservbyname) [HAVE_SOCKETS]: New functions to provide
 	dynamically loaded interface to Windows socket library.

	(sys_close, sys_dup, sys_dup2, sys_read, sys_write): New wrappers
	for C library functions to handle sockets and pipes.

	(sys_pipe): Make pipe handles non-inheritable, and set binary mode
	as required.

	(_sys_read_ahead): New internal support function for pipe/socket
 	support in sys_select.

	(term_ntproc): New function.
	(init_ntproc): New function to initialise socket support and make
	initial std handles non-inheritable.  Also ensure stdin, stdout
	and stderr have valid handles so that pipes and sockets can't
	inadvertently use fd 0, 1, or 2.

	* nt.h: Check to see if already included.
	(fd_set, filedesc): New structures.
	(child_process, MAX_CHILDREN, CHILD_ACTIVE): Definitions moved
	from ntproc.c.
	(FD_SET, FD_CLR, FD_ISSET, FD_ZERO): Operate on fd_set structures.
	(SELECT_TYPE): New macro.
	New child process status enumeration.
	(FILE_READ, FILE_WRITE, FILE_BINARY, FILE_PIPE, FILE_SOCKET):
	New macros.
	(fd_info, new_child, delete_child): Declared.

	* ntheap.c: Include lisp.h.
	(allocate_heap): Use VALBITS to determine size of heap.
	(allocate_heap) [WINDOWS95]: Conditional code removed.
	(sbrk): Use VALMASK instead of an unsigned integer mask.

	* ntinevt.c (win32_kdb_patch_key): Initialize isdead.
	(key_event) [HAVE_NTGUI]: Use Windows key code.

	* ntproc.c: Include config.h after CRT headers. Include fcntl.h.
	(child_process, MAX_CHILDREN, CHILD_ACTIVE): Moved to nt.h.
	(DebugPrint): New macro.
	(new_child): Create input event structures for child processes.
	(delete_child): New function.
	(reader_thread): Return nonzero upon failure.  Use _sys_read_ahead.
	(create_child): Add child_process and parent PID arguments.
	Don't create input event or thread structures here.
	Fixup Windows 95 negative process IDs.
	(register_child): Don't set consumed event; instead, set thread
	status so that select will release it.
	(remove_child): Renamed to reap_process.  Only free resources
	of synchronous children.
	(win32_wait): Renamed to sys_wait.  Sanity check to make sure
	handle to subprocess exists.  Don't reclaim thread resources here.
	(win32_spawnve): Renamed to sys_spawnve.
	Check for proper wait mode first thing.
	Convert command name to DOS format.
	Quote whitespace and quotes in arguments to subprocess.
	Use alloca instead of malloc.
	If max subprocesses, return EAGAIN in hopes of another completing.
	(sys_select): Add support for socket input.  Remove dead code.
	Check input from children fairly.
	(sys_select) [HAVE_TIMEVAL]: Remove conditional check and code.
	(win32_kill_process): Renamed to sys_kill.  Use OpenProcess
	to terminate process.
	(prepate_standard_handles, reset_standard_handles): Moved here
	from nt.c.

	* ntterm.c (reset_kbd): Try to use interrupt input.

	* unexnt.c (WinMain): Function removed.
	(_start) [HAVE_NTGUI]: Don't invoke WinMain, but do set up
	WinMain args as crt0.c would.

	* w32fns.c (quit_char, Vwin32_enable_italics, Vwin32_enable_palette):
	New variables.
	(syms_of_win32fns): Set up new lisp variables.

	(Fwin32_rgb): Dead procedure removed.
	(Fwin32_define_rgb_color, Fwin32_load_color_file, win32_map_color,
	win32_regenerate_palette, win32_unmap_color): New functions.
	(syms_of_w32fns): Set up new lisp functions.
	(define_color): Use palettes.  Simulate use of PALETTE_RGB to
	use closest color instead of dithering.
	(map_mode): Function removed.
	(WIN32_COLOR, SET_WIN32_COLOR): New macros.

	(win32_init_class): Don't set CS_OWNDC in the WNDCLASS style.
	(win32_createwindow): Invoke ShowWindow to discard defaults
	from parent.
	(win32_wnd_proc): Use separate critical sections appropriately.
	Handle palette change, show window, and set window position messages.
	Record WINDOWPLACEMENT structure length.
	Detect quit_char.
	(Fx_create_frame): Set scrollbar width to be the system standard.

	(Ffocus_frame, Funfocus_frame): Functions now do nothing.

	(x_to_win32_weight, win32_to_x_weight): Handle "heavy", "extrabold",
	"light", "extralight", and "thin" fonts.
	(x_to_win32_charset, win32_to_x_charset): New functions.
	(win32_to_x_font): Use new height units.  Use win32_to_x_charset.
	(x_to_win32_font): Use x_to_win32_charset.  Support Win32 font names
	in addition to X font names.

	(win32_load_font, Fx_list_fonts, Fx_display_color_cells,
	Fx_display_mm_height, Fx_display_mm_width: Use GetDC directly.

	(Fx_open_connection): Support external color mapping files.

	(win32_abort): Map abort button to abort, retry to debug, and
	ignore to continue.

	* w32reg.c (REG_ROOT): Remove trailing backslash.

	* w32select.c (Fwin32_set_clipboard_data, Fwin32_get_clipboard_data):
	Calculate exact size of clipboard string with CRs removed or inserted.

	* w32term.c (Vwindow_system): Declared.
	(win32_fill_rect, dumpglyphs, do_line_dance, x_draw_box):
	Use Get/ReleaseFrameDC.

	(pixel_to_glyph_coords): Support tty mode.
	(w32_read_socket): Explicitly use FALSE.
	Handle WM_PALLETTECHANGED event.
	(parse_button): Handle mouse button emulation.

	(my_show_window, my_set_window_pos): New functions.
	(x_set_offset, x_set_window_size, x_raise_frame, x_lower_frame):
	Use my_set_window_pos.
	(x_make_frame_visible, x_iconify_frame): Use my_show_window.

	(x_draw_box): Don't trim right and bottom.
	(x_make_frame_visible): Don't invoke SetForgroundWindow.

	(win32_term_init): Use GetDC directly.  Initialize palette
	and win32_num_mouse_buttons.
	(win32_update_begin): Regenerate palette if necessary.
	(x_delete_display): Free palette.

	(win32_initialize) [ATTACH_THREADS]: Only AttachThreadInput if
	conditional is defined.

	* w32term.h (struct win32_palette_entry): New structure.
	(win32_display_info): New fields has_palette, p_colors_in_use,
	n_colors_in_use, h_palette.
	(win32_output): New field h_old_palette.
	(WM_EMACS_SETWINDOWPOS): New macro.
	(WM_EMACS_DESTROY_WINDOW): Value redefined.
	(win32_window_pos): New structure.
	(GetFrameDC, ReleaseFrameDC): Functions declared.

	(my_get_dc): Macro undefined.
	(map_mode): Function declaration removed.
	(enter_crit, leave_crit): Function declarations changed to macros.

	* w32xfns.c: Include frame.h.
	(hEvent): Renamed to h_input_available.
	(init_crit, delete_crit, get_next_msg, post_msg):
	Use h_input_available.
	(GetFrameDC, ReleaseFrameDC): New functions.
	(leave_crit): Function removed.

	* s/windowsnt.h: Include string.h.
	(HAVE_FREXP, HAVE_FMOD): Macros removed.
	(struct timeval, struct timezone, gettimeofday): Declarations removed.
	(HAVE_SOCKETS, MAIL_USE_POP, MAIL_USE_SYSTEM_LOCK): Macros defined.
	(DIRECTORY_SEP): Use Vdirectory_sep_char.
	(EXEC_SUFFIXES): Add .cmd to list of suffixes.
	(HAVE_SYS_TIMEB_H, HAVE_SYS_TIME_H, HAVE_UNISTD_H, STDC_HEADERS,
	TIME_WITH_SYS_TIME, HAVE_GETTIMEOFDAY, HAVE_CLOSEDIR,
	HAVE_LONG_FILE_NAMES, HAVE_BCOPY, HAVE_BCMP, HAVE_LOGB, HAVE_FREXP,
	HAVE_FMOD, HAVE_FTIME, HAVE_MKTIME, HAVE_H_ERRNO): New macros.
	(access, chdir, chmod, close, creat, ctime, dup, dup2, fopen,
	link, mkdir, mktemp, open, pipe, read, rename, rmdir, select,
	sleep, unlink, write, spawnve, wait, kill, signal):
	Macros redefined from win32_* to sys_*.
	[__STDC__]: Define when including direct.h, io.h, stdio.h.
	(struct nt_stat): Definition removed.
	(stat, st_dev, st_ino, st_mode, st_nlink, st_uid, st_gid,
	st_rdev, st_size, st_atime, st_mtime, st_ctime): Macros undefined.

	* s/windows95.h: File removed.

1996-05-02  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* keyboard.c (Fthis_single_command_keys): New function.
	(syms_of_keyboard): defsubr it.
	(this_single_command_key_start): New variable.
	(add_command_key): Reduce this_single_command_key_start if nec.
	(command_loop_1): Clear this_single_command_key_start if nec.
	(Fread_key_sequence, Fexecute_extended_command): Likewise.
	(read_key_sequence): Set this_single_command_key_start.
	(command_loop_1): Clear echo area while inhibit-quit is still t.

1996-05-01  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* keyboard.c (Fevent_convert_list): Never treat last elt as modifier.

	* buffer.c (add_overlay_mod_hooklist): Fix call to bcopy.

	* insdel.c (signal_after_change): Correct the arg to
	report_overlay_modification.

	* s/sol2-4.h (C_SWITCH_X_SYSTEM): Definition moved from sol2.h.

	* s/sol2.h (C_SWITCH_X_SYSTEM): Definition moved to sol2-4.h.

1996-05-01  Eli Zaretskii  <eliz@is.elta.co.il>

	* msdos.c (dos_get_modifiers): Restore missing comment terminator.
	(getdefdir): Rewrite to call `_fixpath' instead of `intdos'.
	(run_msdos_command) [DJGPP > 1]: Work around some MSDOS
	command-line restrictions by running shell commands via `system'
	instead of `spawnve'.

	* fileio.c (Fexpand_file_name) [DOS_NT]: Correct the `if' clause
	to compile on all platforms.

1996-04-30  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* xterm.c [USE_X_TOOLKIT]: Include X11/Shell.h.
 	(x_wm_set_icon_pixmap) [USE_X_TOOLKIT]: Tell widget the new pixmap.

1996-04-29  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Fexpand_file_name) [DOS_NT]: Keep dir sep following ~
	or ~user, but don't collapse the newdir prefix in that case.

1996-04-26  Richard Stallman  <rms@delasyd.gnu.ai.mit.edu>

	* keyboard.c (make_lispy_event): FRAME_MENU_BAR_ITEMS now has
	four elements per item.  Add a separate slot for the hpos.
	(menu_bar_items): Likewise.
	(menu_bar_item): Initialize the hpos slot to 0.

	* xdisp.c (display_menu_bar): FRAME_MENU_BAR_ITEMS now has
	four elements per item.
	(update_menu_bar): If we update FRAME_MENU_BAR_ITEMS,
	also set w->update_mode_line.

	* xmenu.c (set_frame_menubar): FRAME_MENU_BAR_ITEMS now has
	four elements per item.

	* w32menu.c (get_frame_menubar_event, set_frame_menubar):
	FRAME_MENU_BAR_ITEMS now has four elements per item.

	* fileio.c (Fexpand_file_name, Ffile_name_absolute_p): Doc fixes.
	(Ffile_exists_p, Ffile_executable_p, Ffile_readable_p)
	(Ffile_writable_p, Ffile_directory_p, Ffile_regular_p)
	(Ffile_modes, Fset_file_modes, Ffile_newer_than_file_p)
	(expand_and_dir_to_file): Rename abspath to absname.

1996-04-26  Andrew Innes  <andrewi@harlequin.co.uk>

	* fileio.c (Fexpand_file_name) [!DOS_NT]: Fix incorrect expansion of
	"/foo/../bar" -> "//bar".  Delete relpath variable.

	* fileio.c (CORRECT_DIR_SEPS) [DOS_NT]: New macro.
	(IS_DRIVE) [DOS_NT]: Added separate definitions for DOS and NT.
	(Ffile_name_directory) [DOS_NT]: Simplify code to match change in
 	getdefdir in msdos.c.  Ignore embedded colons.  Correct dir seps.
	(Ffile_name_nondirectory) [DOS_NT]: Ignore embedded colons.
	Correct IS_ANY_SEP to IS_DIRECTORY_SEP.
	(file_name_as_directory) [DOS_NT]: Correct dir seps.
	Correct IS_ANY_SEP to IS_DIRECTORY_SEP.
	(directory_file_name) [DOS_NT]: Correct dir seps.
	(Fmake_temp_name) [DOS_NT]: Correct dir seps.
	(Fexpand_file_name) [DOS_NT]: Remove relpath, tmp and
 	defdir variables; init drive to 0.
  	Correctly detect when default_directory is absolute.
  	Be strict when looking for MSDOS drive specifier; defer calling
	getdefdir.  Ignore drive specifier if name now has UNC prefix.
  	Correctly recognise if name is not absolute when trying simple
 	method to expand; return original string if possible.
  	Skip dir sep after ~ or ~user.
  	Use getpwnam instead of HOME for ~user on NT.
  	Handle error return from getdefdir.
  	Correctly detect if newdir is absolute before using default_directory.
  	Handle case where newdir is not absolute - expand relative to
 	current working dir if necessary (instead of calling getdisk
 	later).  Only keep UNC prefix if nm starts with dir sep.
  	Replace kludgy handling of drive spec in newdir.  Correct dir seps.
	(Fsubstitute_in_file_name) [DOS_NT]: Correct dir seps for NT as
 	well.  Merge equivalent #ifdef APOLLO and WINDOWSNT cases.  Ignore
 	embedded colons and be strict about drive specs.
	(Fcopy_file) [DOS_NT]: Do dev/inode check on NT.
	(Ffile_name_absolute_p) [DOS_NT]: Be strict about drive specs.
	(check_executable) [DOS_NT]: Test st_mode on NT.
	(Ffile_readable_p) [DOS_NT]: Use access instead of open on NT.
	(Ffile_modes) [DOS_NT]: Don't embelish st_mode value on NT.
	(Fread_file_name) [DOS_NT]: Correct dir seps in HOME.
	(syms_of_fileio): Add Vdirectory_sep_char.

